-*- coding: utf-8 -*-

commit 724a0711752f35478dbccdafbb6718687d983d32
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-23 19:23:26 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-04-23 19:23:26 +0900

    Bump up 3.0.7

commit 14510521720231dd9f07d949c86c9df9c52b205b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-23 19:23:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-04-23 19:23:09 +0900

    merge revision(s) 989a2355808a63fc45367785c82ffd46d18c900a:

            Fix Use-After-Free issue for Regexp

            Co-authored-by: Isaac Peka <7493006+isaac-peka@users.noreply.github.com>
            ---
             regexec.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 6c6dca749d3f732b7be04bae20095a040c50fdb8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-23 19:22:22 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-04-23 19:22:22 +0900

    merge revision(s) 33e5b47c16f1fd3382186e6ffe73cfc6e00946f7:

            Fix handling of reg->dmin in Regex matching

            ---
             regexec.c | 10 ++++++++++
             1 file changed, 10 insertions(+)

commit bd9424c71c15896a997d5a092bf5e1ed453defa6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-03-21 15:55:48 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-04-23 16:03:15 +0900

    Merge StringIO 3.0.1.1

commit 7957a25edf844c966de45848fa7e9e2513955660
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-03-21 15:47:40 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-04-23 16:02:50 +0900

    Merge RDoc-6.3.4.1

commit 5aca51d32c0a561e32d848d78a76eecb60644459
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-10-15 23:55:25 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:57 +0900

    No longer download zlib source

    Although zlib package in vcpkg is still 1.2.12, it should be no
    problem in ruby tests.

commit ecf9b15c71cff8a2f3d15cf096af314dd9ec087f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-01-13 17:44:09 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:57 +0900

    [MSWin] Install libffi using vcpkg

commit d2dc49d89f92817cad42777749629cceef9de8f0
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-12 16:16:21 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:57 +0900

    We didn't invoke leaked-globals at ruby_3_0

commit c86a8529d05d5817611cbebd2798ded374fe9303
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-12 16:11:38 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:57 +0900

    openssl of Ruby 3.0 couldn't build with c2x compiler

commit 2d8337b002b0949dccd9e42528522f1a0dbb8c03
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-12 16:02:29 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:57 +0900

    coroutine=pthread is not working with Ruby 3.0

commit f95abc3cecc86c9dbb476ab61f7545e141686430
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-12-29 21:00:02 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:57 +0900

    Canonicalization functions were removed already

    At b958e2add835d62c0a62edaf9a23ecbbd70a3635

commit 682d7e31940a7282698794a4388681debc336e03
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-12-27 14:58:00 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:57 +0900

    Ignore symbols declared in the platform header

commit 3fdc8e904b78708d191cb9217c22d34dbdd73bf8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-12-27 14:05:24 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:57 +0900

    Ignore objects from the "missing" directory

commit 10b30c7d126594d0a68870ad86cd4a517354a078
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-12-26 21:47:57 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:57 +0900

    Get rid of \K for old BASERUBYs which have a bug in String#scan

commit 984ff9c6d65f60107c9510eba5491489357b5e71
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-12-26 21:46:27 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:57 +0900

    Exclude entry points

commit cbe3a9160ed56bbc6ae12dd5980d17841c0c3b8c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-12-26 00:53:51 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:57 +0900

    Support AC_FUNC_MEMCMP

commit 3b9012ecdb897177f1b785f8267ecd842062ea9c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-12 15:49:56 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:57 +0900

    Backport compilers.yml from ruby_3_1

commit 2676046c5851f57d6d85126ca609e3baf92f3419
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-12 15:44:52 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2024-04-15 14:05:57 +0900

    Don't upgrade brew packages

commit 4a8d7246d15b2054eacb20f8ab3d29d39a3e7856
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-08-22 10:25:14 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-08-22 10:25:14 +0900

    zlib 1.2.13 is gone from zlib.net

commit 616926b55e306a0704254a7ddfd6e9834d06c7f2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-06-29 22:25:17 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-06-29 22:25:17 +0900

    CVE-2023-36617 for Ruby 3.0 (#7997)

    * Merge URI-0.10.3

    * Merge URI-0.10.0.3 for Bundler

commit 78d118dcf7849a2896c4c69f3a28f1fc8a657e3a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-06-16 02:38:17 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-06-16 02:38:17 +0900

    Fix test-bundled-gems for Ruby 3.0 (#7936)

    * pry is not needed for test-bundled-gems

    * Run test-unit test without rake task to avoid yard dependency

    * Use power_assert-1.2.1 to avoid pry dependency

commit 23a532679b406cb53c0edfc00c91c32a5ccd335a
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-03-30 21:41:03 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-03-30 21:41:03 +0900

    Fix previous commit

commit 4ec0bac2d9bd29541442709e6c2b62dee688c1ac
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-03-30 20:10:01 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-03-30 20:10:01 +0900

    Limit header length

commit b427e3570d16c7b68cfa0e5e05be84ba8e3eac36
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2023-03-30 19:59:19 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-03-30 19:59:19 +0900

    [Backport #19161] merge part of 96d1acfdf6c6b42f2029f44d5b5920961d6efa92

    Check for TLS usability

    On all platforms using GCC, even other than darwin.

commit 53a7cee6850bd0d5999fcb56471f0a507222f486
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-03-29 13:29:08 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-03-30 19:49:08 +0900

    Merge Time-0.1.1

commit 2d99ef4f74e13de352ffd867ffe7308f78d7418e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-03-29 14:54:14 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-03-29 14:54:14 +0900

    Merge URI-0.10.2 for Ruby 3.0 (#7607)

    * Merge URI-0.10.2

    * Merge URI-0.10.0.2 for bundler

    * Added assert_linear_performance for URI tests

commit 998fe8ace4621b7337fcd88c78eec02588d0bc57
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-03-26 23:10:50 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-03-29 10:57:57 +0900

    Historical timezones of Lisbon in tzdata are unstable

commit 4527440b5242b7e26cce2500177e989853d7fb16
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-03-26 15:23:10 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-03-29 10:57:57 +0900

    Skip test_europe_lisbon on macOS

    until we figure out why it's failing.

commit 78c2e2827ef8a87da801a612b7a9418db703b2d6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-02-03 15:55:33 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-03-29 10:57:57 +0900

    Bump up CodeQL v2

commit 408d2dbede5da0063da0cc71007bf897991e6ca1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-02-03 15:41:16 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-03-29 10:57:57 +0900

    Skip test-bundler-prallel with macOS. It mixed system bundler path.

      https://github.com/ruby/ruby/actions/runs/4061314416/jobs/7033111867

commit 57703ba1ec421c938181f49e8127c6e4ae83c281
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-01-06 09:58:25 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-03-29 10:57:57 +0900

    Pin Ubuntu 20.04 because Ruby 3.0 didn't support OpenSSL 3

commit 6ca5d3cfed45a8c42f6dbf8126e509792576cbe1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-01-06 09:36:07 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-03-29 10:57:57 +0900

    Ruby 3.0 only supports `--jit-*` options

commit 9cb6b7d14571c93c5ddb4c5fbf18908b6f756b04
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-11-28 06:32:39 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-03-29 10:57:57 +0900

    Disable test-all on MJIT CI for now

    https://github.com/ruby/ruby/actions/runs/3560006749/jobs/5979749144

commit 54d0a2af33c7a43ad3bc7d54da8a68d0d31e1c0a
  Author:     卜部昌平 <shyouhei@ruby-lang.org>
  AuthorDate: 2021-10-22 11:15:10 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-03-29 10:57:57 +0900

    .github: use GNUMAKEFLAGS instead of JOBS

    A bit readable to me.
    See also https://github.com/ruby/ruby/pull/4880

commit fcab8cf702a529301568aa605774ebb470febe97
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-11-28 06:12:29 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-03-29 10:57:57 +0900

    Test only --mjit-wait for now

    We've disabled MJIT CI on GitHub Actions for a while. It's convenient
    that fork repositories need to see failures or disable it.

    We should remove unused CI by default instead of silently disabling it.
    Since I saw --mjit-wait passed on my fork, I'd like to try running
    --mjit-wait one.

commit d8b1279d3bf4c80ad461ed393e6e4839f3f6e1ca
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2021-12-14 09:08:01 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-03-29 10:57:57 +0900

    Rename --jit to --mjit (#5248)

    * Rename --jit to --mjit

    [Feature #18349]

    * Fix a few more --jit references

    * Fix MJIT Actions

    * More s/jit/mjit/ and re-introduce --disable-jit

    * Update NEWS.md

    * Fix test_bug_reporter_add

commit 72beb9f868880a97c769d38b9aab99201300ece8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-10-15 01:03:47 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2023-02-07 17:26:37 +0900

    Remove wrong dollar

commit a0a99185577794b1915eba0dc5154f09cc95e81d
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2022-12-08 12:31:20 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-12-08 12:31:20 +0900

    merge revision(s) 58cc3c9f: [Backport #19187]

            [Bug #19187] Fix for tzdata-2022g

            ---
             test/ruby/test_time_tz.rb | 21 +++++++++++++++------
             1 file changed, 15 insertions(+), 6 deletions(-)

commit 9de654cb74daaa8918ca6b04fbce211c3ccd4209
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2022-12-08 12:30:36 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-12-08 12:30:36 +0900

    Bump teeny

commit ba5cf0f7c52d4d35cc6a173c89eda98ceffa2dcf
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2022-09-08 23:00:01 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-11-24 20:04:56 +0900

    Merge openssl-2.2.2

    The changes can be found at:

      https://github.com/ruby/openssl/compare/v2.2.1...v2.2.2

commit 5fb3cf463c2d78a161fba6a4486bd48e0cbd96c9
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-03-09 16:29:50 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-11-24 20:01:26 +0900

    Keep GC disabled until VM bootstrap has done [Bug #17583]

commit bdb8980f01fb119074ccb8c82447cd0dd061d640
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-20 20:30:28 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-11-24 11:21:28 +0900

    merge revision(s) 4f1e0bfacd93c28bff549e2f3603c3b4942429a3:

            Followed up CVE-2022-39253 for bundler examples

            ---
             spec/bundler/cache/git_spec.rb           | 3 +++
             spec/bundler/install/gemfile/git_spec.rb | 9 +++++++++
             spec/bundler/update/git_spec.rb          | 3 +++
             3 files changed, 15 insertions(+)

commit 3b231086cb3e4347ec025aed3a5c10f9e577bef5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-22 20:55:17 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-11-24 11:21:28 +0900

    merge revision(s) 36f297e62108072b9377d927321928b994f66a93:

            Use valid tokens as cookie names

            ---
             spec/ruby/library/cgi/cookie/name_spec.rb  | 12 ++++++------
             spec/ruby/library/cgi/cookie/parse_spec.rb | 10 +++++-----
             2 files changed, 11 insertions(+), 11 deletions(-)

commit 3ff3855be22543b78ddf789f520414eaee912f0d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-20 20:30:06 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-11-24 11:21:28 +0900

    merge revision(s) dae843f6b7502f921a7e66f39e3714a39d860181,86096a91d55f72620e0f8ca8634da5fa342dc35b:

            Bypass git submodule add/update with git config
             protocol.file.allow=always option.

            Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
            ---
             test/rubygems/test_gem_source_git.rb | 5 +++++
             1 file changed, 5 insertions(+)

            [rubygems/rubygems] Use [] instead of double-quotes

            ---
             test/rubygems/test_gem_source_git.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit cbe2c0cd0908981dde1a1289403ac8468e3e06b9
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-11-22 13:49:18 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-11-24 11:21:28 +0900

    Merge CGI-0.2.2

commit 6ea1a4771d0fed63f3374fa799c038967b6c1f7b
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-10-14 08:28:16 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-10-15 23:09:20 +0900

    Upgrade zlib_version on AppVeyor

    They removed https://zlib.net/zlib1212.zip because
    https://zlib.net/zlib1213.zip was released :thinking_face:

    Fix CI failures like:
    https://ci.appveyor.com/project/ruby/ruby/builds/45064876/job/bb9biogolh0u2595

commit 1407149f7bf10168375a1fc40d6748fcfd4616e4
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-10-15 12:56:38 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-10-15 23:09:20 +0900

    Update zlib version

commit 7f2c548255c2e9cf5c7089823153a8a06940f174
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2022-09-24 03:36:04 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-10-01 15:58:25 +0900

    Initialize Objective-C classes before fork() for macOS 13

    Since macOS 13, CFString family API used in
    `rb_str_append_normalized_ospath` may internally use Objective-C classes
    (`NSTaggedPointerString` and `NSPlaceholderMutableString`) for small strings.

    On the other hand, Objective-C classes should not be used for the first
    time in a `fork()`'ed but not `exec()`'ed process. Violations for this rule
    can result deadlock during class initialization, so Objective-C runtime
    conservatively crashes on such cases by default.

    Therefore, we need to use CFString API to initialize Objective-C classes
    used internally *before* `fork()`.

    For more details, see https://bugs.ruby-lang.org/issues/18912

commit 2ae567acab101b4b89522084898fdae0302bb527
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-09-17 12:09:34 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-10-01 15:58:25 +0900

    [Bug #19005] dynamic_lookup linker option in external libraries

    The warning against `-undefined dynamic_lookup` is just a warning yet,
    and many gems seem to pay no attention to warnings.  Until it fails
    actually, keep it as a migration path, except for standard extension
    libraries and bundled extension gems.

commit 45c2fd9e3e93b88f84cb559d3bdc3a3b9f62f0b3
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-09-13 23:56:34 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-10-01 15:58:25 +0900

    -undefined dynamic_lookup is obsolete

commit 15615566931d645f19cb65d859fd113abab29204
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-08-17 00:45:27 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-09-20 16:50:02 +0900

    The tzdata 2022c removed Amsterdam Mean Time

commit 7900a9bd388cff65ba98e4fa09b296eb1f4f815e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-08-29 17:42:49 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-09-16 15:12:47 +0900

    Backport https://github.com/ruby/ruby/pull/6193

    Co-authored-by: Yuta Saito <kateinoigakukun@gmail.com>

commit 9733f4d0f00a38b5f77ee2e2fffdff866828cd66
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2022-07-25 20:39:12 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-07-25 20:39:12 +0900

    merge revision(s) edf01d4e82d8e44ee30ec41fbcb7f802bc8b8c5d: [Backport #18772]

            Treat NULL fake string as an empty string

            And the NULL string must be of size 0.
            ---
             string.c | 5 +++++
             1 file changed, 5 insertions(+)

commit 6ac4449fce6257ffe653a743880cead2e43167e8
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2022-06-18 23:00:21 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-06-18 23:00:21 +0900

    merge revision(s) 7f81f335478a3ca873f34e3bc0af6927819d3e84: [Backport #18734]

            Return `false` where sticky-bit is not provided [Bug #18734]

            ---
             file.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 28b238f2cbcbf9993c4ce8031cbe19bd2accbfbf
  Author:     U.Nakamura <usa@ruby-lang.org>
  AuthorDate: 2022-06-18 22:54:12 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2022-06-18 22:54:12 +0900

    merge revision(s): a0040af6715d85f416f1282588974e151a8164eb

            [Win32] Fix mode of character/pipe device stat [Bug #18732]

commit 3fa771ddedac25560be57f4055f1767e6c810f58
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-04-12 20:08:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-04-12 20:48:55 +0900

    Fix dtoa buffer overrun

commit 052ec6d2585c3ace95671013d336f5543624ef3d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-04-12 20:07:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-04-12 20:48:55 +0900

    Just free compiled pattern if no space is used

commit a6d990892c1d5496468bbacdd4cba99e8f0bd675
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2022-01-25 20:48:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-04-12 14:07:25 +0900

    Fix spec to not touch the network

    And not depend on the state of rack's master branch, in particular, on
    their Ruby support range.

commit 5758c6487de1cdc6df33dfabdd59de23d3fd55f4
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-01-31 09:42:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-04-12 14:07:25 +0900

    Expect to receive a non-keywords hash

    `RSpec::Mocks::ArgumentListMatcher#args_match?` fails when a
    non-keywords hash is passed while a keyword hash is expected.

    This is a change in `rspec-mocks` 3.10.3, so we need to adapt to it.

commit cdec8a29c5e2e3fedc2e7726d409121d5e2890da
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-04-11 19:45:59 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-04-12 14:07:25 +0900

    Merge Bundler-2.2.33

commit 48be8051ef26dd93e714846d94a2c3794c5b101b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-04-11 19:45:23 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-04-12 14:07:25 +0900

    Merge RubyGems-3.2.33

commit e73165c4cd3876435040100b8acab6ffc84f8fa8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-04-02 14:24:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-04-02 14:24:20 +0900

    merge revision(s) 035b75c8f4097a48cde3cebc5db5e2efddc21546:

            Update zlib version to 1.2.12

            ---
             .appveyor.yml | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 74b42fe78154ff5e5a63342b17d005d6c4fa7761
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-04-02 14:20:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-04-02 14:20:08 +0900

    remove bundled zlib patch file for mswin platform. It's already applied at zlib-1.2.12.

commit b364e23d76ccc232c06cc691b467f17e303caa67
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-04-02 14:16:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-04-02 14:16:13 +0900

    remove bundled zlib patch file for mswin platform. It's already applied at zlib-1.2.12.

commit 6a022fb22dac7dcc9d68e339230f8b3cc2749842
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-04-02 14:08:11 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-04-02 14:08:11 +0900

    rename filepath in patch for zlib.

commit 2802f0628c67fd09890fd269c1ce818322455264
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-04-02 14:03:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-04-02 14:03:37 +0900

    rename bundled zlib patch file for mswin platform.

commit 5fafd801fb2db9206097e352bbed02b1055e205a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-04-02 13:58:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-04-02 13:58:13 +0900

    bundle zlib-1.2.12 instead of 1.2.11.

commit a72b7b898c69a116d754d599e8bb061761015255
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-21 16:23:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-21 16:52:05 +0900

    merge revision(s) d0d6227a0da5925acf946a09191f172daf53baf2,fff1edf23ba28267bf57097c269f7fa87530e3fa: [Backport #17529]

            alen should be actions number on ractor_select()

            alen was number of rs, but it should be actions number
            (taking ractors + receiving + yielding).
            ---
             ractor.c | 13 ++++++-------
             1 file changed, 6 insertions(+), 7 deletions(-)

            fix Ractor.yield(obj, move: true)

            Ractor.yield(obj, move: true) and
            Ractor.select(..., yield_value: obj, move: true) tried to yield a
            value with move semantices, but if the trial is faild, the obj
            should not become a moved object.

            To keep this rule, `wait_moving` wait status is introduced.

            New yield/take process:
            (1) If a ractor tried to yield (move:true), make taking racotr's
                wait status `wait_moving` and make a moved object by
                `ractor_move(obj)` and wakeup taking ractor.
            (2) If a ractor tried to take a message from a ractor waiting fo
                yielding (move:true), wakeup the ractor and wait for (1).
            ---
             bootstraptest/test_ractor.rb | 25 +++++++++++++++
             ractor.c                     | 73 +++++++++++++++++++++++++++++++++++---------
             ractor_core.h                |  1 +
             3 files changed, 84 insertions(+), 15 deletions(-)

commit 1ea12cf590603dbc800314c98099eca9eeca1128
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-21 16:46:58 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-21 16:46:58 +0900

    update common.mk dependency to follow up the previous commit.

commit 1a1701c0c3d86c35019f2edf23c35ec6110d1bac
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-21 16:32:26 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-21 16:32:26 +0900

    class.c: include gc.h to suppress 'implicit declaration of function' on some environments.

commit e0146e6cc8f3578b02ad5f228f86bf1aef566d16
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-21 15:35:07 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-21 15:35:07 +0900

    merge revision(s) 97426e15d721119738a548ecfa7232b1d027cd34: [Backport #18627]

            [Bug #18627] Fix crash when including module

            During lazy sweeping, the iclass could be a dead object that has not yet
            been swept. However, the chain of superclasses of the iclass could
            already have been swept (and become a new object), which would cause a
            crash when trying to read the object.
            ---
             class.c | 48 ++++++++++++++++++++++++++++++------------------
             1 file changed, 30 insertions(+), 18 deletions(-)

commit f404b21f849af06fb8bbd4b87fdfb585e904d6c3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-13 15:42:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-13 15:42:14 +0900

    merge revision(s) 496591de96b261b8789332c7f8b2bfbd17658955: [Backport #18578]

            st.c: Do not clear entries_bound when calling Hash#shift for empty
             hash

            tab->entries_bound is used to check if the bins are full in
            rebuild_table_if_necessary.

            Hash#shift against an empty hash assigned 0 to tab->entries_bound, but
            didn't clear the bins. Thus, the table is not rebuilt even when the bins
            are full. Attempting to add a new element into full-bin hash gets stuck.

            This change stops clearing tab->entries_bound in Hash#shift.
            [Bug #18578]
            ---
             st.c                   |  1 -
             test/ruby/test_hash.rb | 13 +++++++++++++
             2 files changed, 13 insertions(+), 1 deletion(-)

commit 2bb5fa495bf9d366d3c1fefc6b093dc4830f27bf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-13 15:20:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-13 15:20:35 +0900

    merge revision(s) 29f6f79e7396018962eb25c5f5e409f5fe28a73b: [Backport #17788] [Backport #18574]

            Get `ruby_nonempty_memcpy` to have C linkage

            Fixes [Bug #17788]
            ---
             include/ruby/internal/memory.h | 2 ++
             1 file changed, 2 insertions(+)

commit 0bd3e436e27c048933133bc19f863c954ed3e3a6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-13 15:16:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-13 15:16:29 +0900

    merge revision(s) c79d2e54748f52c5023b0a1ee441561df9826c17: [Backport #18562]

            Fix TAG_THROW through require [Bug #18562]

            Previously this was being incorrectly swapped with TAG_RAISE in the next
            line. This would end up checking the T_IMEMO throw_data to the exception
            handling (which calls Module#===). This happened to not break existing
            tests because Module#=== returned false when klass is NULL.

            This commit handles throw from require correctly by jumping to the tag
            retaining the TAG_THROW state.
            ---
             load.c                      |  2 +-
             test/ruby/test_exception.rb | 21 +++++++++++++++++++++
             2 files changed, 22 insertions(+), 1 deletion(-)

commit f4f0c793f6eb427b0a85445bff49fdc6b73447ae
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-13 15:10:34 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-13 15:10:34 +0900

    merge revision(s) b555e659c4974acc423083b71b1bd5ec6a926046: [Backport #18388]

            Do not use `fcopyfile` if appending to non-empty file [Bug #18388]

            `fcopyfile` appends `src` to `to` and then truncates `to` to it's
            original size.
            ---
             io.c                 |  7 +++++++
             test/ruby/test_io.rb | 12 ++++++++++++
             2 files changed, 19 insertions(+)

commit 6175823bab28b5d12f66371d67d006df37751fbc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-13 11:52:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-13 11:52:53 +0900

    merge revision(s) 7ff1bf317887c0d7b21e91ad548d07b9f05c540c,e89d80702bd98a8276243a7fcaa2a158b3bfb659: [Backport #18516]

            An alias can suppress method redefinition warning

            ---
             test/ruby/test_alias.rb | 11 +++++++++++
             1 file changed, 11 insertions(+)

            Fix memory leak at the same named alias [Bug #18516]

            When aliasing a method to the same name method, set a separate bit
            flag on that method definition, instead of the reference count
            increment.  Although this kind of alias has no actual effect at
            runtime, is used as the hack to suppress the method re-definition
            warning.
            ---
             method.h                |  1 +
             test/ruby/test_alias.rb | 18 ++++++++++++++++++
             vm_method.c             |  9 ++++++++-
             3 files changed, 27 insertions(+), 1 deletion(-)

commit 9c2213f6695a16917dbe7b5a3a334116d6d8bbf6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-13 11:49:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-13 11:49:15 +0900

    merge revision(s) 6a6227e0168b059c3ed34c9f0ace2e5dc2364221: [Backport #18517]

            Shifting zero always results in zero [Bug #18517]

            ---
             numeric.c | 2 ++
             1 file changed, 2 insertions(+)

commit 6a8c166498b856ca1dcb53248f0be5fc138f1af3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-13 11:47:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-13 11:47:39 +0900

    merge revision(s) 5c7af72304d0ad33cd3f21b24a4bc44e8acd5b2c,d650b17686d49c2ce8e6a87039861154e93d4621: [Backport #18497]

            Assuming EXIT_SUCCESS equals 0 is not portable

            ---
             test/ruby/test_fiber.rb | 6 +++---
             1 file changed, 3 insertions(+), 3 deletions(-)

            `rb_fiber_terminate` must not return [Bug #18497]

            In a forked process from a fiber, the fiber becomes the only
            fiber, `fiber_switch` does nothing as there is no other fibers,
            `rb_fiber_terminate` does not terminate the fiber.  In that case,
            reaches the end of `fiber_entry` finaly, which is declared as
            "COROUTINE" and should never return.
            ---
             cont.c                     |  3 ++-
             eval_intern.h              |  2 +-
             test/fiber/test_process.rb | 15 +++++++++++++++
             test/ruby/test_fiber.rb    |  5 +++++
             4 files changed, 23 insertions(+), 2 deletions(-)

commit 42b1e87ba7856f92973924985a63a60b5fa750c8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-13 11:37:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-13 11:37:03 +0900

    merge revision(s) ae5458f228a5477383e9c00425d85d50a3867817: [Backport #18475]

            thread.c: Convert TAG_BREAK to a normal exception at thread top-level

            [Bug #18475]
            ---
             test/ruby/test_enum.rb | 11 +++++++++++
             thread.c               |  3 +++
             2 files changed, 14 insertions(+)

commit e18e6af604786be481115c7340c1450332615b57
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-12 16:53:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-12 16:53:37 +0900

    merge revision(s) 9e0a91d0640600f2dfd7fc1d5fae6667019c9ca5: [Backport #18458]

            Don't segfault if Warning.warn is undefined

            Check that there is a method entry for the method before passing
            it to rb_method_entry_arity.

            Fixes [Bug #18458]
            ---
             error.c                     | 3 ++-
             test/ruby/test_exception.rb | 8 ++++++++
             2 files changed, 10 insertions(+), 1 deletion(-)

commit bac99c5175bf58815846f9987093a6d944d07fd3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-12 16:36:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-12 16:36:40 +0900

    merge revision(s) bcc2bb28b04054106f4a36e8fd69b2af6ecb033a: [Backport #18500]

            Fix stack buffer overflow

            https://hackerone.com/reports/1306859
            ---
             include/ruby/internal/memory.h | 6 +++---
             random.c                       | 7 ++-----
             2 files changed, 5 insertions(+), 8 deletions(-)

commit 7c0537906314f0c2a317b37661ccdec8dddc6277
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-12 16:30:52 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-12 16:30:52 +0900

    merge revision(s) fdf39963490cf2cf95b30d91bb9b35964c2c2350: [Backport #18421]

            Empty and return the buffer if zero size is given [Bug #18421]

            In `IO#readpartial` and `IO#read_nonblock`, as well as `IO#read`.
            ---
             io.c                 |  8 ++++++--
             test/ruby/test_io.rb | 21 +++++++++++++++++++++
             2 files changed, 27 insertions(+), 2 deletions(-)

commit f2d996dcff56057b48ae41ab6f23e7654848ea4b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-12 16:28:26 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-12 16:28:26 +0900

    merge revision(s) d6c5a30cfdf658280338dbb8c8b17fab3190b928,a2d4e1cda68a49980a4f9f353f400efbde7e7884: [Backport #18392]

            ObjectSpace::WeakMap#inspect: check if living object [Bug #18392]

            ---
             gc.c                      | 29 +++++++++++++++++++++++------
             test/ruby/test_weakmap.rb |  9 +++++++++
             2 files changed, 32 insertions(+), 6 deletions(-)

            Fixed the check order in wmap_live_p [Bug #18392]

            Check if the object is a pointer to heap before check the flag in
            that object.
            ---
             gc.c | 35 ++++++++++++++++++++++-------------
             1 file changed, 22 insertions(+), 13 deletions(-)

commit 09b27ec6a984ec1b660d5b7b48f2ff4d5a0065bc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-12 16:01:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-12 16:01:47 +0900

    merge revision(s) 737e4432b978eb4b9f5b10fb6cc6d9c883a5d17a: [Backport #18409]

            configure: add -Wl,--no-as-needed

            It is reported that combination of `--enable-shared --with-jemalloc`
            breaks on Debian bullseye (testig).  Deeper investigation revealed that
            this system's `ld(1)` is patched, to turn `ld --as-needed` on by
            default.

            This linker flag strips "unnecessary" library dependencies from an
            executable.  In case of `ruby(1)` (of `--enable-shared`), because
            everything is in `libruby.so`, the binary itself doesn't include any
            calls to `malloc(3)` at all.  So in spite of our explicit `-ljemalloc`
            flag, it is ignored.  Libc's one is chosen instead.

            This is not what we want.  Let's force our `ruby(1)` link what we want.

            Fixes https://github.com/ruby/ruby/pull/4627

            The author would like to acknowledge
            Akihiko Odaki <akihiko.odaki@gmail.com> for their contributions.
            ---
             configure.ac | 5 +++++
             1 file changed, 5 insertions(+)

commit 4b1cee1431b44e923611c65a8ec5cc61d4025641
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-12 16:00:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-12 16:00:02 +0900

    merge revision(s) e2ec97c4b823a0b2e0c31e7a6d77b1dcdc0dfada: [Backport #18415]

            [DOC] How to get the longest last match [Bug #18415]

            ---
             string.c | 32 +++++++++++++++++++++++++++++++-
             1 file changed, 31 insertions(+), 1 deletion(-)

commit 3ce60f44b8de3aabb31c37d2afd2a622a64a3e6f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-12 15:58:42 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-12 15:58:42 +0900

    merge revision(s) 0130e17a410d60a10e7041ce98748b8de6946971,32b7dcfb56a417c1d1c354102351fc1825d653bf,79cc566ab4cdf75f125ecf413a27d353a9756c08: [Backport #18394]

            Always enabled read barrier even on GC.compact

            Some objects can survive the GC before compaction, but get collected in
            the second compaction.  This means we could have objects reference
            T_MOVED during "free" in the second, compacting GC.  If that is the
            case, we need to invalidate those "moved" addresses.  Invalidation is
            done via read barrier, so we need to make sure the read barrier is
            active even during `GC.compact`.

            This also means we don't actually need to do one GC before compaction,
            we can just do the compaction and GC in one step.
            ---
             gc.c | 20 +++-----------------
             1 file changed, 3 insertions(+), 17 deletions(-)

            Fix more assumptions about the read barrier

            This is a continuation of 0130e17a410d60a10e7041ce98748b8de6946971.  We
            need to always use the read barrier
            ---
             gc.c | 10 ----------
             1 file changed, 10 deletions(-)

            Make during_compacting flag in GC one bit

            Commit c32218de1ba094223420a4ea017707f48d0009c5 turned during_compacting
            flag to 2 bits to support the case when there is no write barrier. But
            commit 32b7dcfb56a417c1d1c354102351fc1825d653bf changed compaction to
            always enable the write barrier. This commit cleans up some of the
            leftover code.
            ---
             gc.c | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit e413a8ff970fc7692e6c0050a23678605ade884e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-12 15:52:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-12 15:52:46 +0900

    merge revision(s) ecb2ff60507a41c624f59cb9da6a008ab3ec36e1: [Backport #18403]

            intern/select/posix.h: remove unused parameter from rb_fd_dup

            This unused parameter seems to be accidently introduced by https://github.com/ruby/ruby/commit/9e6e39c
            ---
             include/ruby/internal/intern/select/posix.h | 3 +--
             1 file changed, 1 insertion(+), 2 deletions(-)

commit 2ec864d9b7a2c79b5bd9136665aa6f705fa76e53
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-03-12 14:43:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-03-12 14:43:41 +0900

    merge revision(s) 9f0c6f20c58067923864575b60af730d191b8f6c: [Backport #18382]

            [Bug #18382] Fix crash in compaction for
             ObjectSpace.trace_object_allocations

            ObjectSpace.trace_object_allocations can crash when auto-compaction is
            enabled.
            ---
             ext/objspace/object_tracing.c | 3 ++-
             1 file changed, 2 insertions(+), 1 deletion(-)

commit 951e1377c18f84b52fbd3aab048da8536a3bbdb0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-02-19 15:15:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-02-19 15:15:04 +0900

    merge revision(s) c51b92c18deb850d2cea3a7c9020db23b364ab72: [Backport #18358]

            [ruby/zlib] [Bug #18358] Fix crash in zlib when in progress

            When Zlib::Inflate#inflate or Zlib::Deflate#deflate is called
            recursively inside the block, a crash can occur because of an
            use-after-free bug.

            https://github.com/ruby/zlib/commit/50fb8a0338
            ---
             ext/zlib/zlib.c        | 117 ++++++++++++++++++++++++++++++++-----------------
             test/zlib/test_zlib.rb |  10 ++++-
             2 files changed, 85 insertions(+), 42 deletions(-)

commit 49ed412060f48d3b9343b8b90d73e6fcb02b3354
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-02-19 14:36:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-02-19 14:36:41 +0900

    merge revision(s) b3d62a77d928eff01268ca7fa1c1c0966702926d: [Backport #17803]

            [ruby/zlib] Synchronize access to zstream to prevent segfault in
             multithreaded use

            I'm not sure whether this handles all multithreaded use cases,
            but this handles the example that crashes almost immediately
            and does 10,000,000 total deflates using 100 separate threads.

            To prevent the tests from taking forever, the committed test
            for this uses only 10,000 deflates across 10 separate threads,
            which still causes a segfault in the previous implementation
            almost immediately.

            Fixes [Bug #17803]

            https://github.com/ruby/zlib/commit/4b1023b3f2
            ---
             ext/zlib/zlib.c        | 33 ++++++++++++++++++++++++++-
             test/zlib/test_zlib.rb | 61 ++++++++++++++++++++++++++++++++++++++++++++++++++
             2 files changed, 93 insertions(+), 1 deletion(-)

commit 4868d4b439123a7ce2b24770833d2a575b81e3a5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-02-19 14:25:50 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-02-19 14:25:50 +0900

    merge revision(s) fa7a712d460dc904f8a836bb22b54d457d95ba8e:

            Fix -Wundef warnings for HAVE_RB_EXT_RACTOR_SAFE

            * See [Feature #17752]
            ---
             ext/cgi/escape/escape.c  | 2 +-
             ext/monitor/monitor.c    | 2 +-
             ext/racc/cparse/cparse.c | 2 +-
             ext/zlib/zlib.c          | 2 +-
             4 files changed, 4 insertions(+), 4 deletions(-)

commit 5c15cecfbfe61f9d46f45c949829c79cb7f162a9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-02-19 14:19:22 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-02-19 14:19:22 +0900

    merge revision(s) 0c5f8c62766afe4605172800063e63fe36996658: [Backport #10961]

            [ruby/zlib] Resume zstream if available [Bug #10961]

            ---
             ext/zlib/zlib.c | 6 ++++++
             1 file changed, 6 insertions(+)

commit 7cd359261e2427dbed1e721e982043a1ebc2cdbc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-02-13 17:02:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-02-13 17:02:39 +0900

    skip some test using openssl to cease failure on GitHub Actions for MinGW.

commit b61b456391703b530428b96c148c610cee794bce
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-02-13 16:09:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-02-13 16:09:00 +0900

    skip some tests of rdoc temporary.

commit 6c70a32918738a183d65fcca6bb2b4010ed4536a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-02-13 16:05:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-02-13 16:05:27 +0900

    merge revision(s) f18a0b7654d471101b207e7fe553e12a25398e45,77e1b477297a48e285d34b21e8d30ab4b46bf90c,c483aa8394fc26e341666db66938b1d6fc2cbb8e,f2e39e5fed498b51ae914ed42ec51ae578330583,6aaa1c4d09249baae93d5bb7fba585be420c4fee,923b3652247aa17ac99dc45cb1cd0654fa08d976,950c7a12efa19d73bed10d377368a50664cae32c,69ce9e4187589335124077029496ee293d4e9189,ddb87396349fa4699153d5c4c7569c2e0186adfc,09e7a0c4a4fba18e3308e4f8cb4b8b5b52b41d20,298d65b1e4f3019af7fc9b905390b56736f5fd0e,2f3edf28f3a251bac2cf3b47b46b372faac71e8e:

            [ruby/rdoc] Follow-up rubygems

            Use test-unit assertions instead of minitest.

            https://github.com/ruby/rdoc/commit/d6a6209d7f
            ---
             test/rdoc/test_rdoc_rubygems_hook.rb | 18 ++++++++++++------
             1 file changed, 12 insertions(+), 6 deletions(-)

            [ruby/rdoc] Add an alias for test-unit with older versions of
             RubyGems

            https://github.com/ruby/rdoc/commit/b8d68fdd87
            ---
             test/rdoc/test_rdoc_rubygems_hook.rb | 3 +++
             1 file changed, 3 insertions(+)

            [ruby/rdoc] Rwrite test-case for rubygems_hook without Gem::TestCase

            https://github.com/ruby/rdoc/commit/f8d1087ce5
            ---
             test/rdoc/test_rdoc_rubygems_hook.rb | 38 +++++++++++++++++++-----------------
             1 file changed, 20 insertions(+), 18 deletions(-)

            [ruby/rdoc] Update test/rdoc/test_rdoc_rubygems_hook.rb

            https://github.com/ruby/rdoc/commit/fb264c4cc4

            Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
            ---
             test/rdoc/test_rdoc_rubygems_hook.rb | 4 ++++
             1 file changed, 4 insertions(+)

            [ruby/rdoc] Use pend instead of skip

            https://github.com/ruby/rdoc/commit/8460a36d84
            ---
             test/rdoc/test_rdoc_rubygems_hook.rb | 10 +++++-----
             1 file changed, 5 insertions(+), 5 deletions(-)

            Close UserInteraction for tests to fix leaked file descriptors

            ---
             test/rdoc/test_rdoc_rubygems_hook.rb | 2 ++
             1 file changed, 2 insertions(+)

            Make temporary directory under the regular location

            ---
             test/rdoc/test_rdoc_rubygems_hook.rb | 6 ++----
             1 file changed, 2 insertions(+), 4 deletions(-)

            Clear default configurations

            Remove environment variables which can affect the default
            configurations.
            ---
             test/rdoc/test_rdoc_rubygems_hook.rb | 13 +++++++++++++
             1 file changed, 13 insertions(+)

            Clear rdoc options in the global rubygems configuration

            ---
             test/rdoc/test_rdoc_rubygems_hook.rb | 2 ++
             1 file changed, 2 insertions(+)

            Dispose the global rubygems configuration wholely

            ---
             test/rdoc/test_rdoc_rubygems_hook.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            Discard RDOCOPT environment variable to make tests stable

            ---
             test/rdoc/test_rdoc_rubygems_hook.rb | 1 +
             1 file changed, 1 insertion(+)

            [ruby/rdoc] Prefer omit to pend

            These conditions are not temporary, rather platform dependent.

            https://github.com/ruby/rdoc/pull/815#discussion_r654660411

            https://github.com/ruby/rdoc/commit/92545fa250
            ---
             test/rdoc/test_rdoc_rubygems_hook.rb | 10 +++++-----
             1 file changed, 5 insertions(+), 5 deletions(-)

commit 18bd117955479bb0b84d5f5b2d4e4defdb7e7868
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-02-13 14:30:07 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-02-13 14:30:15 +0900

    Revert 207fb8e6d82c5018c958243de8bfaac3fa5ddfb3 partially.

    Bacause the GitHub Actions workflow for MinGW failed on 'where check'

commit 207fb8e6d82c5018c958243de8bfaac3fa5ddfb3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-02-13 14:27:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-02-13 14:27:20 +0900

    merge revision(s) 49cc7709cb762594aa8ea1b98a1fdf41662a5cf6:

            [Actions] mingw - use ruby/setup-ruby@v1 again

            ---
             .github/workflows/mingw.yml | 4 +++-
             1 file changed, 3 insertions(+), 1 deletion(-)

commit 0b45ce2ad03614339e691826c0e65ca3bf2a1970
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-02-13 14:20:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-02-13 14:20:41 +0900

    merge revision(s) 63358581bca80c7a885228ac841b0ae9c4ca11b5:

            Fix weird MinGW failure notifications

            It's been "MinGW / Array", but it will be "MinGW MINGW64 / check" or
            "MinGW UCRT64 / check" by this.
            ---
             .github/workflows/mingw.yml | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 62c2414bd94b895d231a7766d7b0a8b29eb7f80e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-02-13 14:20:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-02-13 14:20:20 +0900

    merge revision(s) e0a5c3d2b71dfad038d7562fdd33f02ffd79232d,7d55f1b6b6b9777a8bd665f6c5ed6a64c7fa2e9b:

            [MinGW] Set job names

            ---
             .github/workflows/mingw.yml | 1 +
             1 file changed, 1 insertion(+)

            [Actions] use windows-2022 for mingw

            MSP-Greg/ruby-setup-ruby@win-ucrt-1
            ---
             .github/workflows/mingw.yml | 9 +++------
             1 file changed, 3 insertions(+), 6 deletions(-)

commit e7f212651ebb500ed07025b94ed64c896d785386
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-02-13 14:11:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-02-13 14:11:35 +0900

    merge revision(s) ec032e86faf9ac128ac51e3394d9b4001a374b38,8acb2a9b4069f55f71a80c747fc7c6bcb686abb7:

            [MinGW] Clear prefix and move the directory to DESTDIR

            Also the destination will be created at the installation.
            ---
             .github/workflows/mingw.yml | 5 ++---
             1 file changed, 2 insertions(+), 3 deletions(-)

            [MinGW] Use autogen

            ---
             .github/workflows/mingw.yml | 10 +++++-----
             1 file changed, 5 insertions(+), 5 deletions(-)

commit ea04e3fff7401cbf0a45f39351c7eb9c9dd6030e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-02-12 16:55:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-02-12 17:12:32 +0900

    Fix bundler test failures.

    These failures are caused by the incompatibility in keyword argument
    treatment in rspec-mocks.
    I fix the expectations in the bundler/rubygems_integration_spec.rb.
    These tests are not touched in the master branch.
    It seems that the following patch also fix the failures.
    But I believe the expectations in these tests are wrong. We should pass a Hash literal explicitly.

    --- a/common.mk
    +++ b/common.mk
    @@ -1365,7 +1365,7 @@ yes-test-bundler-precheck: main
     no-test-bundler-prepare: no-test-bundler-precheck
     yes-test-bundler-prepare: yes-test-bundler-precheck
            $(XRUBY) -C "$(srcdir)" bin/gem install --no-document \
    -               --install-dir .bundle --conservative "rspec:~> 3.8" "rake:~> 13.0" "parallel_tests:~> 2.29"
    +               --install-dir .bundle --conservative "rspec-core:= 3.10.1" "rspec-expectations:= 3.10.1" "rspec-mocks:= 3.10.2" "rake:~> 13.0" "parallel_tests:~> 2.29"

     RSPECOPTS =
     BUNDLER_SPECS =

commit 034872d6a66916fb2859f41d380ce503c84a65e8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-02-12 16:52:38 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2022-02-12 16:52:38 +0900

    merge revision(s) 342e7a094a70d6f90b96262c88177dae32976c85:

            [rubygems/rubygems] Fix spec to not touch the network

            And not depend on the state of rack's master branch, in particular, on
            their Ruby support range.

            https://github.com/rubygems/rubygems/commit/9ea4baffac
            ---
             spec/bundler/commands/remove_spec.rb | 4 +++-
             1 file changed, 3 insertions(+), 1 deletion(-)

commit 545d6820715a48a17d6182128c0db4198dfa76c1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-12-24 17:47:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-12-24 17:47:44 +0900

    merge revision(s) fb4cf204a662a8cd9dafef6f31f2bd0db9129abe,fa0279d947c3962c3f8c32852278d3ebb964cb19: [Backport #17725]

            use me->def instead of me for opt_table

            `vm_opt_method_table` is me=>bop table to manage the optimized
            methods (by specialized instruction). However, `me` can be invalidated
            to invalidate the method cache entry.
            [Bug #17725]

            To solve the issue, use `me-def` instead of `me` which simply copied
            at invalidation timing.

            A test by @jeremyevans https://github.com/ruby/ruby/pull/4376
            ---
             test/ruby/test_method.rb | 15 +++++++++++++++
             vm.c                     | 11 +++++------
             2 files changed, 20 insertions(+), 6 deletions(-)

            should not share same `def` for specialized method

            Because the key of redefine table is `def`, `def` should be
            unique for each optimized method (`alias` is not allowed).
            ---
             array.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 1d29740c1b101db4bd8fc2d05f929a9e37471a0f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-12-24 14:41:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-12-24 14:41:08 +0900

    merge revision(s) 5086c25f6015558877f85c3f1c014780b08fd3ce,3ff0a0b40c2e1fbdad2286f1dafe837f822d0e0d: [Backport #16936]

            Properly exclude test cases.

            Lets consider the following scenario:

            ~~~
            irb(#<Test::Unit::AutoRunner::Runner:0x0000560f68afc3c8>):001:0> p suite
            OpenSSL::TestEC
            => OpenSSL::TestEC

            irb(#<Test::Unit::AutoRunner::Runner:0x0000560f68afc3c8>):002:0> p all_test_methods
            ["test_ECPrivateKey", "test_ECPrivateKey_encrypted", "test_PUBKEY", "test_check_key", "test_derive_key", "test_dh_compute_key", "test_dsa_sign_asn1_FIPS186_3", "test_ec_group", "test_ec_key", "test_ec_point", "test_ec_point_add", "test_ec_point_mul", "test_generate", "test_marshal", "test_sign_verify", "test_sign_verify_raw"]
            =>
            ["test_ECPrivateKey",
             "test_ECPrivateKey_encrypted",
             "test_PUBKEY",
             "test_check_key",
             "test_derive_key",
             "test_dh_compute_key",
             "test_dsa_sign_asn1_FIPS186_3",
             "test_ec_group",
             "test_ec_key",
             "test_ec_point",
             "test_ec_point_add",
             "test_ec_point_mul",
             "test_generate",
             "test_marshal",
             "test_sign_verify",
             "test_sign_verify_raw"]

            irb(#<Test::Unit::AutoRunner::Runner:0x0000560f68afc3c8>):003:0> p filter
            /\A(?=.*)(?!.*(?-mix:(?-mix:memory_leak)|(?-mix:OpenSSL::TestEC.test_check_key)))/
            => /\A(?=.*)(?!.*(?-mix:(?-mix:memory_leak)|(?-mix:OpenSSL::TestEC.test_check_key)))/

            irb(#<Test::Unit::AutoRunner::Runner:0x0000560f68afc3c8>):004:0> method = "test_check_key"
            => "test_check_key"
            ~~~

            The intention here is to exclude the `test_check_key` test case.
            Unfortunately this does not work as expected, because the negative filter
            is never checked:

            ~~~
            irb(#<Test::Unit::AutoRunner::Runner:0x0000560f68afc3c8>):005:0> filter === method
            => true

            irb(#<Test::Unit::AutoRunner::Runner:0x0000560f68afc3c8>):006:0> filter === "#{suite}##{method}"
            => false

            irb(#<Test::Unit::AutoRunner::Runner:0x0000560f68afc3c8>):007:0> filter === method || filter === "#{suite}##{method}"
            => true
            ~~~

            Therefore always filter against the fully qualified method name
            `#{suite}##{method}`, which should provide the expected result.

            However, if plain string filter is used, keep checking also only the
            method name.

            This resolves [Bug #16936].
            ---
             tool/lib/test/unit.rb | 12 +++++++++---
             1 file changed, 9 insertions(+), 3 deletions(-)

            Filter method names only if filtering method name only

            If sole `filter` option doesn't seem including test case name,
            match with method name only.
            And if the filter is a Regexp or String, it never matches method
            name symbols.
            ---
             tool/lib/test/unit.rb | 15 ++++++---------
             1 file changed, 6 insertions(+), 9 deletions(-)

commit 62a33dfa168504f8ee77d493979e66616ebe1da8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-12-24 14:36:45 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-12-24 14:36:45 +0900

    merge revision(s) c6706f15af123bdbb3b39a21903d85c78462d047: [Backport #18241]

            Fix documentation for String#{<<,concat,prepend}

            These methods mutate and return the receiver, they don't create
            and return a new string.

            Fixes [Bug #18241]
            ---
             string.c | 19 ++++++++++---------
             1 file changed, 10 insertions(+), 9 deletions(-)

commit 69272c74a3f675373fc6c6f32b685620da8a85ee
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-12-02 08:05:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-12-02 08:05:08 +0900

    merge revision(s) 9f8a50723f8a84b3e4755b418570148f422d1b28: [Backport #17836]

            Specify -c to emit pch with clang (#4423)

            [Bug #17836]
            ---
             mjit_worker.c | 1 +
             1 file changed, 1 insertion(+)

commit 5c5974dbd00e1e0a827baed5290517208878355d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-12-02 08:03:28 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-12-02 08:03:28 +0900

    merge revision(s) 44d67128a827c65d1a3867c5d8fd190d10aa1dd2:

            test/openssl/test_cipher: skip AES-CCM tests on OpenSSL <= 1.1.1b

            AES CCM mode in OpenSSL <= 1.1.1b was overly strict in the parameters
            assignment order. This has been relaxed by OpenSSL 1.1.1c.

            https://github.com/openssl/openssl/commit/b48e3be947ddc5da6b5a86db8341081c72b9a4ee

            The test case is failing on Ubuntu 18.04 because it still uses the
            initial 1.1.1 release and has the issue:

            http://rubyci.s3.amazonaws.com/graviton2/ruby-master/log/20210316T120003Z.fail.html.gz
            ---
             test/openssl/test_cipher.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 8cfddb68702a1320953c520c77b81176e3269ec7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-11-24 22:25:22 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-24 22:25:22 +0900

    bump teeny version to 3.0.4.

commit 3fb7d2cadc18472ec107b14234933b017a33c14d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-11-24 20:12:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-24 20:12:15 +0900

        Fix integer overflow

        Make use of the check in rb_alloc_tmp_buffer2.

        https://hackerone.com/reports/1328463

        When parsing cookies, only decode the values

        Bump version

        Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
        Co-authored-by: Yusuke Endoh <mame@ruby-lang.org>

commit 02dfd5a7100841f61ba0bc976339d0ad7c76437f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-11-24 19:47:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-24 19:47:36 +0900

    Bump patchlevel.

commit d1e3dd4db16f3306fd9477e029c7e5e281c8b5b3
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-24 13:29:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-24 19:46:22 +0900

    Merge date-3.1.3

commit c2125240cc886c0844efcae8d01e06b291b92aa6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-24 13:29:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-24 19:46:22 +0900

    Merge RubyGems-3.2.32 and Bundler-2.2.32

commit 3ac499555d9f0c5dd94f636a05c5feb4983656fb
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-11-24 19:21:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-24 19:21:54 +0900

    merge revision(s) f367b4ffe739453e87e55f955138b0ce662942b7,31a757a4426f1ac8c479313e01542940386fc2fe,837cbea64b74d464bfbfb10e6c81a8f92c6eee71:

            assert_equal accepts an expected value as the first argument

            ---
             test/psych/test_coder.rb | 30 +++++++++++++++---------------
             1 file changed, 15 insertions(+), 15 deletions(-)

            Make the test pass with the old libyaml

            I have no idea what result is right, but it fails with libyaml 0.1.7
            (bundled with Ubuntu 18.04) anyway.
            ---
             test/psych/test_coder.rb | 6 +++---
             1 file changed, 3 insertions(+), 3 deletions(-)

            test/psych/test_coder.rb: Suppress non-parenthesis warnings

            http://rubyci.s3.amazonaws.com/debian9/ruby-master/log/20210518T093002Z.log.html.gz
            ```
            /home/chkbuild/chkbuild/tmp/build/20210518T093002Z/ruby/test/psych/test_coder.rb:277: warning: ambiguity between regexp and two divisions: wrap regexp in parentheses or add a space after `/' operator
            ```
            ---
             test/psych/test_coder.rb | 6 +++---
             1 file changed, 3 insertions(+), 3 deletions(-)

commit 7b3948750e1b1dd8cb271c0a7377b911bb3b8f1b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-11-24 12:03:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-24 12:03:46 +0900

    merge revision(s) e1b03b0c2b2449a7794f4701bab8b2382eb15116,007e439fe965871c73127928f7244ebb96a86e58:

            Enable VM_ASSERT in --jit CIs (#4543)

            ---
             .github/workflows/mjit.yml | 2 +-
             ractor.c                   | 6 +++---
             vm_core.h                  | 6 +++---
             vm_method.c                | 2 +-
             4 files changed, 8 insertions(+), 8 deletions(-)

            Do not expect ec on rb_vm_bugreport

            because a SEGV might happen on an MJIT worker. As you can clearly see
            from `if (vm && ec) {`, ec is not guaranteed to exist here.
            ---
             vm_dump.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 949af69408e44b69cc7437b58e8edbe3cd77c966
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-11-23 14:26:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-23 14:52:30 +0900

    merge revision(s) 5680c38c75aeb5cbd219aafa8eb48c315f287d97,f5d20411386ff2552ff27661387ddc4bae1ebc30: [Backport #17573]

            Use valid `ec` for postponed job.

            Postponed job can be registered from non-Ruby thread, which means
            `ec` in TLS can be NULL. In this case, use main thread's `ec` instead.

            See https://github.com/ruby/ruby/pull/4108
            and https://github.com/ruby/ruby/pull/4336
            ---
             vm_trace.c | 16 ++++++++++++----
             1 file changed, 12 insertions(+), 4 deletions(-)

            Avoid assert failure when NULL EC is expected

            After 5680c38c75aeb5cbd219aafa8eb48c315f287d97, postponed job APIs now
            expect to be called on native threads not managed by Ruby and handles
            getting a NULL execution context. However, in debug builds the change
            runs into an assertion failure with GET_EC() which asserts that EC is
            non-NULL. Avoid the assertion failure by passing `false` for `expect_ec`
            instead as the intention is to handle when there is no EC.

            Add a test from John Crepezzi and John Hawthorn to exercise this
            situation.

            See GH-4108
            See GH-5094

            [Bug #17573]

            Co-authored-by: John Hawthorn <john@hawthorn.email>
            Co-authored-by: John Crepezzi <john.crepezzi@gmail.com>
            ---
             ext/-test-/postponed_job/postponed_job.c       | 31 ++++++++++++++++++++++++++
             test/-ext-/postponed_job/test_postponed_job.rb |  7 ++++++
             vm_trace.c                                     |  2 +-
             3 files changed, 39 insertions(+), 1 deletion(-)

commit aadb8cad563ca23e54a775d4fee936a07466112f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-11-23 14:20:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-23 14:52:30 +0900

    merge revision(s) e83c02a768af61cd0890a75e90bcae1119d8bd93: [Backport #18289]

            Delegate keywords from Enumerable#to_a to #each

            Fixes [Bug #18289]
            ---
             enum.c                 | 2 +-
             test/ruby/test_enum.rb | 5 +++++
             2 files changed, 6 insertions(+), 1 deletion(-)

commit b6f87d527f59257f07ba6774addaefdedee4fcde
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-11-23 14:19:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-23 14:52:29 +0900

    merge revision(s) 84202963c52e02cecad3e6b2fad478bfbeee1bc7: [Backport #18329]

            [Bug #18329] Fix crash when calling non-existent super method

            The cme is NULL when a method does not exist, so check it before
            accessing the callcache.
            ---
             test/ruby/test_super.rb | 31 +++++++++++++++++++++++++++++++
             vm_insnhelper.c         |  3 ++-
             2 files changed, 33 insertions(+), 1 deletion(-)

commit 5afefe4371b19155fc4d692a5ff2616ad748e9cc
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 20:39:22 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump psych version to 3.3.2

commit 5a6f8462dc00ae453268eb7b42b1d395b9f644f8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 20:14:59 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump racc version to 1.5.2

commit d7c9d86573c6e9244c7d3e29e6d6be7d6545f748
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 19:32:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump resolv version to 0.2.1

commit 6775e9a21b240279dfda889364b50ac9160e7cd6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 18:28:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump strscan version to 3.0.1

commit d9a1f148052c49398975f3f3284d2822e03b92f7
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 18:24:24 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump date version to 3.1.1

commit 8cdb0ebb55ec88ea909b98d3c89e30debedc33b6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 18:20:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump etc version to 1.3.0

commit bfed3296ec81c2ca53e65dc3df5b0e8f1e6810ab
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 18:12:18 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump io-wait version to 0.2.0

commit 4716a8e157044b3a3a490c96957eb6c9204d70f1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 18:06:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump fiddle version to 1.0.8

commit b789399c099b51cd60a07fe686145c451d0a5d4e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 18:01:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump rdoc version to 6.3.3

commit 989540c9ccf89e4e2d837a123858ab420e5c4b6c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 17:34:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump pp version to 0.2.1

commit f86b773b5c46a6f9e7df259913708671cedfd38e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 17:33:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump rinda version to 0.1.1

commit 60d904c4b24df6aa8bac1cfc9d895b0956b37926
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 17:32:59 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump prettyprint version to 0.1.1

commit e6fced73e55dda487f026c929d97542cf1832252
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 17:31:58 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump stringio version to 3.0.1

commit e735773fd4a0f9cbab82134e22d989bf540b744e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 17:16:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump optparse version to 0.1.1

commit b2b66ede714e52b63211bc06996a8a4f237d51e2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 17:12:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump net-protocol version to 0.1.1

commit 8ddad13dcdf60f495fed13bef83016b2db597734
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 16:28:34 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump debug version to 0.2.1

commit c6d9bd75ee4a757618a23eacc6853fa34b091fc5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 16:13:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    pin rbs-1.6.x for test-bundled-gems

commit 905842e122a4c4f150f09e283fec6b004538e2a2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 16:02:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Bump debug version to 0.2.0

commit b19b2e98675a132b4b4a59aa130fd5a9f65d775f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 11:13:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Merge RubyGems 3.2.31 and Bundler 2.2.31

commit e27381d289cbdbdca434bcc957c2cd1beab1c82c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 11:00:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Merge RubyGems 3.2.30 and Bundler 2.2.30

commit e262272b6a50c1a92cdcfee684e82f9242ef8171
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 10:44:07 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Merge RubyGems 3.2.29 and Bundler 2.2.29

commit 24f911f474e11560af5fbd0f637f4c0ded23f604
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 10:41:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Merge RubyGems 3.2.28 and Bundler 2.2.28

commit 31a71048521224774bdb8b5982ab73eb35dad66d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-11 10:40:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-22 10:51:35 +0900

    Merge RubyGems 3.2.27 and Bundler 2.2.27

commit 6d540c1b9844a5832846618b53ce35d12d64deac
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-11-06 17:37:22 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-06 17:37:22 +0900

    merge revision(s) d0a05fd4b40ff0f88728c4897e67b68185128f54:

            Fixed FD leaks

            ---
             test/socket/test_tcp.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 75e74993916e9abda1a74164fed5b59fc3d9b7ce
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-11-06 16:47:07 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-11-06 16:47:07 +0900

    merge revision(s) a4d5ee4f31bf3ff36c1a8c8fe3cda16aa1016b12: [Backport #18264]

            [Bug #18264] Fix memory leak in TracePoint

            TracePoint leaks memory because it allocates a `rb_tp_t` struct
            without ever freeing it (it is created with `RUBY_TYPED_NEVER_FREE`).
            ---
             test/ruby/test_settracefunc.rb | 10 ++++++++++
             vm_trace.c                     |  2 +-
             2 files changed, 11 insertions(+), 1 deletion(-)

commit b1696c87d31d30a64c93d7d4d9c948f383a9da11
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-10-31 13:29:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-31 13:29:01 +0900

    test_gc.rb: relax criterion

commit 5afb947d724f92cf9c94fcbf331c8d530b8ce710
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-10-30 20:54:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-30 20:54:03 +0900

    Bump patchlevel.

commit 519e3bde24ca18489d3327dd369aed815ef84c61
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-10-14 20:59:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-30 20:53:12 +0900

    [ruby/drb] Bump up drb version to 2.0.5

    https://github.com/ruby/drb/commit/7edf67654c

commit f96517ec2b52e68fd425151cb64c3561a6ae854a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-10-14 17:16:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-30 20:53:12 +0900

    [ruby/fcntl] Bump up fcntl version to 1.0.1

    https://github.com/ruby/fcntl/commit/0bcc0c4518

commit e5babb16a1cc7f034e15180df0eeaacd17b29a34
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-10-14 15:55:58 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-30 20:53:12 +0900

    Bump up zlib version to 2.0.0

commit c9bc91bf6934d67bb302cd13961beb6870b05c03
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-10-30 20:23:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-30 20:23:44 +0900

    Bump patchlevel.

commit 00e89fe36b57e2d7c4ea269bc827d9806edef5ed
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2021-09-28 18:03:24 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-30 20:22:06 +0900

    openssl: import v2.2.1

    Bring the local copy of ruby/openssl in sync with the upstream gem
    release v2.2.1. The commits happened in the upstream repository can be
    found at:

            https://github.com/ruby/openssl/compare/v2.2.0...v2.2.1

    Note that many of these have already been applied to ruby.git and don't
    appear in the file changes of this commit.

commit 5427b08381fb0d644ec69d5aa94234f90a4fbed1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-10-16 13:28:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-16 13:28:27 +0900

    merge revision(s) 76228191474c76810043b294a74bbb2f1808b3d9: [Backport #18023]

            Fix Ractor.make_shareable changing locals for Procs

            env_copy() uses rb_ary_delete_at() with a loop counting up while
            iterating through the list of read only locals. rb_ary_delete_at() can
            shift elements in the array to an index lesser than the loop index,
            causing locals to be missed and set to Qfalse in the returned
            environment.

            Iterate through the locals in reverse instead, this way the shifting
            never happens for locals that are yet to be visited and we process all
            the locals in the array.

            [Bug #18023]
            ---
             bootstraptest/test_ractor.rb | 22 ++++++++++++++++++++++
             vm.c                         |  2 +-
             2 files changed, 23 insertions(+), 1 deletion(-)

commit a2fe4b75e4b236ad15778c59ace63006ace53889
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-10-16 13:26:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-16 13:26:47 +0900

    merge revision(s) 217df51f0e5d9824ed712a4d175f555d932e44d8: [Backport #18232]

            Dump outer variables tables when dumping an iseq to binary

            This commit dumps the outer variables table when dumping an iseq to
            binary.  This fixes a case where Ractors aren't able to tell what outer
            variables belong to a lambda after the lambda is loaded via ISeq.load_from_binary

            [Bug #18232] [ruby-core:105504]
            ---
             compile.c              | 55 +++++++++++++++++++++++++++++++++++++++++++++++++-
             test/ruby/test_iseq.rb | 10 +++++++++
             2 files changed, 64 insertions(+), 1 deletion(-)

commit cfad0583eb18bb4505f28ee5cfab703a6b9987be
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-10-09 15:36:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-09 15:36:53 +0900

    merge revision(s) abc0304cb28cb9dcc3476993bc487884c139fd11: [Backport #17507]

            Avoid race condition in Regexp#match

            In certain conditions, Regexp#match could return a MatchData with
            missing captures.  This seems to require at the least, multiple
            threads calling a method that calls the same block/proc/lambda
            which calls Regexp#match.

            The race condition happens because the MatchData is passed from
            indirectly via the backref, and other threads can modify the
            backref.

            Fix the issue by:

            1. Not reusing the existing MatchData from the backref, and always
               allocating a new MatchData.
            2. Passing the MatchData directly to the caller using a VALUE*,
               instead of indirectly through the backref.

            It's likely that variants of this issue exist for other Regexp
            methods.  Anywhere that MatchData is passed implicitly through
            the backref is probably vulnerable to this issue.

            Fixes [Bug #17507]
            ---
             re.c                     | 46 +++++++++++++++++++---------------------------
             test/ruby/test_regexp.rb | 21 +++++++++++++++++++++
             2 files changed, 40 insertions(+), 27 deletions(-)

commit 2c947e74a0a11fe6c54253c15224dc80054c62a2
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-10-09 15:08:38 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-09 15:08:38 +0900

    merge revision(s) 60d0421ca861944459f52292d65dbf0ece26e38a,b6534691a16d751d59fc572d5dddebcaeb21f007,409dbc951b9875d27bd73748c88e15386473cffb,842b0008c132dd587f09766a228041afb7fed24f: [Backport #18191]

            Fix the encoding of loaded feature names [Bug #18191]

            The feature names loaded from the default load paths should also
            be in the file system encoding.
            ---
             ruby.c                    | 12 +++++++++++-
             test/ruby/test_require.rb | 22 ++++++++++++++++++++++
             2 files changed, 33 insertions(+), 1 deletion(-)

            Copy path strings as interned strings

            ---
             ruby.c | 12 ++++++++++--
             1 file changed, 10 insertions(+), 2 deletions(-)

            Replace expanded load path only when modified

            ---
             ruby.c | 6 +++++-
             1 file changed, 5 insertions(+), 1 deletion(-)

            Skip broken strings as the locale encoding

            ---
             internal/string.h |  1 +
             ruby.c            | 11 +++++++----
             string.c          |  6 ++++++
             3 files changed, 14 insertions(+), 4 deletions(-)

commit fe9d33beb78d5c7932a5c2ca3953045c0ae751d5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-10-09 15:05:24 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-09 15:05:24 +0900

    merge revision(s) 89242279e61b023a81c58065c62a82de8829d0b3,529fc204af84f825f98f83c34b004acbaa802615: [Backport #18141]

            Marshal.load: do not call the proc until strings have their encoding

            Ref: https://bugs.ruby-lang.org/issues/18141
            ---
             marshal.c                             |  7 +++-
             spec/ruby/core/marshal/shared/load.rb | 62 +++++++++++++++++++++++------------
             test/ruby/test_marshal.rb             | 17 ++++++++++
             3 files changed, 64 insertions(+), 22 deletions(-)

            marshal.c: don't call the proc with partially initialized objects.
             (#4866)

            For cyclic objects, it requires to keep a st_table of the partially
            initialized objects.
            ---
             marshal.c                             | 75 ++++++++++++++++++++---------------
             spec/ruby/core/marshal/shared/load.rb | 75 ++++++++++++++++++++---------------
             test/ruby/test_marshal.rb             | 12 ++++++
             3 files changed, 97 insertions(+), 65 deletions(-)

commit f192e01233ccd7966721a164e62a86707b4e6d9e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-10-03 16:16:18 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-03 16:16:18 +0900

    merge revision(s) 7c0230b05d0978958f89434c84ddd9c82419c1a5,552728a23aeab0df598b356b19a573259e297d14,49af9012a20a824542cf588e55e5488895553e09: [Backport #18184]

            Check the entire name as `ruby2_keywords_flag` [Bug #18184]

            ---
             marshal.c                 | 2 +-
             test/ruby/test_marshal.rb | 8 +++++++-
             2 files changed, 8 insertions(+), 2 deletions(-)

            Check the encoding of `ruby2_keywords_flag` [Bug #18184]

            ---
             marshal.c                 | 1 +
             test/ruby/test_marshal.rb | 6 +++++-
             2 files changed, 6 insertions(+), 1 deletion(-)

            Prohibit invalid encoding symbols [Bug #18184]

            ---
             marshal.c                 |  8 +++++++-
             test/ruby/test_marshal.rb | 10 +++++++---
             2 files changed, 14 insertions(+), 4 deletions(-)

commit 5341eca588e738cd5031ab7d8bb5c300471c00e9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-10-03 16:10:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-03 16:10:01 +0900

    merge revision(s) ddb32e66160ab50849419ef7c7ac584913b79c34: [Backport #18173]

            [Bug #18173] Update loaded_features_index

            If $LOADED_FEATURES is changed in the just required file, also the
            index table needs to be updated before loaded_features_snapshot is
            reset.  If the snapshot is reset without updating the table, the
            name of the added feature will not be found.
            ---
             load.c                    |  1 +
             test/ruby/test_require.rb | 17 +++++++++++++++++
             2 files changed, 18 insertions(+)

commit efa1ba15fd5007210f819e6d11002ca829c989bf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-10-02 11:22:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-10-02 11:22:19 +0900

    merge revision(s) fa05697e4832fbd67a4f91b9bb362471902faab3: [Backport #18166]

            Use `%printer` directive for Bison 3.8

            ---
             parse.y | 74 ++++++++++++++++++++++++++---------------------------------------
             1 file changed, 29 insertions(+), 45 deletions(-)

commit 8ac058b64577d9b6fb1ee998d0fa7800529d7d34
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2021-07-28 16:55:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-26 20:49:54 +0900

    Fix potential hang when joining threads.

    If the thread termination invokes user code after `th->status` becomes
    `THREAD_KILLED`, and the user unblock function causes that `th->status` to
    become something else (e.g. `THREAD_RUNNING`), threads waiting in
    `thread_join_sleep` will hang forever. We move the unblock function call
    to before the thread status is updated, and allow threads to join as soon
    as `th->value` becomes defined.

    This reverts commit 6505c77501f1924571b2fe620c5c7b31ede0cd22.

commit 7d4a0c4b93cbdf40a9a43c4974199405099a8545
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-06-15 00:03:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-26 20:49:54 +0900

    Suppress exception report in inner thread

commit 24f146bee1780d7fc62be6850b93097819b2a686
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-06-15 00:02:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-26 20:49:54 +0900

    Close leaked file descriptors

commit 5e9ec351044fb74f07f2a45a0dab1e226159b7e6
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2021-06-14 14:56:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-26 20:49:54 +0900

    Wake up join list within thread EC context. (#4471)

    * Wake up join list within thread EC context.

    * Consume items from join list so that they are not re-executed.

    If `rb_fiber_scheduler_unblock` raises an exception, it can result in a
    segfault if `rb_threadptr_join_list_wakeup` is not within a valid EC. This
    change moves `rb_threadptr_join_list_wakeup` into the thread's top level EC
    which initially caused an infinite loop because on exception will retry. We
    explicitly remove items from the thread's join list to avoid this situation.

    * Verify the required scheduler interface.

    * Test several scheduler hooks methods with broken `unblock` implementation.

commit 98ac62de5cb03efec0fb32684c61c0d4df692e5a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-09-18 16:23:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-18 16:23:48 +0900

    merge revision(s) bb84c75001f1bf13b4b2a12db8f4420e76a3ea03: [Backport #17735]

            Revert "Force recycle intermediate collection in Hash#transform_keys!
             [Bug #17735]"

            This reverts commit 522d4cd32f7727886f4fcbc28ed29c08d361ee20.
            ---
             hash.c | 1 -
             1 file changed, 1 deletion(-)

commit 3e61556191ea7e6586ffb995f03e6d2631ec6fb0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-09-18 16:13:38 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-18 16:13:38 +0900

    merge revision(s) 99d8c4832a7133ca52578d015e3ddcfd94820f4a: [Backport #18160]

            Preserve the encoding of the argument in IndexError [Bug #18160]

            ---
             re.c                     | 20 ++++++++++----------
             test/ruby/test_regexp.rb |  7 ++++++-
             2 files changed, 16 insertions(+), 11 deletions(-)

commit 7b55ff21b52e818819b698326f80158643175645
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-09-18 16:11:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-18 16:11:19 +0900

    merge revision(s) 564ccd095a9d7fbe869031dbf666d61dadfdcb03: [Backport #17756]

            [ruby/strscan] Fix segmentation fault of `StringScanner#charpos` when
             `String#byteslice` returns non string value [Bug #17756] (#20)

            https://github.com/ruby/strscan/commit/92961cde2b
            ---
             ext/strscan/strscan.c              |  5 +----
             test/strscan/test_stringscanner.rb | 17 +++++++++++++++++
             2 files changed, 18 insertions(+), 4 deletions(-)

commit e6e25b794d8db52e1df85a02f28846ad7eb82d49
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-09-18 16:07:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-18 16:07:30 +0900

    merge revision(s) 13939d61b4b69bd109c5f41303c79868d639fa44: [Backport #17661]

            Check if closed after each yield [Bug #17661]

            ---
             io.c                 |  4 +++-
             test/ruby/test_io.rb | 36 ++++++++++++++++++++++++++++++++++++
             2 files changed, 39 insertions(+), 1 deletion(-)

commit 650af7d29d98de6a3c2631e31edc6fbe435ece89
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-09-11 14:00:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-11 14:00:44 +0900

    merge revision(s) 5d815542815fe8b939239750bba7f8f0b79c97d6: [Backport #18154]

            [Bug #18154] Fix memory leak in String#initialize

            String#initialize can leak memory when called on a string that is marked
            with STR_NOFREE because it does not unset the STR_NOFREE flag.
            ---
             string.c                 |  2 +-
             test/ruby/test_string.rb | 10 ++++++++++
             2 files changed, 11 insertions(+), 1 deletion(-)

commit 13f64b65e0476c2fe416a29274fcc91e3c0cf5d3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-09-11 13:59:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-11 13:59:43 +0900

    merge revision(s) f336a3eb6c76890f3d8f878725b3d328c8fdcf33: [Backport #18126]

            Use free instead of xfree to free altstack

            The altstack memory of a thread may be free'ed even after the VM is
            destructed. After that, GC is no longer available, so calling xfree
            may lead to a segfault.

            This changeset uses the bare free function to free the altstack memory
            instead of xfree. [Bug #18126]
            ---
             signal.c  | 5 ++++-
             vm_core.h | 2 +-
             2 files changed, 5 insertions(+), 2 deletions(-)

commit 8e4ed4ed00e8346029953c14dd414a996e37a437
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-09-11 13:52:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-11 13:52:43 +0900

    merge revision(s) d795f494a89e0d9498dfedc54b8a98acc2bc4d7b: [Backport #17794]

            Avoid `free(3)`ing invalid pointer

            Fixes [Bug #17794]
            ---
             addr2line.c | 2 ++
             1 file changed, 2 insertions(+)

commit 7b4bc893941b146565c396606effb5f16aa9e88d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-09-05 16:17:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-05 16:17:25 +0900

    merge revision(s) 7d22060c14895bbca3ff962e5456384095b66738: [Backport #17609]

            addr2line.c: DW_LNS_fixed_advance_pc takes a single uhalf operand

            Fixes [Bug #17609]

            Co-Authored-By: xtkoba (Tee KOBAYASHI) <xtkoba+ruby@gmail.com>
            ---
             addr2line.c | 3 ++-
             1 file changed, 2 insertions(+), 1 deletion(-)

commit c42208f8e24402fe1aa8747901fba275bfb0d56b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-09-05 14:55:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-05 14:55:14 +0900

    merge revision(s) c0f4e4ca6d0f76985bca79314b232b787c8f008e: [Backport #18007]

            undefine alloc functions for C extensions

            per guidance in doc/extension.rdoc, these classes now undefine their
            alloc functions:

            - ObjectSpace::InternalObjectWrapper
            - Socket::Ifaddr
            ---
             ext/objspace/objspace.c | 1 +
             ext/socket/ifaddr.c     | 1 +
             2 files changed, 2 insertions(+)

commit 3fb51aec5ba7decffdfc32e540262aaae6167a95
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-09-05 14:12:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-05 14:12:20 +0900

    merge revision(s) bbedd29b6e98ef6e3fc2ce2b358d2b509b7cd1bb: [Backport #18117]

            [Bug #18117] Fix Ractor race condition with GC

            rb_objspace_reachable_objects_from requires that the GC not be active.
            Since the Ractor barrier is not executed for incremental sweeping,
            Ractor may call rb_objspace_reachable_objects_from after sweeping
            has started to share objects. This causes a crash that looks like
            the following:

            ```
            <internal:ractor>:627: [BUG] rb_objspace_reachable_objects_from() is not supported while during_gc == true
            ```

            Co-authored-by: Vinicius Stock <vinicius.stock@shopify.com>
            ---
             bootstraptest/test_ractor.rb | 15 +++++++++++++++
             ractor.c                     | 12 ++++++++++--
             2 files changed, 25 insertions(+), 2 deletions(-)

commit 911e75f0547ae3496280a731fbfd986096b0ffb6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-09-05 13:49:07 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-05 13:49:07 +0900

    add dependency for ext/-test-/array/concat/to_ary_conact.c

commit 92846db6861eed324288819157e6c7722fc62fc2
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-09-05 12:19:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-09-05 12:19:53 +0900

    merge revision(s) cd4f5b13228879d954fa97b6aa479c4a5ef4fb0a,8db269edb3550a85dfab9b193ea115ca36912ced,ab63f6d8543903f177c46634f38e5428655f003b: [Backport #18140]

            Guard array when appending

            This prevents early collection of the array.  The GC doesn't see the
            array on the stack when Ruby is compiled with optimizations enabled

            [ruby-core:105099] [Bug #18140]
            ---
             array.c                 | 1 +
             test/ruby/test_array.rb | 6 ++++++
             2 files changed, 7 insertions(+)

            Guard array when appending

            This prevents early collection of the array.  The GC doesn't see the
            array on the stack when Ruby is compiled with optimizations enabled

            Thanks @jhaberman for the test case

            [ruby-core:105099] [Bug #18140]
            ---
             ext/-test-/array/concat/depend          | 321 ++++++++++++++++++++++++++++++++
             ext/-test-/array/concat/extconf.rb      |   2 +
             ext/-test-/array/concat/to_ary_conact.c |  64 +++++++
             test/-ext-/array/test_to_ary_concat.rb  |  20 ++
             4 files changed, 407 insertions(+)
             create mode 100644 ext/-test-/array/concat/depend
             create mode 100644 ext/-test-/array/concat/extconf.rb
             create mode 100644 ext/-test-/array/concat/to_ary_conact.c
             create mode 100644 test/-ext-/array/test_to_ary_concat.rb

            Refined test [Bug #18140]

            ---
             ext/-test-/array/concat/to_ary_conact.c | 48 +++++++--------------------------
             test/ruby/test_array.rb                 |  5 +++-
             2 files changed, 13 insertions(+), 40 deletions(-)

commit 261a0e0e4a3202ca004eddc3cc2cefc9e8d0a90a
  Author:     Andrew Aladjev <aladjev.andrew@gmail.com>
  AuthorDate: 2021-09-05 11:42:08 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2021-09-05 11:42:08 +0900

    Backport mutexes for socket and connection lists on win32 #4212 (#4218)

    Co-authored-by: nagachika <nagachika@ruby-lang.org>

commit 8899fa0b3d41fd27dd1a2c6f75106cb78ff27236
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-08-29 19:09:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-29 19:09:35 +0900

    merge revision(s) d43279edacd09edf3a43e02d62f5be475e7c3bcb,5dc36ddcd00fc556c04c15ce9770c5a84d7d43dc,523bf31564f160f899f8cf9f73540d6a6f687f17: [Backport #18138]

            Fix length calculation for Array#slice!

            Commit 4f24255 introduced a bug which allows a length to be passed to
            rb_ary_new4 which is too large, resulting in invalid memory access.

            For example:

                (1..1000).to_a.slice!(-2, 1000)
            ---
             array.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            Add out of range tests for Array#slice!

            ---
             test/ruby/test_array.rb | 13 +++++++++++++
             1 file changed, 13 insertions(+)

            Add negative position tests [Bug #18138]

            ---
             test/ruby/test_array.rb | 4 ++++
             1 file changed, 4 insertions(+)

commit 600d0f78395c6a67d6bc8974be9964701976e745
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-08-19 15:47:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-19 15:47:39 +0900

    Bump patchlevel.

commit c758756174958c19c521b7d29ede4deddb214ccb
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2021-08-19 11:33:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-19 15:46:40 +0900

    Bundle RBS 1.4.0 & typeprof 0.15.2 (#4753)

    * Bundle RBS 1.4.0

    * Bundle typeprof 0.15.2

commit 400576304129998d2546462f96b8d0be7393ed06
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2021-08-15 11:59:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-19 15:46:40 +0900

    Update TypeProf to 0.15.1

commit 37f824377fce1bb0fb3ae94f858e2b9417b67b56
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-08-18 19:37:11 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-19 15:46:40 +0900

    Merge RubyGems 3.2.26 and Bundler 2.2.26

commit 41a28637807bef9b15c404c93a778aaa6266ace7
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-08-02 12:07:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-19 15:46:40 +0900

    Merge RubyGems 3.2.25 and Bundler 2.2.25

commit 679185d6c87e0f2e4f6a5da5ce50d02c80ab31b1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-08-02 12:06:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-19 15:46:40 +0900

    Merge RubyGems 3.2.24 and Bundler 2.2.24

commit f1039afa4179f9d3a42f0d89b499e3c955b495d9
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-08-02 12:05:18 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-19 15:46:40 +0900

    Merge RubyGems 3.2.23 and Bundler 2.2.23

commit ca8f73efb31b18fefee1ec25c69143f31ed1aae5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-08-19 15:45:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-19 15:45:53 +0900

    Revert "merge revision(s) 164f50dea918e7019847f578c3cffb079993d626,1985a3a77fac64cda177c74113a9348e36233630:"

    This reverts commit 09d90c0ed861e74e58a59bc413bc39bcf9775db8.

commit 09d90c0ed861e74e58a59bc413bc39bcf9775db8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-08-19 15:08:07 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-19 15:08:07 +0900

    merge revision(s) 164f50dea918e7019847f578c3cffb079993d626,1985a3a77fac64cda177c74113a9348e36233630:

            Update TypeProf to 0.15.1

            ---
             .github/workflows/ubuntu.yml | 2 +-
             gems/bundled_gems            | 2 +-
             2 files changed, 2 insertions(+), 2 deletions(-)

            Bundle RBS 1.4.0 & typeprof 0.15.2 (#4753)

            * Bundle RBS 1.4.0

            * Bundle typeprof 0.15.2
            ---
             gems/bundled_gems | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit 3922394c85b33315483b65eeeac36613deaf0433
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-08-08 13:01:42 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-08 13:01:42 +0900

    Bump patchlevel.

commit c07545bbf82068f4fd92a5ccfa2b09bb96b39adb
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2021-08-07 00:07:56 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-08 12:59:45 +0900

    Fix multiple bugs in partial backtrace optimization

    This fixes multiple bugs found in the partial backtrace
    optimization added in 3b24b79.
    These bugs occurs when passing a start argument to caller where
    the start argument lands on a iseq frame without a pc.

    Before this commit, the following code results in the same
    line being printed twice, both for the #each method.

    ```
    def a; [1].group_by { b } end
    def b; puts(caller(2, 1).first, caller(3, 1).first) end
    a
    ```

    After this commit and in Ruby 2.7, the lines are different,
    with the first line being for each and the second for group_by.

    Before this commit, the following code can either segfault or
    result in an infinite loop:

    ```
    def foo
      caller_locations(2, 1).inspect # segfault
      caller_locations(2, 1)[0].path # infinite loop
    end

    1.times.map { 1.times.map { foo } }
    ```

    After this commit, this code works correctly.

    In terms of the implementation, this correctly skips iseq frames
    without pc that occur before the number of frames the caller
    requested to skip.

    This rewrites the algorithm used for handling the partial
    backtraces.  It scans from the current frame outward to the
    earliest frame, until it has found the desired number of frames.
    It records that frame as the start frame.  If needed, it continues
    scanning backwards until arg->prev_cfp is set, as that is needed
    to set the location of the first frame. Due to the fact that arg
    is a void pointer, it's not possible to check this directly, but
    this calls the iter_skip function in a situation where it knows
    it will set arg->prev_cfp, and then breaks out of the loop.

    Fixes [Bug #18053]

commit d6b8b37a2608a0fbb8bcfd10356bb25f9ebbe1fe
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-08-08 12:00:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-08 12:00:48 +0900

    merge revision(s) e5dd40b1f3a11f48d566413ab347ce0cfdd94960: [Backport #18065]

            Stop force-recycling evacuated array [Bug #18065]

            ---
             hash.c | 1 -
             1 file changed, 1 deletion(-)

commit 80c180df769016d58663218de2687613841864f3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-08-04 12:40:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-04 12:40:12 +0900

    merge revision(s) b8386f7f7f6d7a7d76481e02d389d0f5211f0f2c:

            Prepend DebugSystem to VCS class only

            And revert 24e5f1c982966c379220b1bbb26b4e0320180fa1, pepending to
            Kernel did not affect the top level methods before 3.0.
            ---
             tool/lib/vcs.rb    | 3 ---
             tool/make-snapshot | 2 +-
             2 files changed, 1 insertion(+), 4 deletions(-)

commit a4d2e48c735b3cd4d2af9c71d16d49175d70fef6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-08-01 18:31:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-01 18:31:21 +0900

    merge revision(s) 24e5f1c982966c379220b1bbb26b4e0320180fa1:

            Ignore 7z unless available

            `DebugSystem#system` is prepended in vcs.rb and defaulted to
            `exception: true`.
            ---
             tool/make-snapshot | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 6f4ab641bb1035c5811e42e43320112e4a502a0e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-08-01 18:30:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-01 18:30:39 +0900

    merge revision(s) 345db8f2aa373a31c619c8f85bd372f0a20829c1: [Backport #10902]

            Avoid pointless attempts to open .so file if already required

            When attempting to require a file without an extension that has
            already been required or provided with an .so extension, only
            look for files with an .rb extension. There is no point in
            trying to find files with an .so extension, since we already
            know one has been loaded.

            Previously, attempting to require such a file scanned the load
            path twice, once for .rb and once for .so.  Now it only scans
            once for .rb.  The scan once for .rb cannot be avoided, since
            the .rb file would take precedence and should be loaded if it
            exists.

            Fixes [Bug #10902]
            ---
             load.c | 7 ++++++-
             1 file changed, 6 insertions(+), 1 deletion(-)

commit 0dbb3c15dbe9b7693ea362c94ed8939d20cba083
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-08-01 18:05:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-08-01 18:05:04 +0900

    merge revision(s) b360588cd3cbac5fb4f004aa53a8fdc715906719: [Backport #15856]

            Sort feature index arrays by the priority of file types [Bug #15856]

            When looking for libraries to load with a feature name without
            extension, `.rb` files are given priority. However, since the
            feature index arrays were not in that order of priority, but in
            the order in which they were loaded, a lower priority extension
            library might be returned. In that case, the `.rb` file had to be
            searched for again from the `$LOAD_PATH`, resulting in poor
            performance.
            ---
             load.c | 52 +++++++++++++++++++++++++++++++++++++++++++++-------
             1 file changed, 45 insertions(+), 7 deletions(-)

commit fd476075593b97b143ad39293af5450143cc2ad0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-29 23:25:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-29 23:25:09 +0900

    merge revision(s) 8897098b5ca3ce987307d1799f7765e6a279ff0d,d04ba0906c35013a8432535168eec270d6e9a913:

            Update bundled_gems to pass test-bundled-gems on macOS.

            ---
             gems/bundled_gems | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            Update bundled_gems

            ---
             gems/bundled_gems | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit e2aaed044e9775dde061ecc960b7afabe91e7c6f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-25 14:51:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-25 14:51:32 +0900

    merge revision(s) 292230cbf926e9892596ea37fd4567f0c49ab73c:

            Fixed leaked global symbols

            ---
             gc.c            | 14 +++++++++-----
             vm_insnhelper.c |  7 ++++---
             vm_insnhelper.h |  2 +-
             vm_sync.c       |  4 ++--
             vm_sync.h       |  6 ++++--
             5 files changed, 20 insertions(+), 13 deletions(-)

commit 0a5f22cc426006da8ec2108b36abadad160f8e09
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-25 14:19:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-25 14:19:12 +0900

    merge revision(s) 73cd4951de20bf989747013b1e62a202f12ac2d2,6e6be107dd0c820afc4db68d09110ad96c4aebdd:

            Reduced GitHub Actions

            Moved leaked-globals before check.
            ---
             .github/workflows/macos.yml  | 4 +++-
             .github/workflows/ubuntu.yml | 8 +++-----
             2 files changed, 6 insertions(+), 6 deletions(-)

            Ignore test-bundled-gems on GitHub Actions because matrix tests has
             unknown issues

            ---
             .github/workflows/macos.yml | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 95dc88c88869541dd0eccafd14924d78c8d7f427
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-25 13:38:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-25 13:49:53 +0900

    partially merge revision(s) 5f69a7f60467fa58c2f998daffab43e118bff36c: [Backport #17666]

    Co-authored-by: Samuel Williams <@ioquatix>
    https://github.com/nagachika/ruby/pull/1/commits/2cee515f024f3295945f312cb6b052f972f9c93d

commit dc7ad0287eff6e11c2d0f71d2a02e56fe172a0da
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-25 13:47:45 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-25 13:47:45 +0900

    bump up bundled rbs and typeprof version to pass test-bundled-gems.

commit ec5bc13262de3c827d0e1685d89be3b18457783c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-25 13:12:07 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-25 13:13:08 +0900

    bump up bundled rbs and typeprof version to pass test-bundled-gems.

commit a215c6d0448764131cbbb48b476dc698b51c2273
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-18 15:23:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-22 11:47:00 +0900

    partially merge revision(s) 119697f61e2b2b157816a8aa33aada5863959900,4a627dbdfd1165022fa9e716ba845e937b03773d: [Backport #18014]

            [Bug #18014] Fix rb_gc_force_recycle unmark before sweep

            If we force recycle an object before the page is swept, we should clear
            it in the mark bitmap. If we don't clear it in the bitmap, then during
            sweeping we won't account for this free slot so the `free_slots` count
            of the page will be incorrect.
            ---
             gc.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            [Bug #18014] Fix memory leak in GC when using Ractors

            When a Ractor is removed, the freelist in the Ractor cache is not
            returned to the GC, leaving the freelist permanently lost. This commit
            recycles the freelist when the Ractor is destroyed, preventing a memory
            leak from occurring.
            ---
             gc.c          | 116 +++++++++++++++++++++++++++-------------------------------
             internal/gc.h |   6 +++
             ractor.c      |   3 ++
             ractor_core.h |   5 +--
             4 files changed, 64 insertions(+), 66 deletions(-)

    Co-authored-by: Peter Zhu <peter@peterzhu.ca>

commit c4b602e80fdc1824c68602302a4ed82a0e90d5b7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-18 11:22:50 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-18 11:22:50 +0900

    merge revision(s) 25e56fe374478a2266ac25f22a07bb3c6a423c83,8758b07b1e4fd636dffb4b442388a3033c63d4b5,791e8eec66d3aebcee36c1369b0bf52bc3815e94: [Backport #18016]

            [ruby/fiddle] Fix Win32Types for Windows 64-bit (#63)

            https://docs.microsoft.com/en-us/windows/win32/winprog/windows-data-types

            https://github.com/ruby/fiddle/commit/28ee5b1608
            ---
             ext/fiddle/lib/fiddle/types.rb | 8 ++++----
             1 file changed, 4 insertions(+), 4 deletions(-)

            [ruby/fiddle] Fix more Win32Types definitions

            https://docs.microsoft.com/en-us/windows/win32/winprog/windows-data-types

            https://github.com/ruby/fiddle/commit/805c1a595a
            ---
             ext/fiddle/lib/fiddle/types.rb | 23 ++++++++++++-----------
             1 file changed, 12 insertions(+), 11 deletions(-)

            [ruby/fiddle] win32types: sort

            https://github.com/ruby/fiddle/commit/35dec6c5a5
            ---
             ext/fiddle/lib/fiddle/types.rb | 30 +++++++++++++++---------------
             1 file changed, 15 insertions(+), 15 deletions(-)

commit b93a2d9d2cac5d3efe72537debedb089d447d33a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-18 11:19:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-18 11:19:13 +0900

    merge revision(s) 391abc543cea118a9cd7d6310acadbfa352668ef,e86c1f6fc53433ef5c82ed2b7a4cc9a12c153e4c,f6539202c52a051a4e6946a318a1d9cd29002990: [Backport #12052]

            Scan the coderange in the given encoding

            ---
             ext/-test-/string/enc_str_buf_cat.c       | 14 ++++++++++++++
             string.c                                  | 32 ++++++++++++++++++++++---------
             test/-ext-/string/test_enc_str_buf_cat.rb |  9 +++++++++
             3 files changed, 46 insertions(+), 9 deletions(-)

            Work around issue transcoding issue with non-ASCII compatible
             encodings and xml escaping

            When using a non-ASCII compatible source and destination encoding
            and xml escaping (the :xml option to String#encode), the resulting
            string was broken, as it used the correct non-ASCII compatible
            encoding, but contained data that was ASCII-compatible instead of
            compatible with the string's encoding.

            Work around this issue by detecting the case where both the
            source and destination encoding are non-ASCII compatible, and
            transcoding the source string from the non-ASCII compatible
            encoding to UTF-8. The xml escaping code will correctly handle
            the UTF-8 source string and the return the correctly encoded
            and escaped value.

            Fixes [Bug #12052]

            Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
            ---
             test/ruby/test_transcode.rb | 19 +++++++++++++++++++
             transcode.c                 |  6 ++++++
             2 files changed, 25 insertions(+)

            =?UTF-8?q?-=20add=20regression=20tests=20for=20U+6E7F=20(?=
             =?UTF-8?q?=E6=B9=BF)=20in=20ISO-2022-JP?=
            MIME-Version: 1.0
            Content-Type: text/plain; charset=UTF-8
            Content-Transfer-Encoding: 8bit

              In ISO-2022-JP, the bytes use to code are the same as those for "<>".
              This adds regression tests to make sure that these bytes, when representing
              湿, are NOT　escaped with encode("ISO-2022-JP, xml: :text) or similar.
              These are additional regression tests for #12052.
            ---
             test/ruby/test_transcode.rb | 3 +++
             1 file changed, 3 insertions(+)

commit ca6ebde821991cb558003c3a1d680eaa8df3169d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-18 10:58:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-18 10:58:55 +0900

    merge revision(s) 1fac99afdae2671a9ca86bead5bde4d0e2eff1b4: [Backport #18030]

            skip marking for uninitialized imemo_env.

            RUBY_INTERNAL_EVENT_NEWOBJ can expose uninitialized imemo_env
            objects and marking it will cause critical error. This patch
            skips marking on uninitialized imemo_env.

            See: http://rubyci.s3.amazonaws.com/centos7/ruby-master/log/20210329T183003Z.fail.html.gz

            Shortest repro-code is provided by mame-san.
            ---
             gc.c                           | 16 ++++++++++------
             test/objspace/test_objspace.rb | 13 +++++++++++++
             2 files changed, 23 insertions(+), 6 deletions(-)

commit 3540939b95ffa9c24873e9675997037c54063417
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-07 21:35:10 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 21:35:10 +0900

    bump teeny version to 3.0.3.

commit 0db68f023372b634603c74fca94588b457be084c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-07 19:08:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 19:08:35 +0900

    bump up RUBY_PATCHLEVEL

commit e2ac25d0eb66de99f098d6669cf4f06796aa6256
  Author:     Shugo Maeda <shugo@ruby-lang.org>
  AuthorDate: 2021-05-11 10:31:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 19:08:18 +0900

    Fix StartTLS stripping vulnerability

    This fixes CVE-2021-32066.
    Reported by Alexandr Savca in <https://hackerone.com/reports/1178562>.

commit fc71da2673b4cef08749a6756c3fe2ca214820b7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-07 19:06:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 19:06:32 +0900

    bump up RUBY_PATCHLEVEL

commit bf4d05173c7cf04d8892e4b64508ecf7902717cd
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2021-07-07 11:57:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 19:05:36 +0900

    Ignore IP addresses in PASV responses by default, and add new option use_pasv_ip

    This fixes CVE-2021-31810.
    Reported by Alexandr Savca.

    Co-authored-by: Shugo Maeda <shugo@ruby-lang.org>

commit ec171fa1f9165c31b00971f90c74ef9674d82973
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-07-07 08:57:34 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 10:03:15 +0900

    Merge RubyGems-3.2.22 and Bundler-2.2.22

commit 865221f0ba69f07f700e06b2d2f0a859a01dd233
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-06-28 19:25:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 10:03:15 +0900

    Merge RubyGems-3.2.21 and Bundler-2.2.21

commit a50de0adfff8166ea18570edafafb0ba501ff2fa
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-04-15 13:36:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 10:03:15 +0900

    Also merge tool/bundler/*.rb for testing of Bundler

commit 39f61c3d380576da2f11da73a4b3b640a687d851
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-05-12 16:01:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 10:03:15 +0900

    Use assert_raise instead of assert_raises

commit fd5e314ecc238a73ca70418c9dc7bce1c8141a50
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-05-11 20:08:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 10:03:15 +0900

    Workaround for make test-tool

commit 596a99ac7faf4e7cc25fedb2b17fa49918323d56
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2021-05-11 19:46:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 10:03:15 +0900

    Fix a typo of c6a11b865e1f9085c88fe169a1f47680383580c2

    It failed to define `refute_path_not_exist`

commit 152397e495650dc5d55b85796a4272c3b52e0b15
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-05-11 19:32:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 10:03:15 +0900

    Alias assert/refute_path_exists for test-unit gem.
    It's required at https://github.com/rubygems/rubygems/pull/3141

commit bf0e7095dc75516e61d077f70ee8733ecb54faa6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-06-14 13:03:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 10:03:15 +0900

    Use the latest version of Bundler's gemspec

commit 1e98ec27f6ab893d7c9c1d48214fbe9bb2aa049c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-06-14 12:55:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 10:03:15 +0900

    Merge RubyGems-3.2.20 and Bundler-2.2.20

commit f63d3bbb6e27daaac8211c57929d62add4fef1ad
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-06-14 12:55:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 10:03:15 +0900

    Merge RubyGems-3.2.19 and Bundler-2.2.19

commit d4b4281959d2a9846d766253b5e21e8158948aa7
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-06-14 12:55:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 10:03:15 +0900

    Merge RubyGems-3.2.18 and Bundler-2.2.18

commit dd28c03d5fd7a82d1b694a9c2332a55dab81add9
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-06-14 12:54:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 10:03:15 +0900

    Merge RubyGems-3.2.17 and Bundler-2.2.17

commit 3e2f089432119cf67017d55f4deef2ea909ceb79
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-06-14 12:54:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-07 10:03:15 +0900

    Merge RubyGems-3.2.16 and Bundler-2.2.16

commit 69fd46f2524ac5df5b739f0a19c71aecfa180d48
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-03 14:22:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-03 14:22:06 +0900

    Revert "merge revision(s) e86c1f6fc53433ef5c82ed2b7a4cc9a12c153e4c,f6539202c52a051a4e6946a318a1d9cd29002990: [Backport #1205]"

    This reverts commit e62cccaeb0986d43480bccbd365cb20056bda4d7.

commit e62cccaeb0986d43480bccbd365cb20056bda4d7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-03 13:49:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-03 13:49:46 +0900

    merge revision(s) e86c1f6fc53433ef5c82ed2b7a4cc9a12c153e4c,f6539202c52a051a4e6946a318a1d9cd29002990: [Backport #1205]

            Work around issue transcoding issue with non-ASCII compatible
             encodings and xml escaping

            When using a non-ASCII compatible source and destination encoding
            and xml escaping (the :xml option to String#encode), the resulting
            string was broken, as it used the correct non-ASCII compatible
            encoding, but contained data that was ASCII-compatible instead of
            compatible with the string's encoding.

            Work around this issue by detecting the case where both the
            source and destination encoding are non-ASCII compatible, and
            transcoding the source string from the non-ASCII compatible
            encoding to UTF-8. The xml escaping code will correctly handle
            the UTF-8 source string and the return the correctly encoded
            and escaped value.

            Fixes [Bug #12052]

            Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
            ---
             test/ruby/test_transcode.rb | 19 +++++++++++++++++++
             transcode.c                 |  6 ++++++
             2 files changed, 25 insertions(+)

            =?UTF-8?q?-=20add=20regression=20tests=20for=20U+6E7F=20(?=
             =?UTF-8?q?=E6=B9=BF)=20in=20ISO-2022-JP?=
            MIME-Version: 1.0
            Content-Type: text/plain; charset=UTF-8
            Content-Transfer-Encoding: 8bit

              In ISO-2022-JP, the bytes use to code are the same as those for "<>".
              This adds regression tests to make sure that these bytes, when representing
              湿, are NOT　escaped with encode("ISO-2022-JP, xml: :text) or similar.
              These are additional regression tests for #12052.
            ---
             test/ruby/test_transcode.rb | 3 +++
             1 file changed, 3 insertions(+)

commit 2aad080396f5b79a33502f1d812fb237968cb931
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-03 12:09:42 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-03 12:09:42 +0900

    merge revision(s) 0846c2da457e7523819236ac7da492029b3ef73d,6c7cb00c094332a208cf36e5cd723a9ba60c41b8: [Backport #16376]

            Check backref number buffer overrun [Bug #16376]

            ---
             regcomp.c                | 21 ++++++++++++---------
             test/ruby/test_regexp.rb |  6 ++++++
             2 files changed, 18 insertions(+), 9 deletions(-)

            test/ruby/test_regexp.rb: Avoid "ambiguity between regexp and two
             divisions"

            ---
             test/ruby/test_regexp.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 934001fb08ef133b2925f1651f36f83ddcd2f46d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-07-03 11:38:10 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-07-03 11:38:10 +0900

    merge revision(s) 5d710d7e41ef3a9877426c87de121be3bf770e34: [Backport #17476]

            Fix the wrong file detection for net-*.gemspec

            [Bug #17476][ruby-core:101724]
            ---
             tool/rbinstall.rb | 5 +++++
             1 file changed, 5 insertions(+)

commit f0a1c063490d69f0868876deed74ad52db63cf4b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-06-13 14:07:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-06-13 14:07:06 +0900

    merge revision(s) d74e5d5b4fba41a9120b3ed2762cf765478605ad: [Backport #17948]

            Crash more nicely when the VM isn't fully set up

            If we crash but the VM isn't fully alive, we can get an infinite loop.
            ---
             vm_dump.c | 62 ++++++++++++++++++++++++++++++++------------------------------
             1 file changed, 32 insertions(+), 30 deletions(-)

commit 3d6b5c23139f097ca5022bcb84135b42ee0ff2b4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-06-10 16:09:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-06-10 16:09:02 +0900

    merge revision(s) 773c690f2553db31a9cc83a037f5449e0c1ea456:

            [ruby/net-ftp] Bump version to 0.1.2

            https://github.com/ruby/net-ftp/commit/895ba44b3c
            ---
             lib/net/ftp.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 24370a7a38db06a29637052a174c1fdc9c779a28
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-06-10 16:08:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-06-10 16:08:40 +0900

    merge revision(s) 370949aad60e992c26037241c07489c056554ea3:

            test/net/ftp/test_ftp.rb - fix intermittent MinGW failure

            Fixes intermittent error as below:

            [242/838] 5316=test_ftp
            #<Thread:0x0000020aa8733f20 D:/a/ruby/ruby/src/test/net/ftp/test_ftp.rb:2532 run> terminated with exception (report_on_exception is true):
            D:/a/ruby/ruby/src/tool/lib/minitest/unit.rb:199:in `assert': Expected #<Errno::ECONNRESET: An existing connection was forcibly closed by the remote host.> to be nil. (MiniTest::Assertion)
                    from D:/a/ruby/ruby/src/tool/lib/test/unit/core_assertions.rb:504:in `assert'
                    from D:/a/ruby/ruby/src/tool/lib/minitest/unit.rb:299:in `assert_nil'
                    from D:/a/ruby/ruby/src/test/net/ftp/test_ftp.rb:430:in `ensure in block in test_list_read_timeout_exceeded'
                    from D:/a/ruby/ruby/src/test/net/ftp/test_ftp.rb:431:in `block in test_list_read_timeout_exceeded'
                    from D:/a/ruby/ruby/src/test/net/ftp/test_ftp.rb:2539:in `block in create_ftp_server'
            D:/a/ruby/ruby/src/test/net/ftp/test_ftp.rb:426:in `write': An existing connection was forcibly closed by the remote host. (Errno::ECONNRESET)
                    from D:/a/ruby/ruby/src/test/net/ftp/test_ftp.rb:426:in `print'
                    from D:/a/ruby/ruby/src/test/net/ftp/test_ftp.rb:426:in `block (2 levels) in test_list_read_timeout_exceeded'
                    from D:/a/ruby/ruby/src/test/net/ftp/test_ftp.rb:420:in `each'
                    from D:/a/ruby/ruby/src/test/net/ftp/test_ftp.rb:420:in `each_with_index'
                    from D:/a/ruby/ruby/src/test/net/ftp/test_ftp.rb:420:in `block in test_list_read_timeout_exceeded'
                    from D:/a/ruby/ruby/src/test/net/ftp/test_ftp.rb:2539:in `block in create_ftp_server'
            ---
             test/net/ftp/test_ftp.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 98e5d1f23c8fd492f7b856902132c11752967d3a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-06-10 16:07:42 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-06-10 16:07:42 +0900

    merge revision(s) fe11031b677f301fa011202f3d27e8eb73064264:

            test/net/ftp/test_ftp.rb: remove unused variable

            ---
             test/net/ftp/test_ftp.rb | 1 -
             1 file changed, 1 deletion(-)

commit 02411b16afa615617b8076548571cc2cdd6a5228
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-06-10 16:07:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-06-10 16:07:25 +0900

    merge revision(s) 1b2abb6590a653cb7b31d73c42edbaf2d0617b27:

            [ruby/net-ftp] Replace "iff" with "if and only if"

            iff means if and only if, but readers without that knowledge might
            assume this to be a spelling mistake. To me, this seems like
            exclusionary language that is unnecessary. Simply using "if and only if"
            instead should suffice.

            https://github.com/ruby/net-ftp/commit/e920473618
            ---
             lib/net/ftp.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 6363492817d9dc73da836da852d7cb6a4ace3a8f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-06-10 16:06:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-06-10 16:06:01 +0900

    merge revision(s) 990baec41174a0b4cf7e285cf3185b4ab444437e:

            [ruby/net-ftp] Close the passive connection data socket if there is
             an error setting up the transfer

            Previously, the connection leaked in this case.  This uses
            begin/ensure and checking for an error in the ensure block.

            An alternative approach would be to not even perform the
            connection until after the RETR (or other) command has been
            sent.  However, I'm not sure all FTP servers support that.
            The current behavior is:

            * Send (PASV/EPSV)
            * Connect to the host/port returned in 227/229 reply
            * Send (RETR/other command)

            Changing it to connect after the RETR could break things.
            FTP servers might expect that the client has already
            connected before sending the RETR.  The alternative
            approach is more likely to introduce backwards compatibility
            issues, compared to the begin/ensure approach taken here.

            Fixes Ruby Bug 17027

            https://github.com/ruby/net-ftp/commit/6e8535f076
            ---
             lib/net/ftp.rb           | 24 ++++++++++++++----------
             test/net/ftp/test_ftp.rb | 39 +++++++++++++++++++++++++++++++++++++--
             2 files changed, 51 insertions(+), 12 deletions(-)

commit ced669aed0de19090d1ba85eb9881becb693a735
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-06-10 16:01:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-06-10 16:01:53 +0900

    merge revision(s) a86c6cb34df0c44973efe6578ba1cd9150af22cf:

            [ruby/net-ftp] Replace Timeout.timeout with socket timeout

            Timeout.timeout is inefficient since it spins up a new thread for
            each invocation, use Socket.tcp's connect_timeout option instead
            when we aren't using SOCKS (we can't replace Timeout.timeout
            for SOCKS yet since SOCKSSocket doesn't have a connect_timeout
            option).

            https://github.com/ruby/net-ftp/commit/d65910132f
            ---
             lib/net/ftp.rb | 17 +++++++++++------
             1 file changed, 11 insertions(+), 6 deletions(-)

commit d4f4ae599f650feb0a9da6fa486ce425dbe8a81a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-06-10 10:31:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-06-10 10:31:27 +0900

    merge revision(s) 73f9831a57e133ab5645221df862a176a42f6685: [Backport #17941]

            POSIX timer cannot be shared in forked process [Bug #17941]

            ---
             thread_pthread.c | 1 +
             1 file changed, 1 insertion(+)

commit 2dd18df4a35a4b2dd0cf2dec7759898246fc6935
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-06-03 20:46:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-06-03 20:46:53 +0900

    merge revision(s) 86c262541ad07528842d76dab4b9b34bd888d5f4,7e14762159643b4415e094f9d2a90afaf7994588: [Backport #17935]

            Fix a race condition around mjit_recompile

            This fixes SEGVs like https://github.com/ruby/ruby/runs/2715166621?check_suite_focus=true.

            When mjit_recompile is called when mjit_compile is compiling the exact
            same iseq (and after it called mjit_capture_cc_entries), iseq->body->jit_unit
            is re-created and its cc_entries becomes NULL. Then, when it tries to
            lookup cc_entries through iseq->body->jit_unit, it fails.
            ---
             mjit.c        | 21 +++++++++++++--------
             mjit_worker.c |  4 ++++
             2 files changed, 17 insertions(+), 8 deletions(-)

            Do not doubly hold an MJIT lock

            This is a follow-up of 86c262541ad07528842d76dab4b9b34bd888d5f4.
            CRITICAL_SECTION_START/FINISH are not needed when it's called from an
            MJIT worker.

            Also, ZALLOC needs to be calloc because ZALLOC may trigger GC, which an
            MJIT worker must not do.
            ---
             mjit.c        | 23 ++++++++++++++---------
             mjit_worker.c |  4 ++--
             2 files changed, 16 insertions(+), 11 deletions(-)

commit 9680ee97e0b3e87c0fc9a65c01de1ee50a1a178b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-06-03 20:46:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-06-03 20:46:01 +0900

    merge revision(s) 1aac0e88193a82ed36b43e852c46414181b66455: [Backport #17928]

            Mark inlined ISeqs during MJIT compilation (#4539)

            [Bug #17584]
            ---
             common.mk      |  6 ++++++
             mjit.c         | 18 +++++++++++-----
             mjit_compile.c | 24 +++++++++++++++------
             mjit_worker.c  | 66 ++++++++++++++++++++++++++++++++++++++++++++++++++++++----
             4 files changed, 99 insertions(+), 15 deletions(-)

commit a21ec8d1ecc6e978ea6b18a27046c424e2849752
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-29 14:36:28 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-29 14:36:28 +0900

    merge revision(s) 636d4f7eb9f3fcb088e1a44af4181c4aa36789b4: [Backport #17822]

            Avoid setting the visibility of refinement method entries

            Since refinement search is always performed, these entries should always
            be public. The method entry that the refinement search returns decides
            the visibility.

            Fixes [Bug #17822]
            ---
             test/ruby/test_refinement.rb | 22 ++++++++++++++++++++++
             vm_method.c                  | 15 ++++++++++-----
             2 files changed, 32 insertions(+), 5 deletions(-)

commit d47df50678b00bd622e6be474031204ed2e52b31
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-29 14:35:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-29 14:35:12 +0900

    merge revision(s) 39a2ba5cc559900c30c3143da32446c2f20a7484: [Backport #17806]

            Method cache: fix refinement entry handling

            To invalidate some callable method entries, we replace the entry in the
            class. Most types of method entries are on the method table of the
            origin class, but refinement entries without an orig_me are housed in
            the method table of the class itself. They are there because refinements
            take priority over prepended methods.

            By unconditionally inserting a copy of the refinement entry into the
            origin class, clearing the method cache created situations where there
            are refinement entry duplicates in the lookup chain, leading to infinite
            loops and other problems.

            Update the replacement logic to use the right class that houses the
            method entry. Also, be more selective about cache invalidation when
            moving refinement entries for prepend. This avoids calling
            clear_method_cache_by_id_in_class() before refinement entries are in the
            place it expects.

            [Bug #17806]
            ---
             class.c                      |  4 +++-
             test/ruby/test_refinement.rb | 49 ++++++++++++++++++++++++++++++++++++++++++++
             vm_method.c                  | 13 ++++++++++--
             3 files changed, 63 insertions(+), 3 deletions(-)

commit 7b6a2ad04a3272a31323493133498dfc60d77d76
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-29 14:34:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-29 14:34:00 +0900

    merge revision(s) 4b36a597f48c857aa5eb9ed80fec0d02f6284646: [Backport #17519]

            Fix setting method visibility for a refinement without an origin
             class

            If a class has been refined but does not have an origin class,
            there is a single method entry marked with VM_METHOD_TYPE_REFINED,
            but it contains the original method entry.  If the original method
            entry is present, we shouldn't skip the method when searching even
            when skipping refined methods.

            Fixes [Bug #17519]
            ---
             test/ruby/test_module.rb | 110 ++++++++++++++++++++++++++++++++++++++++++++++-
             vm_method.c              |   3 +-
             2 files changed, 111 insertions(+), 2 deletions(-)

commit 20bf397f7cebd8156d76941dd54659cf9b8c8fe7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-29 14:04:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-29 14:04:25 +0900

    merge revision(s) fd8991f797c145615820b4c76e6b7ac5a71339ea: [Backport #17889]

            Fix lazy enumerator with index size

            Fixes [Bug #17889]
            ---
             enumerator.c                      | 7 ++++++-
             test/ruby/test_lazy_enumerator.rb | 4 ++++
             2 files changed, 10 insertions(+), 1 deletion(-)

commit 9d63a8dd0beefa49796eb86ab688c2eb0cd89a20
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-29 13:39:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-29 13:39:20 +0900

    merge revision(s) 5cdf99f64e344b8e4638824d55f5caf33be682ca: [Backport #17761]

            mkmf: fixed install directories of header files in extension
             libraries [Bug #17761]

            When installing an extension library which provides a header, that
            header should be installed under site_ruby (or vendor_ruby when
            "--vendor" option was given to extconf.rb).  However, currently
            this file is about to be installed in the core include directory.
            ---
             lib/mkmf.rb               |  8 ++++----
             test/mkmf/test_install.rb | 30 ++++++++++++++++++++++++++++++
             2 files changed, 34 insertions(+), 4 deletions(-)
             create mode 100644 test/mkmf/test_install.rb

commit 5af5ea7f860ed64062796e54e73274e7a56c7280
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-23 16:09:17 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-23 16:09:17 +0900

    merge revision(s) cfd162d535c7a4f8b1f95255cc6be696a8b75557: [Backport #17467]

            Make String#{strip,lstrip}{,!} strip leading NUL bytes

            The documentation already specifies that they strip whitespace
            and defines whitespace to include null.

            This wraps the new behavior in the appropriate guards in the specs,
            but does not specify behavior for previous versions, because this
            is a bug that could be backported.

            Fixes [Bug #17467]
            ---
             spec/ruby/core/string/lstrip_spec.rb | 18 ++++++++++++------
             spec/ruby/core/string/strip_spec.rb  | 22 ++++++++++------------
             string.c                             |  4 ++--
             test/ruby/test_string.rb             | 16 ++++++++++++++++
             4 files changed, 40 insertions(+), 20 deletions(-)

commit 44b87adc07621b6a8eddfcf4aaff34ce634179d4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-23 15:51:10 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-23 15:51:10 +0900

    merge revision(s) e019dd24df4ed7063ad80d4c2e4070141793f598,7954bb056be30e86c419fe3792064d28990a4999,7d3fdfb27dac456827b004d9e66a44b15f8cd762: [Backport #17736]

            Ensure the receiver is modifiable before shrinking [Bug #17736]

            * Ensure the receiver is modifiable before shinking [Bug #17736]

            * Assert the receivers are not modified
            ---
             array.c                 |  1 +
             test/ruby/test_array.rb | 36 ++++++++++++++++++++++++++++++++++++
             2 files changed, 37 insertions(+)

            Some Hash destructive methods ensure the receiver modifiable [Bug
             #17736]

            refs:

            * https://bugs.ruby-lang.org/issues/17736
            * https://github.com/ruby/ruby/pull/4296

            This commit aims to cover following methods

            * Hash#select!
            * Hash#filter!
            * Hash#keep_if
            * Hash#reject!
            * Hash#delete_if

            I think these are not all.

            ---

            * Ensure the receiver is modifiable or not
            * Assert the receiver is not modified
            ---
             hash.c                 |  2 ++
             test/ruby/test_hash.rb | 42 ++++++++++++++++++++++++++++++++++++++++++
             2 files changed, 44 insertions(+)

            Hash#transform_values! ensures receiver modifiable in block [Bug
             #17736]

            ---
             hash.c                 | 1 +
             test/ruby/test_hash.rb | 9 +++++++++
             2 files changed, 10 insertions(+)

commit 86f7e55dfb5938e0c617b8629a1fbb4d24341dc0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-23 15:05:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-23 15:05:06 +0900

    merge revision(s) 10e63f3f56cc0f559816d921f3e771dea02f3eb9:

            [ruby/rdoc] Vertical-bar is disallowed in path names on Windows

            No risk of remote code execution, when the file cannot be created.

            https://github.com/ruby/rdoc/runs/2565343916?check_suite_focus=true#step:5:58
            ```
            Error: test_remove_unparseable_CVE_2021_31799(TestRDocRDoc): Errno::EINVAL: Invalid argument @ utime_failed - | touch evil.txt && echo tags
            D:/rubyinstaller-head-x64/lib/ruby/3.1.0/fileutils.rb:1142:in `utime'
            D:/rubyinstaller-head-x64/lib/ruby/3.1.0/fileutils.rb:1142:in `block in touch'
            D:/rubyinstaller-head-x64/lib/ruby/3.1.0/fileutils.rb:1139:in `each'
            D:/rubyinstaller-head-x64/lib/ruby/3.1.0/fileutils.rb:1139:in `touch'
            D:/a/rdoc/rdoc/test/rdoc/test_rdoc_rdoc.rb:463:in `block (2 levels) in test_remove_unparseable_CVE_2021_31799'
                 460:     temp_dir do
                 461:       file_list = ['| touch evil.txt && echo tags']
                 462:       file_list.each do |f|
              => 463:         FileUtils.touch f
                 464:       end
                 465:
                 466:       assert_equal file_list, @rdoc.remove_unparseable(file_list)
            ```

            https://github.com/ruby/rdoc/commit/a7df7dc8fa
            ---
             test/rdoc/test_rdoc_rdoc.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 410216c9db033a72f4dd119c366bc58dd54383ec
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-23 14:59:26 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-23 14:59:26 +0900

    merge revision(s) d8a13e504992a45d52063f7c925408d7aad3595a: [Backport #17780]

            [Bug #17780] Fix Method#super_method for module alias

            Method#super_method crashes for aliased module methods because they are
            not defined on a class. This bug was introduced in
            c60aaed1856b2b6f90de0992c34771830019e021 as part of bug #17130.
            ---
             proc.c                   |  2 +-
             test/ruby/test_method.rb | 13 +++++++++++++
             2 files changed, 14 insertions(+), 1 deletion(-)

commit fc73fc79cbaee6674256589b7cfe53d20b638a05
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-23 14:40:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-23 14:40:20 +0900

    merge revision(s) 1ad222477344597038d7ec08885a41f547c2a3b4: [Backport #17625]

            [ruby/openssl] Fixed the results of
             OpenSSL::Timestamp::Response#failure_info

            Made stored values `Symbol`s instead of `ID`s.

            Fixes https://bugs.ruby-lang.org/issues/17625

            Co-Authored-By: xtkoba (Tee KOBAYASHI) <xtkoba+ruby@gmail.com>

            https://github.com/ruby/openssl/commit/f2d004679a
            ---
             ext/openssl/ossl_ts.c   | 22 +++++++++++-----------
             test/openssl/test_ts.rb |  5 +++++
             2 files changed, 16 insertions(+), 11 deletions(-)

commit f9196de1dee6f5ab8b6fe115070b92775a3500fe
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-23 14:36:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-23 14:36:05 +0900

    merge revision(s) 3a3b19b2bba49e5d6f1cf13764eb6dd701397be9: [Backport #17827]

            Fix Monitor to lock per Fiber, like Mutex [Bug #17827]

            ---
             ext/monitor/monitor.c        | 10 +++++-----
             test/monitor/test_monitor.rb |  7 +++++++
             2 files changed, 12 insertions(+), 5 deletions(-)

commit 31816356eee6313fe968eecd4cd3ad9ac4848819
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-22 17:09:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-22 17:09:16 +0900

    merge revision(s) 2bc293e899c9d32dcd794a73de8925c49ecf8f15,d0e6c6e682b9ba2b0309a5177933a0628e8ef316,cc0dc67bbbe1951ff90004bc987f78545625d772,e1eff837cf12a8e813de9d4ff2db50c9b68b86b5,0ab0b86c8491d639b9ff1335ddf35e341ecd867e,6911b4bc82889860ff7da4ecf975504cdc3e5314: [Backport #17854]

            cdhash_cmp: can take rational literals

            Rational literals are those integers suffixed with `r`.  They tend to
            be a part of more complex expressions like `123/456r`, but in theory
            they can live alone.  When such "bare" rational literals are passed to
            case-when branch, we have to take care of them.  Fixes [Bug #17854]
            ---
             common.mk                  |  1 +
             compile.c                  |  7 +++++++
             internal/rational.h        |  1 +
             rational.c                 | 13 ++++++++++---
             test/ruby/test_rational.rb |  7 +++++++
             5 files changed, 26 insertions(+), 3 deletions(-)

            cdhash_cmp: rational literals with fractions

            Nobu kindly pointed out that rational literals can have fractions.
            ---
             compile.c                  | 5 +++--
             test/ruby/test_rational.rb | 4 ++++
             2 files changed, 7 insertions(+), 2 deletions(-)

            cdhash_cmp: can also take complex

            There are complex literals `123i`, which can also be a case condition.
            ---
             compile.c                  | 15 +++++++++++----
             complex.c                  | 12 +++++++++---
             internal/complex.h         |  1 +
             test/ruby/test_rational.rb |  4 ++++
             4 files changed, 25 insertions(+), 7 deletions(-)

            cdhash_cmp: recursively apply

            For instance a rational's numerator can be a bignum.  Comparison using
            C's == can be insufficient.
            ---
             compile.c | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

            cdhash_cmp: should use ||

            cf: https://github.com/ruby/ruby/pull/4469#discussion_r628386707
            ---
             compile.c | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

            test_cdhash: refactor change class

            It is now strange to test Complex in a class named Rational_Test.
            ---
             test/ruby/test_rational.rb | 15 ---------------
             test/ruby/test_syntax.rb   | 15 +++++++++++++++
             2 files changed, 15 insertions(+), 15 deletions(-)

commit af9de56c6fde7f9adb81d6ed0ef3067af81f90e5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-22 16:47:24 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-22 16:47:24 +0900

    merge revision(s) 110f242ef9b495037f59e4972ee102a8b8b372d5: [Backport #17861]

            Also `\U` after control/meta is invalid [Bug #17861]

            As well as `\u`, `\U` should be invalid there too.
            And highlight including `u`/`U` not only the backslash before it.
            ---
             parse.y                 | 12 ++++++++++--
             test/ruby/test_parse.rb | 15 +++++++++++++++
             2 files changed, 25 insertions(+), 2 deletions(-)

commit 5e21726cda22e3cb34127751aec7e9babb4308b3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-22 16:27:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-22 16:27:29 +0900

    merge revision(s) 799ea1d1540aca03542ee31647052343507a4b41: [Backport #16651]

            mkmf.rb: convert also arch_hdrdir [Bug #16651]

            ---
             lib/mkmf.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit ddd720f8dcd98de6a250a152fa40c3c044d62383
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-22 15:51:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-22 15:51:37 +0900

    merge revision(s) 5026f9a5d5012248729a0052cd6cec811748291b: [Backport #17868]

            compile.c: stop the jump-jump optimization if the second has any
             event

            Fixes [Bug #17868]
            ---
             compile.c                      |  3 ++-
             test/ruby/test_settracefunc.rb | 15 +++++++++++++++
             2 files changed, 17 insertions(+), 1 deletion(-)

commit 9c0df2e81c22e6e35f3c5d69a070c2a3cf67e320
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-22 15:20:23 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-22 15:20:23 +0900

    merge revision(s) 9edc162583a4f685332239f6249745ad9b518cbe: [Backport #17781]

            [ruby/resolv] Fix confusion of received response message

            This is a follow up for commit 33fb966197f1 ("Remove sender/message_id
            pair after response received in resolv", 2020-09-11).

            As the @senders instance variable is also used for tracking transaction
            ID allocation, simply removing an entry without releasing the ID would
            eventually deplete the ID space and cause
            Resolv::DNS.allocate_request_id to hang.

            It seems the intention of the code was to check that the received DNS
            message is actually the response for the question made within the method
            earlier. Let's have it actually do so.

            [Bug #12838] https://bugs.ruby-lang.org/issues/12838
            [Bug #17748] https://bugs.ruby-lang.org/issues/17748

            https://github.com/ruby/resolv/commit/53ca9c9209
            ---
             lib/resolv.rb | 6 +++---
             1 file changed, 3 insertions(+), 3 deletions(-)

commit e175917f66f0b51638d9d9e143918d4109d489f4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-22 14:59:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-22 14:59:05 +0900

    merge revision(s) dfe21ef7a15a30fc33f3a5cc089e15d09e905eb4: [Backport #17874] [Backport #17876]

            Do not block JIT with pending_stale_p

            Because we want to flush pending stale units before unloading units, the
            pending_stale_p check is implemented in this waiting loop.

            However, once all methods are called more than --jit-min-calls,
            mjit_worker_wakeup will not be signaled again. As a result, when
            mjit_recompile is called after that and pending_stale_p becomes true,
            MJIT stops processing methods in the unit queue even if the queue is
            very long and MJIT does nothing, waiting for the signal.

            There should be a better way to handle this, but as a fix to be
            backported to Ruby 3.0, let me make an obvious simple commit here.
            ---
             mjit_worker.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 2a70d2148453aeb39443f4c84147ace722d53a9a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-05-22 14:51:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-05-22 14:51:55 +0900

    merge revision(s) b1c73f239fe9af97de837331849f55d67c27561e,bb570ce6d80d28cfc7131dcb72885eed2f989b30,b88d1e6b44164bca0c2b85ea6639469813e1e1d8,127f735c1e5e0771076caf2a74390757a42fb177,f3f1a666c77f8c528b0adc9ccf78e4b9910bd6e0,fa048a0f8523cefde5428805dd334691486319e6,d5d1c41728d65acfb8aa2cf95f2d8ac88f271cd1,52ebaf718e6a78297ceb0dff49815eeed28eae45,7fe22152fc28084f4395fece84ff6e5eb2d6b288,19e6d271266eca5925e66fc8ec39b251a2fa6bcd,05898c5b9001c0b1e8bd7bf0d12b42a8e7c388b8,3651f678a719ae3a35825bcb4e0dabbc7c60d8df,10b082064e6ab0943cce4ef43e567d8044c7096d,de8e6218a3257fe19b46ff0aa157e66f452ac8b7,971a0cd246db6578e1ea8760a903e1a23e3681f3,61a29a41e1d0d11a9963315aa86d25ed690124c0,ff9a00887161840eb8a34d53749a7d7962181cfe,fad3412d475b57055f426cf4e86eafeab516672b,54aa11efa8b1be2c5d20402890d6d2fa90aa19a8,e84d275fe6d0c14ba58ce73b13323879c060b7ae,61e1cf23ac0d122fba3ad4cbaa402c7c94ad54d3,a6948329f8f89fb390215086fe4a888915fd589e,64b991b0cd98ee8f23266b8cbea0fa34bdaab1ec,b1c73f239fe9af97de837331849f55d67c27561e,0ee24b4fab1a1faef600a42c29863e1c3edd8c61: [Backport #17877]

    Synchronize rdoc with upstream version v6.3.1.

            [ruby/rdoc] Use File.open to fix the OS Command Injection
             vulnerability in CVE-2021-31799

            https://github.com/ruby/rdoc/commit/a7f5d6ab88
            ---
             lib/rdoc/rdoc.rb            |  2 +-
             test/rdoc/test_rdoc_rdoc.rb | 12 ++++++++++++
             2 files changed, 13 insertions(+), 1 deletion(-)

            [ruby/rdoc] Support ChangeLog generated by `git log`

            https://github.com/ruby/rdoc/commit/5e0a123ca1
            ---
             lib/rdoc/parser/changelog.rb            | 35 +++++++++++++++++++++
             test/rdoc/test_rdoc_parser_changelog.rb | 56 +++++++++++++++++++++++++++++++++
             2 files changed, 91 insertions(+)

            [ruby/rdoc] Make each commit entries h3

            https://github.com/ruby/rdoc/commit/11eefb2ae9
            ---
             lib/rdoc/parser/changelog.rb            | 12 ++++++------
             test/rdoc/test_rdoc_parser_changelog.rb | 12 ++++--------
             2 files changed, 10 insertions(+), 14 deletions(-)

            [ruby/rdoc] Tweak log entry markdown

            * add 3 levels to headings
            * prefix commit log to labels to make unique IDs

            https://github.com/ruby/rdoc/commit/5074c13209
            ---
             lib/rdoc/parser/changelog.rb            | 20 +++++++++++++++++-
             test/rdoc/test_rdoc_parser_changelog.rb | 36 ++++++++++++++++++++++++++++++++-
             2 files changed, 54 insertions(+), 2 deletions(-)

            [ruby/rdoc] Shorten commit hashes

            https://github.com/ruby/rdoc/commit/5d3e153963
            ---
             lib/rdoc/parser/changelog.rb            | 2 +-
             test/rdoc/test_rdoc_parser_changelog.rb | 2 +-
             2 files changed, 2 insertions(+), 2 deletions(-)

            [ruby/rdoc] Add links to the commits

            https://github.com/ruby/rdoc/commit/1821628076
            ---
             lib/rdoc/parser/changelog.rb            | 107 +++++++++++++++++++++++++-------
             test/rdoc/test_rdoc_parser_changelog.rb |  36 ++++++-----
             2 files changed, 107 insertions(+), 36 deletions(-)

            [ruby/rdoc] Sort by CommitDate if available

            https://github.com/ruby/rdoc/commit/455715e930
            ---
             lib/rdoc/parser/changelog.rb            | 11 ++++++---
             test/rdoc/test_rdoc_parser_changelog.rb | 40 +++++++++++++++++++++++++++++++++
             2 files changed, 48 insertions(+), 3 deletions(-)

            [ruby/rdoc] Skip non-date logs by git-log

            `RDoc::Parser::ChangeLog` mis-parses ChangeLog generated by
            git-log, because of too heuristic `Time.parse`.

            For instance, "commit 8187228de0142d3ac7950b7d977c2849e934c637"
            results in "8187-08-16", that is, day 228 in the year 8187.

            https://github.com/ruby/rdoc/commit/9711e6f6d9
            ---
             lib/rdoc/parser/changelog.rb            | 36 ++++++++++++++++++++-------------
             test/rdoc/test_rdoc_parser_changelog.rb |  2 ++
             2 files changed, 24 insertions(+), 14 deletions(-)

            [ruby/rdoc] Support other date formats in git-log

            https://github.com/ruby/rdoc/commit/ad8cf37d72
            ---
             lib/rdoc/parser/changelog.rb            |  6 +++---
             test/rdoc/test_rdoc_parser_changelog.rb | 22 ++++++++++++++++++++++
             2 files changed, 25 insertions(+), 3 deletions(-)

            [ruby/rdoc] Support iso-strict format in git-log

            https://github.com/ruby/rdoc/commit/2a6c22da63
            ---
             lib/rdoc/parser/changelog.rb            |  6 +++---
             test/rdoc/test_rdoc_parser_changelog.rb | 11 +++++++++++
             2 files changed, 14 insertions(+), 3 deletions(-)

            [ruby/rdoc] Update Rdoc.css sidebar panel.

            Updates css so the sidebar look like a panel instead of looking like chopped edges.

            https://github.com/ruby/rdoc/commit/b0098c6d72
            ---
             lib/rdoc/generator/template/darkfish/css/rdoc.css | 1 +
             1 file changed, 1 insertion(+)

            [ruby/rdoc] Support GFM table

            https://github.com/ruby/rdoc/commit/9dc933df16
            ---
             lib/rdoc/markdown.rb                    | 349 +++++++++++++++++++++++++++++++-
             lib/rdoc/markup.rb                      |   1 +
             lib/rdoc/markup/table.rb                |  47 +++++
             lib/rdoc/markup/to_html.rb              |  23 +++
             lib/rdoc/markup/to_joined_paragraph.rb  |   1 +
             lib/rdoc/markup/to_rdoc.rb              |  28 +++
             lib/rdoc/markup/to_table_of_contents.rb |   1 +
             test/rdoc/test_rdoc_markdown.rb         |  23 +++
             8 files changed, 471 insertions(+), 2 deletions(-)
             create mode 100644 lib/rdoc/markup/table.rb

            [ruby/rdoc] Add table style

            https://github.com/ruby/rdoc/commit/2219c5ae80
            ---
             lib/rdoc/generator/template/darkfish/css/rdoc.css | 19 +++++++++++++++++++
             1 file changed, 19 insertions(+)

            [ruby/rdoc] Fixed CodeFence without blank lines

            Currently a fenced code block needs a preceding blank line, it
            should not be required, as:
            https://github.github.com/gfm/#fenced-code-blocks
            > A fenced code block may interrupt a paragraph, and does not
            > require a blank line either before or after.

            Just recommended:
            https://docs.github.com/en/github/writing-on-github/creating-and-highlighting-code-blocks
            > We recommend placing a blank line before and after code blocks
            > to make the raw formatting easier to read.

            https://github.com/ruby/rdoc/commit/0e1776caf3
            ---
             lib/rdoc/markdown.rb            | 447 +++++++---------------------------------
             test/rdoc/test_rdoc_markdown.rb |  36 +++-
             2 files changed, 112 insertions(+), 371 deletions(-)

            [ruby/rdoc] Allow partial default values to be overridden with
             .rdoc_options

            https://github.com/ruby/rdoc/commit/e14800891f
            ---
             lib/rdoc/options.rb         | 34 +++++++++++++++++++++++++++++++++-
             lib/rdoc/rdoc.rb            |  7 ++++++-
             test/rdoc/test_rdoc_rdoc.rb | 12 ++++++++++++
             3 files changed, 51 insertions(+), 2 deletions(-)

            [ruby/rdoc] Allow empty .rdoc_options

            https://github.com/ruby/rdoc/commit/0c8cb25b50
            ---
             lib/rdoc/rdoc.rb            |  2 ++
             test/rdoc/test_rdoc_rdoc.rb | 11 +++++++++++
             2 files changed, 13 insertions(+)

            [ruby/rdoc] Suppress unused variable warning of "text"

            https://github.com/ruby/rdoc/commit/3a4120b155
            ---
             lib/rdoc/markdown.rb | 345 ++++++++++++++++++++++++++++++++++++++++++++++++++-
             1 file changed, 343 insertions(+), 2 deletions(-)

            [ruby/rdoc] Get rid of a trailing space

            https://github.com/ruby/rdoc/commit/7b7b91768e
            ---
             lib/rdoc/markdown.rb | 7 +++----
             1 file changed, 3 insertions(+), 4 deletions(-)

            [ruby/rdoc] Disable other notations in <code> tags

            https://github.com/ruby/rdoc/commit/0cd3b55210
            ---
             lib/rdoc/markup/attr_span.rb                    |  10 ++-
             lib/rdoc/markup/attribute_manager.rb            | 102 ++++++++++++++++++------
             test/rdoc/test_rdoc_markup_attribute_manager.rb |  24 +++++-
             test/rdoc/test_rdoc_markup_to_html.rb           |   6 ++
             4 files changed, 114 insertions(+), 28 deletions(-)

            [ruby/rdoc] Treat other tags as word boundaries

            https://github.com/ruby/rdoc/commit/8222f85a17
            ---
             lib/rdoc/markup/attribute_manager.rb  | 17 +++++++++++++----
             test/rdoc/test_rdoc_markup_to_html.rb |  5 +++++
             2 files changed, 18 insertions(+), 4 deletions(-)

            [ruby/rdoc] Treat emphasis tags as excluding other notations

            And exclusive notations don't exclude other exclusive notations.

            https://github.com/ruby/rdoc/commit/b8baa9a435
            ---
             lib/rdoc/markup/attr_span.rb                    |  2 +-
             lib/rdoc/markup/attribute_manager.rb            | 10 +++++-----
             test/rdoc/test_rdoc_markup_attribute_manager.rb |  1 +
             3 files changed, 7 insertions(+), 6 deletions(-)

            [ruby/rdoc] Clarify that dots in URL are replaced

            The dots in all path components from the document root are
            replaced with underscores, not only in the basename.

            https://github.com/ruby/rdoc/commit/7a3417ea4c
            ---
             test/rdoc/test_rdoc_top_level.rb | 3 +++
             1 file changed, 3 insertions(+)

            [ruby/rdoc] Links to document texts without "rdoc-ref:" prefix

            While links to generated HTML from RDoc file needs to be prefixed
            by "rdoc-ref:" currently, in case of explicit references this
            seems just redundant.

            Also GitHub RDoc support does not work with this prefix.

            This patch lets links to such document texts (".rb", ".rdoc" and
            ".md" now) refer URLs generated by `RDoc::TopLevel#http_url`
            without the prefix.

            https://github.com/ruby/rdoc/commit/f18b27b69d
            ---
             lib/rdoc/markup/to_html.rb            |  4 ++++
             test/rdoc/test_rdoc_markup_to_html.rb | 21 +++++++++++++++++++++
             2 files changed, 25 insertions(+)

            [ruby/rdoc] Use File.open to fix the OS Command Injection
             vulnerability in CVE-2021-31799

            https://github.com/ruby/rdoc/commit/a7f5d6ab88
            ---
             lib/rdoc/rdoc.rb            |  2 +-
             test/rdoc/test_rdoc_rdoc.rb | 12 ++++++++++++
             2 files changed, 13 insertions(+), 1 deletion(-)

            [ruby/rdoc] Version 6.3.1

            https://github.com/ruby/rdoc/commit/9307f932b7
            ---
             lib/rdoc/version.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 3e07a4edc92f18dec4806961c1b724ac5cf4d6b2
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-04-29 17:53:07 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-29 17:53:07 +0900

    merge revision(s) 3a3033c138c0951ad5edbf02b5c233b58a190d2f: [Backport #17787]

            get rid of using `__builtin_unreachable` directly [Bug #17787]

            As it is an independent feature from `clz`, `ctz` and `popcount`,
            it might be unavailable even if the latters are built in.
            ---
             internal/bits.h | 6 +++---
             1 file changed, 3 insertions(+), 3 deletions(-)

commit cc4e602634e894c831a4103a5803a3de566c1856
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-04-29 17:49:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-29 17:49:55 +0900

    merge revision(s) 87c546b5fa97e6e226cce4daf417617a1143f642,7a3322a0fd660d676f1918bd7c4a37676b44e1c2:

            Avoid using inconsistent coding style

            Other `_mjit_compile_*.erb` files don't use goto. These files'd better
            be consistent for readability.
            ---
             tool/ruby_vm/views/_mjit_compile_getinlinecache.erb | 14 +++-----------
             1 file changed, 3 insertions(+), 11 deletions(-)

            Fix broken JIT of getinlinecache

            e7fc353f04 reverted vm_ic_hit_p's signature change made in 53babf35ef,
            which broke JIT compilation of getinlinecache.

            To make sure it doesn't happen again, I separated vm_inlined_ic_hit_p to
            make the intention clear.
            ---
             test/ruby/test_jit.rb                              | 12 +++++++++++
             .../ruby_vm/views/_mjit_compile_getinlinecache.erb |  2 +-
             vm_insnhelper.c                                    | 25 ++++++++++++++--------
             3 files changed, 29 insertions(+), 10 deletions(-)

commit 58240b5d0b52d9685b773e5b9e45d22ca500392a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-04-29 17:20:52 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-29 17:20:52 +0900

    merge revision(s) 4ae27d8075b2d138d13cb2b112f0ee50934b3017,2670509ebba5ba31a5bf34cf906943075446e005,8e2ac2140d1cd9c163c1556df58c020dc22ab269:

            [ruby/net-ftp] Reduce resource cosumption of Net::FTP::TIME_PARSER

            Reported by Alexandr Savca as a DoS vulnerability, but Net::FTP is a
            client library and the impact of the issue is low, so I have decided
            to fix it as a normal issue.
            Based on patch by nobu.

            https://github.com/ruby/net-ftp/commit/a93af636f8
            ---
             lib/net/ftp.rb           |  5 +++--
             test/net/ftp/test_ftp.rb | 11 +++++++++++
             2 files changed, 14 insertions(+), 2 deletions(-)

            [ruby/net-ftp] Add test cases

            https://github.com/ruby/net-ftp/commit/865232bb2a
            ---
             test/net/ftp/test_ftp.rb | 6 ++++++
             1 file changed, 6 insertions(+)

            test/net/ftp/test_ftp.rb: reduce the size of a long response

            "9" * 999999999 (about 1 GB) was too large for some CI servers.
            This commit changes the size to 999999 (about 1 MB).

            http://rubyci.s3.amazonaws.com/scw-9d6766/ruby-master/log/20210427T141707Z.fail.html.gz
            http://rubyci.s3.amazonaws.com/raspbian10-aarch64/ruby-master/log/20210427T145408Z.fail.html.gz
            ---
             test/net/ftp/test_ftp.rb | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit 13f93ad16d3d1ecf96ece229cd4bc5ea294e1a71
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-04-24 14:04:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-24 14:04:04 +0900

    merge revision(s) 611e711085c7e3984555a79626d025c8b876eced,a9c5c2d614f30a616970245fef3e7ffc151e2ecf: [Backport #17527]

            Test incorrect behaviour of `rb_io_wait_readable/writable`.

            ---
             test/fiber/test_io.rb | 35 +++++++++++++++++++++++++++++++++++
             1 file changed, 35 insertions(+)

            Check errno before invoking scheduler in
             `rb_io_wait_readable/writable`.

            See <https://bugs.ruby-lang.org/issues/17527> for more details.
            ---
             io.c | 66 +++++++++++++++++++++++++++++++++++-------------------------------
             1 file changed, 35 insertions(+), 31 deletions(-)

commit 5a9b5b8e953dc36f4f7f7639e8aeaa8132241c79
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-04-18 19:03:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-18 19:04:24 +0900

    Add execution bit for autogen.sh.

commit 6e6157d9a985dd39a141e26e579b8508f6ceff15
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-04-18 17:59:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-18 17:59:19 +0900

    merge revision(s) 6268fdc662c75c61091b2ab0b476ec15df023328:

            spec/ruby/core/hash/transform_keys_spec.rb: Fix the failure of
             ruby_3_0

            https://github.com/ruby/spec/pull/833
            https://github.com/ruby/spec/commit/8290e5ad8952b14ee9a5069651d9864c66681112
            ---
             spec/ruby/core/hash/transform_keys_spec.rb | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit 316699605c4ffd37329370233dcee48d6fa8e0d1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-04-15 13:51:10 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-15 13:51:10 +0900

    bump up RUBY_PATCHLEVEL

commit ce06c24b0c1fd9a3e74909886b425feb0af50233
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-04-06 16:07:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-15 13:43:56 +0900

    merge revision(s) c32375883a6,48bb0329eb3:

            Update for autoconf 2.70

            ---
             configure.ac                         | 232 +++++++++++++++++------------------
             tool/m4/ruby_check_builtin_setjmp.m4 |   8 +-
             tool/m4/ruby_check_printf_prefix.m4  |   9 +-
             tool/m4/ruby_check_setjmp.m4         |   6 +-
             tool/m4/ruby_check_sysconf.m4        |   6 +-
             tool/m4/ruby_cppoutfile.m4           |   4 +-
             tool/m4/ruby_decl_attribute.m4       |   4 +-
             tool/m4/ruby_dtrace_available.m4     |   2 +-
             tool/m4/ruby_dtrace_postprocess.m4   |   2 +-
             tool/m4/ruby_mingw32.m4              |   4 +-
             tool/m4/ruby_stack_grow_direction.m4 |   4 +-
             tool/m4/ruby_try_cflags.m4           |   2 +-
             tool/m4/ruby_try_cxxflags.m4         |   2 +-
             tool/m4/ruby_try_ldflags.m4          |   2 +-
             14 files changed, 143 insertions(+), 144 deletions(-)

            Revert AC_PROG_CC_C99 for -std=gnu99 option to gcc 4.8

            ---
             configure.ac | 5 ++++-
             1 file changed, 4 insertions(+), 1 deletion(-)

commit 6add6014d8626c4e5f6816030ea651321e6aa044
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-04-06 16:06:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-15 13:43:56 +0900

    merge revision(s) a3851d97ede:

            Removed unused AC_CHECKING

            ---
             configure.ac | 7 -------
             1 file changed, 7 deletions(-)

commit 84d9a9afc0b49d095541acb9832f8b12fb506e19
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-04-15 10:11:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-15 10:25:30 +0900

    merge revision(s) 31e0382723bfb35cffe3ca485dd0577668cafa07,5e5fb72f99701dc27c66ab148471893f14e6d6f0,fb6ebe55d91187d9635e0183d47dbf38e95b1141,522d4cd32f7727886f4fcbc28ed29c08d361ee20: [Backport #17735]

            Keep non evaluated keys in `Hash#transform_keys!` [Bug #17735]

            ---
             hash.c                                     |  6 +++++-
             spec/ruby/core/hash/transform_keys_spec.rb | 12 +++++++++++-
             test/ruby/test_hash.rb                     |  8 ++++++++
             3 files changed, 24 insertions(+), 2 deletions(-)

            Clear an intermediate hash [Bug #17735]

            ---
             hash.c | 1 +
             1 file changed, 1 insertion(+)

            Hide an intermediate array

            ---
             hash.c | 6 ++++--
             1 file changed, 4 insertions(+), 2 deletions(-)

            Force recycle intermediate collection in Hash#transform_keys! [Bug
             #17735]

            * Force recycle intermediate hash

            * Force recycle intermediate array too

            https://github.com/ruby/ruby/pull/4329#issuecomment-808840718
            ---
             hash.c | 2 ++
             1 file changed, 2 insertions(+)

commit d5a34e1b142eccc54971494be2243a0c6ac01d94
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-04-15 09:46:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-15 09:46:36 +0900

    merge revision(s) fbbc37dc1d5b329777e6d9716118db528ab70730: [Backport #17802]

            test/drb/test_drb.rb: Specify the host of DRbServer

            to try fixing the following error.

            http://rubyci.s3.amazonaws.com/opensuseleap/ruby-master/log/20210407T063004Z.log.html.gz
            ```
            [  605/21105] DRbTests::TestDRbSSLAry#test_06_next/home/chkbuild/chkbuild/tmp/build/20210407T063004Z/ruby/lib/drb/drb.rb:1138:in `method_missing': undefined method `regist' for [1, 2, "III", 4, "five", 6]:Array (NoMethodError)
                    from /home/chkbuild/chkbuild/tmp/build/20210407T063004Z/ruby/lib/drb/extserv.rb:21:in `block in initialize'
                    from /home/chkbuild/chkbuild/tmp/build/20210407T063004Z/ruby/.ext/common/monitor.rb:202:in `synchronize'
                    from /home/chkbuild/chkbuild/tmp/build/20210407T063004Z/ruby/.ext/common/monitor.rb:202:in `mon_synchronize'
                    from /home/chkbuild/chkbuild/tmp/build/20210407T063004Z/ruby/lib/drb/extserv.rb:20:in `initialize'
                    from /home/chkbuild/chkbuild/tmp/build/20210407T063004Z/ruby/test/drb/ut_array_drbssl.rb:35:in `new'
                    from /home/chkbuild/chkbuild/tmp/build/20210407T063004Z/ruby/test/drb/ut_array_drbssl.rb:35:in `<main>'
             = 100.05 s
            ```

            Here is my analysis:
            The test of drb used both `druby://:0` and `druby://localhost:0` for
            DRbServer. However, the former listens on IPv4, and the latter does on
            IPv6, depending on environments. The port 0 is automatically assigned,
            but sometimes the same port is used to both because they are different
            protocols (IPv4 and IPv6). In this case, their URIs are resolved to the
            completely same one (`druby://localhost:port`), which confuses the
            method `DRb.here?` which determines the DRbObject is remote or local.

            This changeset uses `druby://localhost:0` consistently.
            ---
             test/drb/test_drb.rb    | 4 ++--
             test/drb/test_drbssl.rb | 2 +-
             2 files changed, 3 insertions(+), 3 deletions(-)

commit f057a60792293cccfb259430c1a48d445c5c9310
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-04-15 09:44:59 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-15 09:44:59 +0900

    bump teeny version to 3.0.2.

commit 0fb782ee38ea37fd5fe8b1f775f8ad866a82a3f0
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-04-05 21:20:51 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-04-05 21:33:42 +0900

    Get rid of multibyte prefix to tmpdir

commit 6cdc36a60d7fbf4b218785087b1c3a91682bc147
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-04-05 21:06:23 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-04-05 21:33:12 +0900

    [ruby/tmpdir] Bump version to 0.1.2

    https://github.com/ruby/tmpdir/commit/c79bc7adf6

commit b609bf0a17e166a7092fa6d2ff291ed9a26e2510
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-04-05 20:56:45 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-04-05 20:56:45 +0900

    teenyup

commit 69e6e07a314aa4b2b3c334163dbfb494f369ec54
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-04-05 20:08:23 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-04-05 20:08:23 +0900

    Update REXML to 3.2.5

commit 3b97a6496f35efbc6aef9aef2bd1fe87e6b5d158
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-04-01 01:17:45 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-04-05 20:06:22 +0900

    Make usable chars more strict

    Remove other than alphanumeric and some punctuations considered
    filesystem-safe, instead of removing some unsafe chars only.

    https://hackerone.com/reports/1131465

commit cafa7904e7233d1a4b8ae7e738f6bd35ed67d642
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-04-03 18:26:46 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2021-04-03 18:26:46 +0900

    Backport lib/reline, and lib/irb for 3.0.1 4th (https://github.com/ruby/reline/pull/4349)

    * [ruby/irb] Update help message for next context-mode of 4

    While here, fixing tab/space issues in help message, and sync
    rdoc for IRB class to match the help message.

    https://github.com/ruby/irb/commit/ef8e3901cc

    * [ruby/irb] Do not continue line if last expression is an endless range

    Fixes [Bug #14824]

    https://github.com/ruby/irb/commit/63414f8465

    * [ruby/irb] Add a test for not continuing when endless range at eol

    https://github.com/ruby/irb/commit/1020ac9c65

    * [ruby/irb] Make save-history extension safe for concurrent use

    This makes the save-history extension check for modifications to
    the history file before saving it.  If the history file was modified
    after the history was loaded and before it was saved, append only
    the new history lines to the history file.

    This can result in more lines in the history file than SAVE_HISTORY
    allows.  However, that will be fixed the next time irb is run and
    the history is saved.

    Fixes [Bug #13654]

    https://github.com/ruby/irb/commit/041ef53845

    * Fix errors when XDG_CONFIG_HOME points to non-writable directory

    `$HOME/.config` is not writable on CI
    because I think tests should not corrupt user's data.

    And GitHub Actions CI sets `XDG_CONFIG_HOME`
    since `Version: 20210309.1`.

    https://github.com/ruby/actions/runs/2130811016?check_suite_focus=true#step:16:301
    ```
    Errno::EACCES: Permission denied @ dir_s_mkdir - /home/runner/.config/irb
    ```

    * Try to fix errors in TestIRB::TestHistory too

    https://github.com/ruby/actions/runs/2137935523?check_suite_focus=true#step:9:562
    ```
      1) Error:
    TestIRB::TestHistory#test_history_concurrent_use:
    Errno::EACCES: Permission denied @ dir_s_mkdir - /home/runner/.config/irb
        /home/runner/work/actions/actions/ruby/lib/fileutils.rb:253:in `mkdir'
        /home/runner/work/actions/actions/ruby/lib/fileutils.rb:253:in `fu_mkdir'
        /home/runner/work/actions/actions/ruby/lib/fileutils.rb:231:in `block (2 levels) in mkdir_p'
        /home/runner/work/actions/actions/ruby/lib/fileutils.rb:229:in `reverse_each'
        /home/runner/work/actions/actions/ruby/lib/fileutils.rb:229:in `block in mkdir_p'
        /home/runner/work/actions/actions/ruby/lib/fileutils.rb:211:in `each'
        /home/runner/work/actions/actions/ruby/lib/fileutils.rb:211:in `mkdir_p'
        /home/runner/work/actions/actions/ruby/lib/irb/init.rb:355:in `rc_file_generators'
        /home/runner/work/actions/actions/ruby/lib/irb/init.rb:330:in `rc_file'
        /home/runner/work/actions/actions/ruby/test/irb/test_history.rb:170:in `block in assert_history'
        /home/runner/work/actions/actions/ruby/lib/tmpdir.rb:96:in `mktmpdir'
        /home/runner/work/actions/actions/ruby/test/irb/test_history.rb:168:in `assert_history'
        /home/runner/work/actions/actions/ruby/test/irb/test_history.rb:133:in `test_history_concurrent_use'
    ```

    * [ruby/irb] Define "measure" command without forced override

    https://github.com/ruby/irb/commit/9587ba13b5

    * [ruby/irb] Add all lib files automatically

    https://github.com/ruby/irb/commit/ecc82336b7

    * [ruby/irb] Don't call Ruby 2.4+'s String#pretty_print

    https://github.com/ruby/irb/commit/89bcf107be

    * [ruby/irb] Implement ls command

    https://github.com/ruby/irb/commit/19b6c20604

    * [ruby/irb] Add whereami command

    https://github.com/ruby/irb/commit/bc822e4aac

    * [ruby/irb] Fix column overflow on ls output

    https://github.com/ruby/irb/commit/6115754623

    * [ruby/irb] Fix step's argument

    cols.size was calling Integer#size, which returns 8.

    Fixing a bug of https://github.com/ruby/irb/pull/209

    https://github.com/ruby/irb/commit/c93ae4be71

    * [ruby/irb] Deal with different screen sizes

    e.g. http://rubyci.s3.amazonaws.com/centos8/ruby-master/log/20210321T063003Z.fail.html.gz

    https://github.com/ruby/irb/commit/ddb3472ba2

    * [ruby/irb] Have some right padding

    instead of filling out an entire line

    https://github.com/ruby/irb/commit/6ac8f45f5f

    * Suppress verbose messages

    Get rid of warnings in the parallel test.

    ```
    unknown command: "Switch to inspect mode."
    ```

    * [ruby/irb] Change ripper_lex_without_warning to a class method

    https://github.com/ruby/irb/commit/d9f8abc17e

    * [ruby/irb] Complete require and require_relative

    https://github.com/ruby/irb/commit/1c61178b4c

    * [ruby/reline] Add Reline.ungetc to control buffer

    https://github.com/ruby/reline/commit/43ac03c624

    * [ruby/reline] Reline.delete_text removes the current line in multiline

    https://github.com/ruby/reline/commit/da90c094a1

    * [ruby/reline] Support preposing and postposing for Reline.completion_proc

    https://github.com/ruby/reline/commit/1f469de90c

    * [ruby/reline] Suppress crashing when completer_{quote,word_break}_characters is empty

    https://github.com/ruby/reline/commit/c6f1164942

    * [ruby/irb] fix completion test when out-of-place build

    * [ruby/irb] Cache completion files to require

    https://github.com/ruby/irb/commit/612ebcb311

    * [ruby/irb] Always add input method when calling Irb.new in tests

    When passes input method as nil to Context.new through Irb.new,
    ReidlineInputMethod.new is executed and the global internal state of Reline is
    rewritten, therefore other tests are failed in the Ruby repository. This
    commit changes to use TestInputMethod.

    https://github.com/ruby/irb/commit/010dce9210

    * [ruby/irb] Prevent the completion from crashing if rdoc is missing

    There are cases where ruby is installed without rdoc and e.g.
    lib/irb/cmd/help.rb also handles the LoadError

    Here is how to replicate the issue:

    ```
    $ docker run -it alpine:3.13.3 sh

    / # apk add ruby ruby-irb ruby-io-console

    / # irb

    irb(main):001:0> Class[TAB][TAB]
    ```

    And you end up with something like:

    ```
    irb(main):001:0> ClassTraceback (most recent call last):
            34: from /usr/bin/irb:23:in `<main>'
            33: from /usr/bin/irb:23:in `load'
            32: from /usr/lib/ruby/gems/2.7.0/gems/irb-1.2.6/exe/irb:11:in `<top (required)>'
            31: from /usr/lib/ruby/2.7.0/irb.rb:400:in `start'
            30: from /usr/lib/ruby/2.7.0/irb.rb:471:in `run'
            29: from /usr/lib/ruby/2.7.0/irb.rb:471:in `catch'
            28: from /usr/lib/ruby/2.7.0/irb.rb:472:in `block in run'
            27: from /usr/lib/ruby/2.7.0/irb.rb:537:in `eval_input'
            26: from /usr/lib/ruby/2.7.0/irb/ruby-lex.rb:150:in `each_top_level_statement'
            25: from /usr/lib/ruby/2.7.0/irb/ruby-lex.rb:150:in `catch'
            24: from /usr/lib/ruby/2.7.0/irb/ruby-lex.rb:151:in `block in each_top_level_statement'
            23: from /usr/lib/ruby/2.7.0/irb/ruby-lex.rb:151:in `loop'
            22: from /usr/lib/ruby/2.7.0/irb/ruby-lex.rb:154:in `block (2 levels) in each_top_level_statement'
            21: from /usr/lib/ruby/2.7.0/irb/ruby-lex.rb:182:in `lex'
            20: from /usr/lib/ruby/2.7.0/irb.rb:518:in `block in eval_input'
            19: from /usr/lib/ruby/2.7.0/irb.rb:704:in `signal_status'
            18: from /usr/lib/ruby/2.7.0/irb.rb:519:in `block (2 levels) in eval_input'
            17: from /usr/lib/ruby/2.7.0/irb/input-method.rb:294:in `gets'
            16: from /usr/lib/ruby/2.7.0/forwardable.rb:235:in `readmultiline'
            15: from /usr/lib/ruby/2.7.0/forwardable.rb:235:in `readmultiline'
            14: from /usr/lib/ruby/2.7.0/reline.rb:175:in `readmultiline'
            13: from /usr/lib/ruby/2.7.0/reline.rb:238:in `inner_readline'
            12: from /usr/lib/ruby/2.7.0/reline.rb:238:in `loop'
            11: from /usr/lib/ruby/2.7.0/reline.rb:239:in `block in inner_readline'
            10: from /usr/lib/ruby/2.7.0/reline.rb:270:in `read_io'
             9: from /usr/lib/ruby/2.7.0/reline.rb:270:in `loop'
             8: from /usr/lib/ruby/2.7.0/reline.rb:311:in `block in read_io'
             7: from /usr/lib/ruby/2.7.0/reline.rb:240:in `block (2 levels) in inner_readline'
             6: from /usr/lib/ruby/2.7.0/reline.rb:240:in `each'
             5: from /usr/lib/ruby/2.7.0/reline.rb:241:in `block (3 levels) in inner_readline'
             4: from /usr/lib/ruby/2.7.0/reline/line_editor.rb:820:in `input_key'
             3: from /usr/lib/ruby/2.7.0/reline/line_editor.rb:608:in `complete'
             2: from /usr/lib/ruby/2.7.0/irb/completion.rb:269:in `block in <module:InputCompletor>'
             1: from /usr/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92:in `require'
    /usr/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92:in `require': cannot load such file -- rdoc (LoadError)
    ```

    https://github.com/ruby/irb/commit/a2d299c2ac

    * [ruby/irb] Suppress verbose messages in the parallel test

    `:VERBOSE` flag needs to be set prior to `IRB::Irb.new`.

    https://github.com/ruby/irb/commit/78604682d9

    * [ruby/irb] SIGINT should raise Interrupt after IRB session

    https://github.com/ruby/irb/commit/5832cfe75b

    * [ruby/irb] Colorize `__END__` as keyword

    https://github.com/ruby/irb/commit/9b84018311

    * [ruby/irb] Add show_source command

    https://github.com/ruby/irb/commit/108cb04352

    * [ruby/reline] Reset @rest_height when clear screen

    https://github.com/ruby/reline/commit/3a7019b0d5

    * [ruby/irb] process multi-line pastes as a single entity

    this allows pasting leading-dot chained methods correctly:

    ```ruby
    class A
      def a; self; end
      def b; true; end
    end

    a = A.new

    a
     .a
     .b
    ```

    will properly return `true` instead of erroring on the `.a` line:

    ```
    irb(main):001:1*     class A
    irb(main):002:1*       def a; self; end
    irb(main):003:0>     end
    irb(main):004:0*
    irb(main):005:0>     a = A.new
    irb(main):006:0*
    irb(main):007:0>     a
    irb(main):008:0>      .a
    irb(main):009:0>      .a
    => #<A:0x00007f984211fbe8>
    ```

    https://github.com/ruby/irb/commit/45aeb52575

    * [ruby/irb] Add yamatanooroti test example

    https://github.com/ruby/irb/commit/279155fcee

    * [ruby/irb] Add test for multiline paste

    https://github.com/ruby/irb/commit/e93c9cb54d

    * [ruby/irb] Evaluate each toplevel statement

    https://github.com/ruby/irb/commit/bc1b1d8bc3

    * [ruby/irb] Version 1.3.5

    https://github.com/ruby/irb/commit/22e2ddf715

    * [ruby/reline] Version 0.2.5

    https://github.com/ruby/reline/commit/22ce5651e5

    Co-authored-by: Jeremy Evans <code@jeremyevans.net>
    Co-authored-by: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
    Co-authored-by: Takashi Kokubun <takashikkbn@gmail.com>
    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
    Co-authored-by: Aleksandar Ivanov <aivanov92@gmail.com>
    Co-authored-by: Koichi Sasada <ko1@atdot.net>
    Co-authored-by: Cody Cutrer <cody@instructure.com>

commit 6abb8ee711a941b7ad31d21fdb429750f7ea4463
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-04-02 16:09:09 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-04-02 16:09:09 +0900

    merge revision(s) 0a544c0c35f7445d69402d7c53d825384c728017: [Backport #17754]

            Fix segmentation fault when `Module#name` returns non string value
             [Bug #17754]

            * Add test for NoMethodError#to_s does not segfault

            * Ensure no segfault even if Module#name is overridden
            ---
             error.c                          |  4 +++-
             test/ruby/test_nomethod_error.rb | 16 ++++++++++++++++
             2 files changed, 19 insertions(+), 1 deletion(-)

commit 0315e1e5ca0722f9dffeae70b860c19de303e339
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-04-02 16:08:30 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-04-02 16:08:30 +0900

    merge revision(s) f9f13a4f6d8be706b17efc089c28f7bc617ef549: [Backport #17746]

            Ensure that caller respects the start argument

            Previously, if there were ignored frames (iseq without pc), we could
            go beyond the requested start frame.  This has two changes:

            1) Ensure that we don't look beyond the start frame by using
            last_cfp = RUBY_VM_PREVIOUS_CONTROL_FRAME(last_cfp) until the
            desired start frame is reached.

            2) To fix the failures caused by change 1), which occur when a
            limited number of frames is requested, scan the VM stack before
            allocating backtrace frames, looking for ignored frames. This
            is complicated if there are ignored frames before and after
            the start, in which case we need to scan until the start frame,
            and then scan backwards, decrementing the start value until we
            get to the point where start will result in the number of
            requested frames.

            This fixes a Rails test failure.  Jean Boussier was able to
            to produce a failing test case outside of Rails.

            Co-authored-by: Jean Boussier <jean.boussier@gmail.com>
            ---
             test/ruby/test_backtrace.rb | 16 ++++++++++++++
             vm_backtrace.c              | 52 +++++++++++++++++++++++++++++++++++++++++++--
             2 files changed, 66 insertions(+), 2 deletions(-)

commit 4e2738f477b5343a0d48a400c975220fed123c9b
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-04-02 16:06:31 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-04-02 16:06:31 +0900

    merge revision(s) 7e8a9af9db42a21f6a1125a29e98c45ff9d5833b: [Backport #17732]

            rb_enc_interned_str: handle autoloaded encodings

            If called with an autoloaded encoding that was not yet
            initialized, `rb_enc_interned_str` would crash with
            a NULL pointer exception.

            See: https://github.com/ruby/ruby/pull/4119#issuecomment-800189841
            ---
             encoding.c                        | 28 ++++++++++++----------------
             ext/-test-/string/depend          |  3 +++
             ext/-test-/string/fstring.c       | 15 +++++++++++++++
             internal/encoding.h               |  3 +++
             string.c                          |  4 ++++
             test/-ext-/string/test_fstring.rb | 16 ++++++++++++++++
             6 files changed, 53 insertions(+), 16 deletions(-)

commit 855401da495117fcf5d258fe43b71010abc43d9a
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-04-02 12:31:08 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-04-02 12:31:08 +0900

    merge revision(s) a85ed626f18d1014d09fb37eb0a703976c3d2b53: [Backport #17731]

            Fix Enumerable#inject with high negative fixnums [Bug #17731]

            ---
             enum.c                 | 2 +-
             test/ruby/test_enum.rb | 2 ++
             2 files changed, 3 insertions(+), 1 deletion(-)

commit 1a47de64f44da6d4339ba8b2c5220eeaba82954c
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-04-02 12:27:26 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-04-02 12:27:26 +0900

    merge revision(s) f748b911c9157a0bb86f38280ddfba72a55049b6: [Backport #17729]

            Fix infinite loop at illegal sequence [Bug #17729]

            As mblen returns -1 on failure, skip the first byte and try the
            succeeding bytes in that case.

            Close https://github.com/ruby/ruby/pull/4281
            ---
             eval_intern.h                 | 11 ++++++++++-
             test/ruby/test_rubyoptions.rb |  5 +++++
             2 files changed, 15 insertions(+), 1 deletion(-)

commit d1cec0bca588266b9af1d55e592016c45ee68fbb
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-04-02 12:26:56 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-04-02 12:26:56 +0900

    merge revision(s) 58660e943488778563b9e41005a601e9660ce21f: [Backport #17519]

            Skip refined method when exporting methods with changed visibility

            Previously, attempting to change the visibility of a method in a
            singleton class for a class/module that is prepended to and refined
            would raise a NoMethodError.

            Fixes [Bug #17519]
            ---
             test/ruby/test_module.rb | 23 +++++++++++++++++++++++
             vm_method.c              | 14 +++++++++++---
             2 files changed, 34 insertions(+), 3 deletions(-)

commit 2efda212b0d9ad5ec265271db25ad51d796fde44
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-03-24 04:52:19 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2021-03-24 04:52:19 +0900

    Merge RubyGems-3.2.15 and Bundler-2.2.15 (#4311)

commit ff2ea4daeb795ebb3d0afa8c57d86a4af9757e50
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-14 21:30:23 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-14 21:30:23 +0900

    merge revision(s) 2a6bfd22468343003463e0cbf91953a01b0dbba5,3ac28de5414c81a0da8c8ec969ea74db5a0f1b0f: [Backport #17645]

            Properly convert time_t [Bug #17645]

            ---
             thread_sync.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            Explicitly cast __s64 to time_t [Bug #17645]

            A workaround of shorten-64-to-32 error where 32-bit linux.
            ---
             file.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit e050dd53230cb354e816415f8a937901f79ec395
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-13 17:56:17 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-13 17:56:17 +0900

    merge revision(s) f6d5de8f33fe715d939e3e77b8ef73d88bcd6c9f: [Backport #17659]

            [ruby/io-wait] Declare as Ractor-safe

            Fixes https://bugs.ruby-lang.org/issues/17659

            https://github.com/ruby/io-wait/commit/ba338b4764
            ---
             ext/io/wait/wait.c          |  4 ++++
             test/io/wait/test_ractor.rb | 22 ++++++++++++++++++++++
             2 files changed, 26 insertions(+)
             create mode 100644 test/io/wait/test_ractor.rb

commit b20e2c3f2a3ce227b9cf32d2bf02db0ac67eccb5
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2021-03-13 17:55:49 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2021-03-13 17:55:49 +0900

    Backport io-console 0.5.7 to Ruby 3.0 (https://github.com/ruby/io-console/pull/4252)

    * [ruby/io-console] [DOC] Note that IO#getpass returns a chomped string

    IO#getpass uses String#chomp! on the read input line.

    https://github.com/ruby/io-console/commit/1e98c93bc8

    * [ruby/io-console] Ignore chomp! result and return the modified string

    https://github.com/ruby/io-console/commit/09e5ccc729

    * [ruby/io-console] Pre-define chomp! ID

    https://github.com/ruby/io-console/commit/028e1c9497

    * [ruby/io-console] Shrink struct query_args

    https://github.com/ruby/io-console/commit/720be0a3e5

    * [ruby/io-console] bump up to 0.5.7

    https://github.com/ruby/io-console/commit/f55d7ebff6

    Co-authored-by: Marcus Stollsteimer <sto.mar@web.de>
    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

commit 6f9e007729d53fdbc22e37e52129ea5aa2556d0e
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-13 05:12:54 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-13 05:12:54 +0900

    merge revision(s) b3c53a8a885be8f5cc2b712798b0d2741c488ce4: [Backport #17672]

            Make Ractor stdio belonging to the Ractor [Bug #17672]

            Defer making ractor stdio until ractor started.
            Before ractor started, created objects belong to the caller ractor
            instead of the created ractor.
            ---
             bootstraptest/test_ractor.rb | 12 ++++++++++++
             ractor.c                     |  9 ---------
             thread.c                     |  9 +++++++++
             3 files changed, 21 insertions(+), 9 deletions(-)

commit 6bf32cbed8f3fd0b73b99737d671f833c594d800
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-13 05:11:30 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-13 05:11:30 +0900

    merge revision(s) 63abb5c227e5c20d18d0debf699251da93ca64b5,34d02631e71209b12abb69d0114601027e485bc9,2adbf01ae14c0a4cf190b7c969b91726966a0e0f,3acc81d9e41b18380b9e0168fe2b5e5e0c727256: [Backport #17612]

            dtoa.c: make compilable independently

            Except for `-Dxmalloc=malloc -Dxfree=free`.
            ---
             missing/dtoa.c | 24 ++++++++++++++++++------
             1 file changed, 18 insertions(+), 6 deletions(-)

            dtoa.c: constified

            clang seems to locate never modified local data in the const
            segment implicitly.
            ---
             missing/dtoa.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            dtoa.c: make thread-safe by using atomic CAS

            ---
             common.mk      |  2 ++
             missing/dtoa.c | 75 ++++++++++++++++++++++++++++++++++++++++++----------------
             util.c         |  1 +
             3 files changed, 57 insertions(+), 21 deletions(-)

            Fixed race in dtoa [Bug #17612]

            Fixed the race condition when replacing `freelist` entry with its
            chained next element.  At acquiring an entry, hold the entry once
            with the special value, then release by replacing it with the next
            element again after acquired.  If another thread is holding the
            same entry at that time, spinning until the entry gets released.

            Co-Authored-By: Koichi Sasada <ko1@atdot.net>
            ---
             bootstraptest/test_ractor.rb | 11 +++++++++++
             missing/dtoa.c               | 13 ++++++++++---
             2 files changed, 21 insertions(+), 3 deletions(-)

commit 72c6497453f74f3398130d99fc610922f3995ae5
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-12 00:32:56 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-12 00:32:56 +0900

    merge revision(s) 7b9476fbfab738d1eb01b4b4c4af9a1680513019: [Backport #17642]

            Ractor.allocate should not be allowed

            Ractor.allocate and Ractor#dup should not be allowed like Thread.
            [Bug #17642]
            ---
             bootstraptest/test_ractor.rb | 18 ++++++++++++++++++
             ractor.c                     |  2 ++
             2 files changed, 20 insertions(+)

commit 6305d1c6edeec2c3aa25b9220142274f1ef2e868
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2021-01-06 13:06:25 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-11 20:36:52 +0900

    remove invalidated cc

    if cc is invalidated, cc should be released from iseq.

commit d3863cb2e80f27d26b521b2c957b21feacb900de
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-11 20:34:40 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-11 20:34:40 +0900

    merge revision(s) 07ab172ebef28bb82c2650694548d123802d6c22: [Backport #17636]

            sync check_rvalue_consistency_force()

            check_rvalue_consistency_force() uses is_pointer_to_heap() and
            it should be synchronized with other ractors.
            [Bug #17636]
            ---
             gc.c | 149 ++++++++++++++++++++++++++++++++++---------------------------------
             1 file changed, 76 insertions(+), 73 deletions(-)

commit de6072a22edbaab3793cf7f976cc9e0118d0df40
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-11 20:24:48 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-11 20:24:48 +0900

    merge revision(s) abdc634f64a440afcdc7f23c9757d27aab4db8a9,083c5f08ec4e95c9b75810d46f933928327a5ab3,1ecda213668644d656eb0d60654737482447dd92,813fe4c256f89babebb8ab53821ae5eb6bb138c6: [Backport #17497]

            remove unused decl

            ---
             internal/vm.h | 6 ------
             vm_args.c     | 2 --
             2 files changed, 8 deletions(-)

            Check stack overflow in recursive glob_helper [Bug #17162]

            ---
             dir.c         |  2 ++
             internal/vm.h |  1 +
             vm_eval.c     | 10 ++++++++++
             3 files changed, 13 insertions(+)

            global call-cache cache table for rb_funcall*

            rb_funcall* (rb_funcall(), rb_funcallv(), ...) functions invokes
            Ruby's method with given receiver. Ruby 2.7 introduced inline method
            cache with static memory area. However, Ruby 3.0 reimplemented the
            method cache data structures and the inline cache was removed.

            Without inline cache, rb_funcall* searched methods everytime.
            Most of cases per-Class Method Cache (pCMC) will be helped but
            pCMC requires VM-wide locking and it hurts performance on
            multi-Ractor execution, especially all Ractors calls methods
            with rb_funcall*.

            This patch introduced Global Call-Cache Cache Table (gccct) for
            rb_funcall*. Call-Cache was introduced from Ruby 3.0 to manage
            method cache entry atomically and gccct enables method-caching
            without VM-wide locking. This table solves the performance issue
            on multi-ractor execution.
            [Bug #17497]

            Ruby-level method invocation does not use gccct because it has
            inline-method-cache and the table size is limited. Basically
            rb_funcall* is not used frequently, so 1023 entries can be enough.
            We will revisit the table size if it is not enough.
            ---
             debug_counter.h |   3 +
             vm.c            |  12 +++
             vm_callinfo.h   |  12 ---
             vm_core.h       |   5 +
             vm_eval.c       | 288 ++++++++++++++++++++++++++++++++++++++++++--------------
             vm_insnhelper.c |  11 ++-
             vm_method.c     |  14 ++-
             7 files changed, 255 insertions(+), 90 deletions(-)

            opt_equality_by_mid for rb_equal_opt

            This patch improves the performance of sequential and parallel
            execution of rb_equal() (and rb_eql()).
            [Bug #17497]

            rb_equal_opt (and rb_eql_opt) does not have own cd and it waste
            a time to initialize cd. This patch introduces opt_equality_by_mid()
            to check equality without cd.

            Furthermore, current master uses "static" cd on rb_equal_opt
            (and rb_eql_opt) and it hurts CPU caches on multi-thread execution.
            Now they are gone so there are no bottleneck on parallel execution.
            ---
             vm_insnhelper.c | 99 ++++++++++++++++++++++++++++++++++++---------------------
             1 file changed, 63 insertions(+), 36 deletions(-)

commit 0074ea2d83230e10ab0cd769fff203c13d3c592f
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-11 20:06:14 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-11 20:06:14 +0900

    merge revision(s) 2a83650b0fd25719fb6c03bfec7bd895734d3ceb: [Backport #15852]

            Destroy VM-wise locks before freeing [Bug #15852]

            ---
             thread.c | 7 -------
             vm.c     | 2 ++
             2 files changed, 2 insertions(+), 7 deletions(-)

commit 04ef602c28aa175d7e03e802aa7db750632251cf
  Author:     Aditya Prakash <aditya.prakash132@gmail.com>
  AuthorDate: 2021-03-06 12:11:50 +0900
  Commit:     NARUSE, Yui <nurse@users.noreply.github.com>
  CommitDate: 2021-03-11 17:24:52 +0900

    [rubygems/rubygems] Remote test to check require

    This test was triggering require of `rubygems/core_ext/tcpsocket_init`
    which overrides TCPSocket.initialize globally. Requires don't get
    reset between test runs and it was making other test unreliable.

    Fixes timeout of test on ruby master

    https://github.com/rubygems/rubygems/commit/fdfe5c9691

commit 0476ce0370c1ee56de690d43c15d5e8d7893dedd
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-03-10 12:08:20 +0900
  Commit:     NARUSE, Yui <nurse@users.noreply.github.com>
  CommitDate: 2021-03-11 17:24:52 +0900

    Merge RubyGems-3.2.14 and Bundler-2.2.14

commit 7efc7afcae6720e1af7ab49986d789b6f9d6fe0a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-03-08 12:17:52 +0900
  Commit:     NARUSE, Yui <nurse@users.noreply.github.com>
  CommitDate: 2021-03-11 17:24:52 +0900

    Merge RubyGems-3.2.13 and Bundler-2.2.13

commit 06cd5711e0afc6302052e847863a7fdcc42fe692
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-03-02 20:38:16 +0900
  Commit:     NARUSE, Yui <nurse@users.noreply.github.com>
  CommitDate: 2021-03-11 17:24:52 +0900

    Merge RubyGems-3.2.12 and Bundler-2.2.12

commit f375bc77d2f347dd2a44705b8abd29398feae427
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-03-02 20:37:31 +0900
  Commit:     NARUSE, Yui <nurse@users.noreply.github.com>
  CommitDate: 2021-03-11 17:24:52 +0900

    Merge RubyGems-3.2.11 and Bundler-2.2.11

commit 38f8b8d070aaac02f1d048b5d9947b2e58401e2b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-03-02 20:36:40 +0900
  Commit:     NARUSE, Yui <nurse@users.noreply.github.com>
  CommitDate: 2021-03-11 17:24:52 +0900

    Merge RubyGems-3.2.10 and Bundler-2.2.10

commit 70e9489f9ea85ddaa68fb43398c14a3921cacb27
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-03 17:35:47 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-03 19:40:48 +0900

    merge revision(s) 0d89aedb734372bc35d8a569a992d13e86e7923e,a6f5f3cccda381ae332aaa6467f2644611371fb5,97cf290063ab940d08819cd96cbcca0ef6d50e4c: [Backport #17338]

            Assign TAG_NONE to ruby_tag_type instead of 0

            ---
             eval.c | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

            Also `eclass` loop can raise in `rb_obj_is_kind_of`

            ---
             eval.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            Copy va_list of exception classes

            The list is reused when an exception raised again after retrying
            in the rescue procedure.
            ---
             eval.c | 6 +++++-
             1 file changed, 5 insertions(+), 1 deletion(-)

commit b49264ab7aa92f64a806857d7e81b3f1cbba5585
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-02 22:00:45 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-02 22:00:45 +0900

    merge revision(s) 969b824a0c7605e0e570631d967ad0de0c37d0bf,100e464bee46ae71ef048ed85a9bdd012935a3f7: [Backport #17599]

            sync GC rest if needed

            marking requires a barrier (stop all Ractors) and gc_enter() does it.
            However, it doesn't check rest event which can start marking.
            [Bug #17599]
            ---
             gc.c | 3 +++
             1 file changed, 3 insertions(+)

            clear RVALUE on NEWOBJ event.

            NEWOBJ event is called without clearing RVALUE values (v1, v2, v3).
            This patch clear them before NEWOBJ tracepoint internal hook.
            [Bug #17599]
            ---
             gc.c | 27 +++++++++++++++------------
             1 file changed, 15 insertions(+), 12 deletions(-)

commit 4328f93f1bf08296115172a279e2d85a0ed80122
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-02 21:50:15 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-02 21:50:15 +0900

    merge revision(s) 87437326214e4587a41946c8937e11418d983acd: [Backport #17581]

            Fix backtrace to not skip frames with iseq without pc

            Previously, frames with iseq but no pc were skipped (even before
            the refactoring in 3b24b7914c16930bfadc89d6aff6326a51c54295).
            Because the entire backtrace was procesed before the refactoring,
            this was handled by using later frames instead.  However, after
            the refactoring, we need to handle those frames or they get
            lost.

            Keep two iteration counters when iterating, one for the desired
            backtrace size (so we generate the desired number of frames), and
            one for the actual backtrace size (so we don't process off the end
            of the stack).  When skipping over an iseq frame with no pc,
            decrement the counter for the desired backtrace, so it will
            continue to process the expected number of backtrace frames.

            Fixes [Bug #17581]
            ---
             test/ruby/test_backtrace.rb | 12 ++++++++++++
             vm_backtrace.c              | 16 +++++++++-------
             2 files changed, 21 insertions(+), 7 deletions(-)

commit 3e67bfe202d6b410375af990ac806f15cb2df762
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-02 18:29:05 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-02 18:29:05 +0900

    merge revision(s) b94b7965c420661ed621c146a4efaf43bc3cf50b: [Backport #17639]

            Fixed fallback ENABLE_VIRTUAL_TERMINAL_PROCESSING value [Bug #17639]

            ---
             ruby.c        | 2 +-
             win32/win32.c | 4 ++--
             2 files changed, 3 insertions(+), 3 deletions(-)

commit a6dec2e144d65011d49f272e494bf62daf3d7531
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-02 18:28:30 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-02 18:28:30 +0900

    merge revision(s) 5de38c41ae7bf17ae599fdfa9f8face87f16d8bb: [Backport #17644]

            ripper: fix a bug of Ripper::Lexer with syntax error and heredoc [Bug
             #17644]

            ---
             ext/ripper/lib/ripper/lexer.rb |  2 +-
             test/ripper/test_lexer.rb      | 12 ++++++++++++
             2 files changed, 13 insertions(+), 1 deletion(-)

commit 713d6d5eb05de06a0de25feef801ff8c72c65754
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-02 18:27:43 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-02 18:27:43 +0900

    merge revision(s) 265c0022390e3dcd4ff692fc77d29b94e652c877: [Backport #17653]

            Do not allocate ractor-local storage in dfree function during GC

            ---
             random.c | 3 ++-
             1 file changed, 2 insertions(+), 1 deletion(-)

commit 5816725ccc9642101d447b0f3b03c14d232aec6a
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-03-02 17:39:31 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-03-02 17:39:31 +0900

    merge revision(s) 15dbaa0b54f10e43976d594ef987da5f51e0c7c1: [Backport #17622]

            [Fixes #17622] Mark and move the previous ep

            ---
             vm.c | 10 ++++++++++
             1 file changed, 10 insertions(+)

commit 46825a7462e3106599c034bd77dcd3646a181539
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-02-26 10:32:34 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2021-02-26 10:32:34 +0900

    Backport lib/reline, and lib/irb for 3.0.1 3rd (https://github.com/ruby/reline/pull/4228)

    * [ruby/irb] Suppress error when File::ALT_SEPARATOR is nil

    https://github.com/ruby/irb/commit/96accf3b95

    * [ruby/irb] Suppress colorize on Windows tests

    https://github.com/ruby/irb/commit/5be9354cf9

    * [ruby/irb] The command "irb_info" should show RUBY_PLATFORM

    https://github.com/ruby/irb/commit/39d1cd874f

    * [ruby/irb] Fix inverse separator condition

    https://github.com/ruby/irb/commit/33f933196f

    * [ruby/reline] Return 1 when char width not found

    This fixes ruby/reline#261.

    https://github.com/ruby/reline/commit/3cf1213014

    * [ruby/reline] Avoid tripping over nil prompt

    https://github.com/ruby/reline/commit/d4d9d3e3d4

    * [ruby/reline] Move script files for yamatanooroti tests

    https://github.com/ruby/reline/commit/03031b885d

    * [ruby/reline] Add a test for suppressing crash when dynamic prompt returns empty

    ref. https://github.com/ruby/reline/pull/262

    https://github.com/ruby/reline/commit/b98bc3c329

    * [ruby/reline] We still need support new and legacy behavior.
    Revert "Support for change in Windows-specific behavior at eol"

    This reverts commit cad4de6ee841b43f3f0e441626f9415c3eda0f82.

    https://github.com/ruby/reline/commit/646587fc2c

    * [ruby/reline] check ENABLE_VIRTUAL_TERMINAL_PROCESSING flag and switch eof processing

    https://github.com/ruby/reline/commit/3535676689

    * [ruby/reline] Use UTF-8 only for width calc, rest uses original encoding

    I confirmed that libvterm supports only which are UTF-8, US ASCII, UK, and
    DEC graphics by reading source code, so can't test this patch by
    yamatanoorogi gem through vterm gem for now.

    This fixes ruby/irb#190.

    https://github.com/ruby/reline/commit/44596c0cc7

    * [ruby/reline] fix Reline::Windows.getconsolemode buffer

    use double quotes to properly convert the \000 escape sequence.

    https://github.com/ruby/reline/commit/236dfe5683

    * [ruby/irb] Version 1.3.4

    https://github.com/ruby/irb/commit/ab9852ccc5

    * [ruby/reline] Version 0.2.4

    https://github.com/ruby/reline/commit/462f971bd3

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
    Co-authored-by: Eamonn Webster <eamonn.webster@gmail.com>
    Co-authored-by: Yoshinao Muramatu <ysno@ac.auone-net.jp>
    Co-authored-by: cremno <cremno@mail.ru>

commit 551f1236a43ad014522d120dea1f136052879c0a
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-16 13:16:54 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-16 13:16:54 +0900

    merge revision(s) a681c484a3c5b9235c84bc5c253b4406e498e8cf: [Backport #17626]

            Fixed codepage for utime [Bug #17626]

            Should use the given codepage argument.

            Co-Authored-By: Nobuyoshi Nakada <nobu@ruby-lang.org>
            ---
             test/ruby/test_file_exhaustive.rb | 7 +++++++
             win32/win32.c                     | 2 +-
             2 files changed, 8 insertions(+), 1 deletion(-)

commit 38f9c832e812f96fd06ca73688ff2baa528c119c
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-16 13:13:27 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-16 13:13:27 +0900

    merge revision(s) 49d3830f44031174ad450a0ea1cdcdf0eabf9d0e: [Backport #17560]

            Fix documentation for Module#ruby2_keywords

            It returns nil, not self.

            Fixes [Bug #17560]
            ---
             vm_method.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 09c681ab38df33468570534bef7609222e49c6f4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-02-09 22:53:57 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2021-02-09 22:53:57 +0900

    Merge RubyGems 3.2.9 and Bundler 2.2.9 (#4158)

commit 9aba46d8d80473594e567dff1652626e7b2a77b0
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-08 19:13:52 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-08 19:13:52 +0900

    merge revision(s) 6f727853cee41195b67ee5d793c1ac23fe1a6ae0,b2674c1fd725b43adf51af7935c780359d70c2a4: [Backport #17482]

            only main thread can modify vm->ubf_async_safe

            vm->ubf_async_safe is VM global resource and only main thread
            can manipulate it.
            [Bug #17482]
            ---
             thread.c | 8 +++++---
             1 file changed, 5 insertions(+), 3 deletions(-)

            unblock thread is only for main ractor.

            other ractors should not have a unblock thread.
            This patch fixes 6f727853cee41195b67ee5d793c1ac23fe1a6ae0.
            ---
             thread.c | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit 77700bf023a963af810bcc49184428a75cd23bb1
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2021-02-07 21:04:32 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2021-02-07 21:04:32 +0900

    Backport lib/reline, and lib/irb for 3.0.1 2nd (https://github.com/ruby/reline/pull/4157)

    * [ruby/irb] Stub a screen size for tests

    https://github.com/ruby/irb/commit/6663057083

    * [ruby/irb] Support GitHub Actions

    https://github.com/ruby/irb/commit/8e9e6c4037

    * [ruby/irb] Stub a screen size for test_context

    http://ci.rvm.jp/logfiles/brlog.trunk-random1.20210119-074232

    https://github.com/ruby/irb/commit/ea87592d4a

    * [ruby/irb] Use a real screen size for pp by default

    https://github.com/ruby/irb/commit/9b9300dec2

    * [ruby/irb] Rescue Errno::EINVAL on IRB pp

    http://rubyci.s3.amazonaws.com/solaris11-gcc/ruby-master/log/20210119T070008Z.log.html.gz
    is caused by:

    /export/home/chkbuild/chkbuild-gcc/tmp/build/20210119T150010Z/ruby/lib/reline/ansi.rb:157:in `winsize': Invalid argument - <STDIN> (Errno::EINVAL)
            from /export/home/chkbuild/chkbuild-gcc/tmp/build/20210119T150010Z/ruby/lib/reline/ansi.rb:157:in `get_screen_size'
            from /export/home/chkbuild/chkbuild-gcc/tmp/build/20210119T150010Z/ruby/lib/reline.rb:168:in `get_screen_size'
            from /export/home/chkbuild/chkbuild-gcc/tmp/build/20210119T150010Z/ruby/lib/forwardable.rb:238:in `get_screen_size'
            from /export/home/chkbuild/chkbuild-gcc/tmp/build/20210119T150010Z/ruby/lib/irb/color_printer.rb:7:in `pp'
            from -e:1:in `<main>'

    https://github.com/ruby/irb/commit/1719514598

    * [ruby/irb] Split test files for IRB::Color and IRB::ColorPrinter

    https://github.com/ruby/irb/commit/d95e8daab3

    * [ruby/irb] Undefine unused constants

    https://github.com/ruby/irb/commit/eea9c16804

    * [ruby/irb] Remove pp-specific stub from TestColor

    because it was for TestColorPrinter

    https://github.com/ruby/irb/commit/7569206fd4

    * [ruby/irb] Delete a doodle-level memo comment...

    https://github.com/ruby/irb/commit/fc3e1d9e0c

    * [ruby/irb] Indent correctly with keyword "for" and "in"

    https://github.com/ruby/irb/commit/47c83ea724

    * [ruby/irb] Indent correctly with method calling with receiver

    https://github.com/ruby/irb/commit/e7c68e74a0

    * [ruby/irb] add `IRB::FileInputMethod.open` to ensure closing associated File

    * tweak some methods not to raise exception after `#close`
    * use it in `IRB::IrbLoader#{source_file,load_file}

    https://github.com/ruby/irb/commit/ec2947acbd

    * [ruby/irb] use `RubyLex::TerminateLineInput` appropriately [Bug #17564]

    * using the appropriciate exception instead of `break` so that the session
      can be continue after the `irb_source` and `irb_load` commands
    * suppress extra new line due to one more `#prompt` call

    https://github.com/ruby/irb/commit/bdefaa7cfd

    * [ruby/irb] specify the `VERBOSE` to `false` and fix tests to fit

    https://github.com/ruby/irb/commit/502c590925

    * In test, need to pass a context to IRB::WorkSpace.new explicitly

    * Fix absolute path predicate on Windows

    A path starts with '/' is not an absolute path on Windows, because
    of drive letter or UNC.

    * [ruby/irb] follow up the actual line number

    https://github.com/ruby/irb/commit/7aed8fe3b1

    * [ruby/irb] Add info.rb to gemspec

    https://github.com/ruby/irb/commit/adbba19adf

    * [ruby/irb] Allow "measure" command to take block

    https://github.com/ruby/irb/commit/20f1ca23e9

    * [ruby/irb] Enable to reassign a new block with "measure" command

    https://github.com/ruby/irb/commit/b444573aa2

    * [ruby/reline] Cache pasting state in processing a key

    Because it's too slow.

    The rendering time in IRB has been reduced as follows:

      start = Time.now

      def each_top_level_statement
        initialize_input
        catch(:TERM_INPUT) do
          loop do
            begin
              prompt
              unless l = lex
                throw :TERM_INPUT if @line == ''
              else
                @line_no += l.count("\n")
                next if l == "\n"
                @line.concat l
                if @code_block_open or @ltype or @continue or @indent > 0
                  next
                end
              end
              if @line != "\n"
                @line.force_encoding(@io.encoding)
                yield @line, @exp_line_no
              end
              break if @io.eof?
              @line = ''
              @exp_line_no = @line_no

              @indent = 0
            rescue TerminateLineInput
              initialize_input
              prompt
            end
          end
        end
      end

      puts "Duration: #{Time.now - start} seconds"

    0.22sec -> 0.14sec

    https://github.com/ruby/reline/commit/b8b3dd52c0

    * [ruby/reline] Initialize uninitialized variables in tests

    https://github.com/ruby/reline/commit/25af4bb64b

    * [ruby/reline] Remove an unused variable

    https://github.com/ruby/reline/commit/123ea51166

    * [ruby/reline] Scroll down when ^C is pressed

    https://github.com/ruby/reline/commit/6877a7e3f5

    * [ruby/reline] Show all lines higher than the screen when finished

    On Unix-like OSes, logs prior to the screen are not editable. When the code
    is higher than the screen, the code is only shown on the screen until input
    is finished, but when it is finished, all lines are outputted.

    https://github.com/ruby/reline/commit/8cd9132a39

    * [ruby/reline] Handle past logs correctly when the code is higher than the screen

    https://github.com/ruby/reline/commit/f197139b4a

    * [ruby/reline] Update cursor info by inserting newline even if not in pasting

    https://github.com/ruby/reline/commit/92d314f514

    * [ruby/reline] Move cursor just after the last line when finished

    https://github.com/ruby/reline/commit/ba06e4c480

    * [ruby/reline] The vi_histedit supports multiline

    This closes ruby/reline#253.

    https://github.com/ruby/reline/commit/f131f86d71

    * [ruby/reline] Autowrap correctly when inserting chars in the middle of a line

    https://github.com/ruby/reline/commit/ebaf37255f

    * [ruby/reline] Terminate correctly in the middle of lines higher than the screen

    https://github.com/ruby/reline/commit/e1d9240ada

    * [ruby/irb] Version 1.3.3

    https://github.com/ruby/irb/commit/4c87035b7c

    * [ruby/reline] Version 0.2.3

    https://github.com/ruby/reline/commit/b26c7d60c8

    Co-authored-by: Takashi Kokubun <takashikkbn@gmail.com>
    Co-authored-by: Nobuhiro IMAI <nov@yo.rim.or.jp>
    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
    Co-authored-by: ima1zumi <mariimaizumi5@gmail.com>

commit 0c6361ff28528181e8436aff1f6e045759d8e32d
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-03 00:33:47 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-03 00:33:47 +0900

    merge revision(s) 0e5fbec81632968836da06dc50fca4948cae6d30: [Backport #17603]

            Fixed varargs in `rb_bug_without_die` [Bug #17603]

            ---
             error.c | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit 03c50eb0db82afc528f1eaf53b5fd55423449f04
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-03 00:30:28 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-03 00:30:59 +0900

    merge revision(s) 598b7988f4f332c2d974bde6bc8be299150e2dce,4a06cb31170789f6fc0b1ce069bccab9d731c8bf: [Backport #17604]

            Bundle RBS 1.0.4 (#4136)

            ---
             gems/bundled_gems | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            Update TypeProf to 0.12.0 (#4132)

            ---
             gems/bundled_gems | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 852c112a3f6fe4211c5818c2584a1514f46b7d0b
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-02 22:10:02 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-02 22:10:02 +0900

    merge revision(s) 739f929:

            NetBSD build update. (#4079)

            ---
             addr2line.c | 8 ++++++--
             1 file changed, 6 insertions(+), 2 deletions(-)

commit 6673b60f3d86e7431a2ae7b4af7249a01d20f71c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-02-02 20:23:57 +0900
  Commit:     NARUSE, Yui <nurse@users.noreply.github.com>
  CommitDate: 2021-02-02 21:30:08 +0900

    Merge RubyGems-3.1.7

commit cc51cfabfd0592dd49d4a8ad4bc78e0520128e72
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-02-02 20:23:14 +0900
  Commit:     NARUSE, Yui <nurse@users.noreply.github.com>
  CommitDate: 2021-02-02 21:30:08 +0900

    Merge Bundler-2.2.7

commit 71b4638ca29a5d8a7d6f72e453513035d2096f47
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-02 19:09:40 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-02 19:09:40 +0900

    merge revision(s) 1cdae49d39fbaef654df487f168d1fb14a146d59: [Backport #17577]

            Implement NameError::message#clone for Ractor

            ---
             bootstraptest/test_ractor.rb   | 13 +++++++++++++
             error.c                        | 35 +++++++++++++++++++++++++++++++++--
             test/objspace/test_objspace.rb |  9 +++++++++
             3 files changed, 55 insertions(+), 2 deletions(-)

commit e9843cdaee26387310384fa0a1d43d450b017350
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-02 18:06:56 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-02 18:06:56 +0900

    merge revision(s) b091889ed67f278b1652ddde88596e2160d5aef0: [Backport #17582]

            Removed YYUSE [Bug #17582]

            Although it was used just to suppress an "unsed argument" warning
            in the same manner as other bison-provided functions, it has been
            dropped since Bision 3.7.5.  And we always suppress that
            warnings.
            ---
             parse.y | 1 -
             1 file changed, 1 deletion(-)

commit 3cebc709539c9d0ac5bf0b7b280ec74c8029815f
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-02 17:50:36 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-02 17:50:36 +0900

    merge revision(s) 9241211538189a58b477bd55b539357617fd42ed: [Backport #17589]

            Forward keyword arguments for Pathname#each_line [Bug #17589]

            ---
             ext/pathname/pathname.c        |  4 ++--
             test/pathname/test_pathname.rb | 26 ++++++++++++++++++++++++++
             2 files changed, 28 insertions(+), 2 deletions(-)

commit 2dc39e2fd45aacd5fcd33ed80f602bd6f2ddb504
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-02 17:50:00 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-02 17:50:00 +0900

    merge revision(s) 1b89b99941548fdb65305dd9a412082e7fdba45a: [Backport #17534]

            Mark pattern labels as unremoveable

            Peephole optimization doesn't play well with find pattern at
            least. The only case when a pattern matching could have
            unreachable patterns is when we have lasgn/dasgn node, which
            shouldn't happen in real-life.

            Fixes https://bugs.ruby-lang.org/issues/17534
            ---
             compile.c                          |  2 +-
             test/ruby/test_pattern_matching.rb | 10 ++++++++++
             2 files changed, 11 insertions(+), 1 deletion(-)

commit fb6cb226a03c2eeaf4fe68b282fcd6e4a8696ffd
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-02 15:49:51 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-02 15:49:51 +0900

    merge revision(s) 8dfae85adb96cf3da84bf38f2103969d4a7aed3f: [Backport #17575]

            Warn the defined location as deprecation as well as the main message

            [Bug #17575]
            ---
             test/ruby/test_defined.rb | 17 +++++++++++++++++
             vm_method.c               |  3 ++-
             2 files changed, 19 insertions(+), 1 deletion(-)

commit d370cb62d26f212e431d4a7b38db56254c95cd5d
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-02 15:47:10 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-02 15:47:50 +0900

    merge revision(s) 9efd590a13d1e8b8a141c46eabb48c2a1c286d2b,a55eb9a2af7950d180d9d31ffde2bce66710f44f: [Backport #17572]

            Rationalize floats in coerce [Bug #17572]

            ---
             rational.c | 16 +++++++++++-----
             1 file changed, 11 insertions(+), 5 deletions(-)

            Make reciprocal properly of non-integral rational [Bug #17572]

            ---
             rational.c                 | 2 +-
             test/ruby/test_rational.rb | 7 +++++++
             2 files changed, 8 insertions(+), 1 deletion(-)

commit c09f5ee344ae5e6edb827b177bc6a5c2df37e805
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-02 00:15:19 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-02 15:47:50 +0900

    merge revision(s) 6ca3d1af3302f722aed530764d07c1cc83e95ecf: [Backport #17552]

            objspace_dump.c: Handle allocation path and line missing

            ---
             ext/objspace/objspace_dump.c | 13 +++++++++----
             1 file changed, 9 insertions(+), 4 deletions(-)

commit 7899046315321f78fa95ef92f313afa86f4d962b
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-02 00:14:24 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-02 15:47:50 +0900

    merge revision(s) eeacdcb9a073c7d8ad703e0dc9faf229a5ebbe3c: [Backport #17558]

            Fixed premature return

            After setting ruby2_keywords for bmethod, the rest of arguments
            had been ignored. [Bug #17558]
            ---
             test/ruby/test_keyword.rb | 9 +++++++++
             vm_method.c               | 2 +-
             2 files changed, 10 insertions(+), 1 deletion(-)

commit da1f1a4694da618849299987f550e40ec0b8284f
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-01 23:59:23 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-01 23:59:23 +0900

    merge revision(s) e033c9d7db0: [Backport #17549]

            Include missing AvailabilityMacros.h

            ---
             random.c | 4 ++++
             1 file changed, 4 insertions(+)

commit 17986daf6edd00313c2a2fe4d2dfccb4f1472977
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-01 23:07:02 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-01 23:07:02 +0900

    merge revision(s) b84b253a69537a14e4854e17b6d94ae75c2af050: [Backport #17547]

            Fix Ripper with heredoc.

            ---
             ext/ripper/lib/ripper/lexer.rb |  1 +
             test/ripper/test_lexer.rb      | 10 ++++++++++
             2 files changed, 11 insertions(+)

commit 138f0ba6da2a1ecf80729be3065310c5c0cfdb9a
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-01 23:06:33 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-01 23:06:33 +0900

    merge revision(s) 0ed71b37fa9af134fdd5a7fd1cebd171eba83541: [Backport #17536]

            Don't try to clear cache on garbage objects

            Method cache can be cleared during lazy sweeping.  An object that will
            be collected during lazy sweep *should not* have it's method cache
            cleared.  Soon-to-be-collected objects can be in an inconsistent state and
            this can lead to a crash.  This patch just leaves early if the object is
            going to be collected.

            Fixes [Bug #17536]

            Co-Authored-By: John Hawthorn <john@hawthorn.email>
            Co-Authored-By: Alan Wu <XrXr@users.noreply.github.com>
            ---
             vm_method.c | 1 +
             1 file changed, 1 insertion(+)

commit 74f90b46a9f21e8ef6e01bebad9dc00f420f8cec
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-01 21:42:11 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-01 21:42:11 +0900

    merge revision(s) efcdf68e6443ab70fbff1703b9dabbfc5090df31,5e26619660f20272a53c7f839dde36cce034bb35: [Backport #17539]

            Guard callinfo

            Callinfo was being written in to an array and the GC would not see the
            reference on the stack.  `new_insn_send` creates a new callinfo object,
            then it calls `new_insn_core`.  `new_insn_core` allocates a new INSN
            linked list item, which can end up calling `xmalloc` which will trigger
            a GC:

              https://github.com/ruby/ruby/blob/70cd351c7c71c48ee18d7c01e851a89614086f8f/compile.c#L968-L969

            Since the callinfo object isn't on the stack, the GC won't see it, and
            it can get collected.  This patch just refactors `new_insn_send` to keep
            the object on the stack

            Co-authored-by: John Hawthorn <john@hawthorn.email>
            ---
             compile.c            |  7 +++++--
             test/ruby/test_gc.rb | 10 ++++++++++
             2 files changed, 15 insertions(+), 2 deletions(-)

            Fix WB for callinfo

            The WB for callinfo needs to be executed *after* the reference is
            written.  Otherwise we get a WB miss.
            ---
             compile.c | 1 +
             1 file changed, 1 insertion(+)

commit d1fb0a39537d4536869921383ee2a223cc6dfac9
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-01 20:27:16 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-01 20:27:16 +0900

    merge revision(s) 952b2dcc8804cbf094f8f626e04bcb3f8e151005: [Backport #17602]

            Fix for windres 2.36 [Bug #17602]

            Add --preprocessor and --preprocessor-arg for each preprocessor
            command arguments, as windres 2.36 requires preprocessor name and
            arguments to be separated to respect spaces in these paths.
            ---
             cygwin/GNUmakefile.in | 5 ++++-
             1 file changed, 4 insertions(+), 1 deletion(-)

commit 42f02a0bac2c037b4e00a9811c5548c5ec7d28a7
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-01 19:21:03 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-01 19:21:03 +0900

    merge revision(s) 6bcc4664bdaebbf9b28a762ae63f476a1ec6cfb2,bb40c5cbe977de9f36a2a739e94e9b2fd4496b6e,c060bdc2b4ab8eeef5374f4174f5de48ab936d74: [Backport #17541]

            Return new NODE_LIT

            As NODE_ZLIST/NODE_LIST are not markable, cannot be reused as
            NODE_LIT.
            ---
             parse.y | 7 ++-----
             1 file changed, 2 insertions(+), 5 deletions(-)

            Ensure symbol list node is either NODE_STR or NODE_DSTR

            ---
             parse.y | 11 ++++++++---
             1 file changed, 8 insertions(+), 3 deletions(-)

            NODE markability should not change by nd_set_type

            ---
             node.c | 31 +++++++++++++++++++++++++------
             node.h | 12 ++++++++++++
             2 files changed, 37 insertions(+), 6 deletions(-)

commit 1b0622d7a9451dbeaadccc1f416b71a98271e097
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-01 19:20:20 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-01 19:20:20 +0900

    merge revision(s) 0036648a420f945624898568bb82bc5f83195d12: [Backport #17533]

            Capture to reserved name variables if already defined [Bug #17533]

            ---
             parse.y                  |  5 +++--
             test/ruby/test_regexp.rb | 11 +++++++++++
             2 files changed, 14 insertions(+), 2 deletions(-)

commit 9aa7b57ba4453fce871011c1d9587536d425700f
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2021-02-01 19:19:11 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2021-02-01 19:19:27 +0900

    merge revision(s) 6f6dfdcc685077f0f85dcdd63843ecfc0f6fbfb6: [Backport #17523]

            Make warning values consistent [Bug #17523]

            They should be affected, as well as `$VERBOSE`, by `-w`/`-W`
            options, not only in the main script but in scripts loaded by `-r`
            option too.
            ---
             ruby.c                        | 4 ++--
